/* Album.c generated by valac 0.28.1, the Vala compiler
 * generated from Album.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2013 Noise Developers (http://launchpad.net/noise)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Victor Eduardo <victoreduardm@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>


#define NOISE_TYPE_ALBUM (noise_album_get_type ())
#define NOISE_ALBUM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_ALBUM, NoiseAlbum))
#define NOISE_ALBUM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_ALBUM, NoiseAlbumClass))
#define NOISE_IS_ALBUM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_ALBUM))
#define NOISE_IS_ALBUM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_ALBUM))
#define NOISE_ALBUM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_ALBUM, NoiseAlbumClass))

typedef struct _NoiseAlbum NoiseAlbum;
typedef struct _NoiseAlbumClass NoiseAlbumClass;
typedef struct _NoiseAlbumPrivate NoiseAlbumPrivate;

#define NOISE_TYPE_MEDIA (noise_media_get_type ())
#define NOISE_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_MEDIA, NoiseMedia))
#define NOISE_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_MEDIA, NoiseMediaClass))
#define NOISE_IS_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_MEDIA))
#define NOISE_IS_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_MEDIA))
#define NOISE_MEDIA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_MEDIA, NoiseMediaClass))

typedef struct _NoiseMedia NoiseMedia;
typedef struct _NoiseMediaClass NoiseMediaClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _NoiseAlbum {
	GObject parent_instance;
	NoiseAlbumPrivate * priv;
};

struct _NoiseAlbumClass {
	GObjectClass parent_class;
};

struct _NoiseAlbumPrivate {
	gchar* _name;
	gchar* _artist;
	guint _n_discs;
	guint _year;
	GeeHashSet* media;
};


static gpointer noise_album_parent_class = NULL;

GType noise_album_get_type (void) G_GNUC_CONST;
GType noise_media_get_type (void) G_GNUC_CONST;
#define NOISE_ALBUM_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NOISE_TYPE_ALBUM, NoiseAlbumPrivate))
enum  {
	NOISE_ALBUM_DUMMY_PROPERTY,
	NOISE_ALBUM_NAME,
	NOISE_ALBUM_ARTIST,
	NOISE_ALBUM_N_DISCS,
	NOISE_ALBUM_YEAR,
	NOISE_ALBUM_N_MEDIA,
	NOISE_ALBUM_IS_EMPTY
};
NoiseAlbum* noise_album_new_from_media (NoiseMedia* m);
NoiseAlbum* noise_album_construct_from_media (GType object_type, NoiseMedia* m);
const gchar* noise_media_get_album (NoiseMedia* self);
void noise_album_set_name (NoiseAlbum* self, const gchar* value);
const gchar* noise_media_get_album_artist (NoiseMedia* self);
void noise_album_set_artist (NoiseAlbum* self, const gchar* value);
guint noise_media_get_year (NoiseMedia* self);
void noise_album_set_year (NoiseAlbum* self, guint value);
gboolean noise_string_is_empty (const gchar* text, gboolean check_white_space);
const gchar* noise_album_get_artist (NoiseAlbum* self);
const gchar* noise_media_get_artist (NoiseMedia* self);
gchar* noise_album_to_string (NoiseAlbum* self);
const gchar* noise_album_get_name (NoiseAlbum* self);
gchar* noise_album_get_display_name (NoiseAlbum* self);
gchar* noise_media_get_simple_display_text (const gchar* text);
gchar* noise_album_get_display_artist (NoiseAlbum* self);
gboolean noise_album_contains (NoiseAlbum* self, NoiseMedia* m);
gboolean noise_album_is_compatible (NoiseAlbum* self, NoiseMedia* m);
gchar* noise_media_get_album_hashkey (NoiseMedia* self);
gchar* noise_album_get_hashkey (NoiseAlbum* self);
void noise_album_remove_media (NoiseAlbum* self, NoiseMedia* m);
void noise_media_set_album_info (NoiseMedia* self, NoiseAlbum* value);
void noise_album_add_media (NoiseAlbum* self, NoiseMedia* m);
GeeCollection* noise_album_get_media (NoiseAlbum* self, guint n_disc);
guint noise_album_get_n_discs (NoiseAlbum* self);
NoiseAlbum* noise_album_new (void);
NoiseAlbum* noise_album_construct (GType object_type);
void noise_album_set_n_discs (NoiseAlbum* self, guint value);
guint noise_album_get_year (NoiseAlbum* self);
guint noise_album_get_n_media (NoiseAlbum* self);
gboolean noise_album_get_is_empty (NoiseAlbum* self);
static void noise_album_finalize (GObject* obj);
static void _vala_noise_album_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_noise_album_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


/**
     * Convenience constructor.
     *
     * This is a temporary workaround used by the Grid View and will be
     * deprecated after the TODO list is completed.
     */
NoiseAlbum* noise_album_construct_from_media (GType object_type, NoiseMedia* m) {
	NoiseAlbum * self = NULL;
	NoiseMedia* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	NoiseMedia* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	NoiseMedia* _tmp6_ = NULL;
	guint _tmp7_ = 0U;
	guint _tmp8_ = 0U;
	const gchar* _tmp9_ = NULL;
	gboolean _tmp10_ = FALSE;
#line 70 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	g_return_val_if_fail (m != NULL, NULL);
#line 70 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	self = (NoiseAlbum*) g_object_new (object_type, NULL);
#line 71 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp0_ = m;
#line 71 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp1_ = noise_media_get_album (_tmp0_);
#line 71 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp2_ = _tmp1_;
#line 71 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	noise_album_set_name (self, _tmp2_);
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp3_ = m;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp4_ = noise_media_get_album_artist (_tmp3_);
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp5_ = _tmp4_;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	noise_album_set_artist (self, _tmp5_);
#line 73 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp6_ = m;
#line 73 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp7_ = noise_media_get_year (_tmp6_);
#line 73 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp8_ = _tmp7_;
#line 73 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	noise_album_set_year (self, _tmp8_);
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp9_ = self->priv->_artist;
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp10_ = noise_string_is_empty (_tmp9_, TRUE);
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	if (_tmp10_) {
#line 191 "Album.c"
		NoiseMedia* _tmp11_ = NULL;
		const gchar* _tmp12_ = NULL;
		const gchar* _tmp13_ = NULL;
#line 76 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		_tmp11_ = m;
#line 76 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		_tmp12_ = noise_media_get_artist (_tmp11_);
#line 76 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		_tmp13_ = _tmp12_;
#line 76 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		noise_album_set_artist (self, _tmp13_);
#line 203 "Album.c"
	}
#line 70 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	return self;
#line 207 "Album.c"
}


NoiseAlbum* noise_album_new_from_media (NoiseMedia* m) {
#line 70 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	return noise_album_construct_from_media (NOISE_TYPE_ALBUM, m);
#line 214 "Album.c"
}


gchar* noise_album_to_string (NoiseAlbum* self) {
	gchar* result = NULL;
	GString* builder = NULL;
	GString* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
#line 87 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 88 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp0_ = g_string_new ("");
#line 88 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	builder = _tmp0_;
#line 89 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp1_ = self->priv->_name;
#line 89 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	g_string_append (builder, _tmp1_);
#line 90 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp2_ = self->priv->_artist;
#line 90 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	g_string_append (builder, _tmp2_);
#line 91 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp3_ = builder->str;
#line 91 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 91 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	result = _tmp4_;
#line 91 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_g_string_free0 (builder);
#line 91 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	return result;
#line 250 "Album.c"
}


inline gchar* noise_album_get_display_name (NoiseAlbum* self) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 95 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp0_ = self->priv->_name;
#line 95 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp1_ = noise_media_get_simple_display_text (_tmp0_);
#line 95 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	result = _tmp1_;
#line 95 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	return result;
#line 268 "Album.c"
}


inline gchar* noise_album_get_display_artist (NoiseAlbum* self) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 98 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 99 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp0_ = self->priv->_artist;
#line 99 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp1_ = noise_media_get_simple_display_text (_tmp0_);
#line 99 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	result = _tmp1_;
#line 99 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	return result;
#line 286 "Album.c"
}


gboolean noise_album_contains (NoiseAlbum* self, NoiseMedia* m) {
	gboolean result = FALSE;
	GeeHashSet* _tmp0_ = NULL;
	NoiseMedia* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
#line 102 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 102 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	g_return_val_if_fail (m != NULL, FALSE);
#line 103 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp0_ = self->priv->media;
#line 103 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp1_ = m;
#line 103 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp2_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, _tmp1_);
#line 103 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	result = _tmp2_;
#line 103 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	return result;
#line 309 "Album.c"
}


gboolean noise_album_is_compatible (NoiseAlbum* self, NoiseMedia* m) {
	gboolean result = FALSE;
	NoiseMedia* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
#line 106 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 106 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	g_return_val_if_fail (m != NULL, FALSE);
#line 107 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp0_ = m;
#line 107 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp1_ = noise_media_get_album_hashkey (_tmp0_);
#line 107 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp2_ = _tmp1_;
#line 107 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp3_ = noise_album_get_hashkey (self);
#line 107 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp4_ = _tmp3_;
#line 107 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp5_ = g_strcmp0 (_tmp2_, _tmp4_) == 0;
#line 107 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_g_free0 (_tmp4_);
#line 107 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_g_free0 (_tmp2_);
#line 107 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	if (_tmp5_) {
#line 108 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		result = TRUE;
#line 108 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		return result;
#line 347 "Album.c"
	} else {
#line 110 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		result = FALSE;
#line 110 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		return result;
#line 353 "Album.c"
	}
}


void noise_album_remove_media (NoiseAlbum* self, NoiseMedia* m) {
	NoiseMedia* _tmp0_ = NULL;
	GeeHashSet* _tmp1_ = NULL;
	NoiseMedia* _tmp2_ = NULL;
#line 113 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	g_return_if_fail (self != NULL);
#line 113 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	g_return_if_fail (m != NULL);
#line 114 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp0_ = m;
#line 114 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	noise_media_set_album_info (_tmp0_, NULL);
#line 115 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp1_ = self->priv->media;
#line 115 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp2_ = m;
#line 115 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp1_, _tmp2_);
#line 376 "Album.c"
}


void noise_album_add_media (NoiseAlbum* self, NoiseMedia* m) {
	GeeHashSet* _tmp0_ = NULL;
	NoiseMedia* _tmp1_ = NULL;
	NoiseMedia* _tmp2_ = NULL;
#line 118 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	g_return_if_fail (self != NULL);
#line 118 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	g_return_if_fail (m != NULL);
#line 119 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp0_ = self->priv->media;
#line 119 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp1_ = m;
#line 119 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, _tmp1_);
#line 120 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp2_ = m;
#line 120 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	noise_media_set_album_info (_tmp2_, self);
#line 398 "Album.c"
}


gchar* noise_album_get_hashkey (NoiseAlbum* self) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
#line 123 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 124 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp0_ = self->priv->_name;
#line 124 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp1_ = self->priv->_artist;
#line 124 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp2_ = g_strdup_printf ("%s|%s", _tmp0_, _tmp1_);
#line 124 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	result = _tmp2_;
#line 124 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	return result;
#line 419 "Album.c"
}


/**
     * Returns the media contained by the disc specified
     */
GeeCollection* noise_album_get_media (NoiseAlbum* self, guint n_disc) {
	GeeCollection* result = NULL;
	guint _tmp0_ = 0U;
	guint _tmp1_ = 0U;
	guint _tmp2_ = 0U;
	GeeHashSet* _tmp3_ = NULL;
	GeeSet* _tmp4_ = NULL;
	GeeSet* _tmp5_ = NULL;
#line 130 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 130 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp0_ = n_disc;
#line 130 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_vala_return_val_if_fail (_tmp0_ > ((guint) 0), "n_disc > 0", NULL);
#line 130 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp1_ = n_disc;
#line 130 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp2_ = self->priv->_n_discs;
#line 130 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_vala_return_val_if_fail (_tmp1_ <= _tmp2_, "n_disc <= n_discs", NULL);
#line 134 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp3_ = self->priv->media;
#line 134 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp4_ = gee_abstract_set_get_read_only_view ((GeeAbstractSet*) _tmp3_);
#line 134 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp5_ = _tmp4_;
#line 134 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	result = (GeeCollection*) _tmp5_;
#line 134 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	return result;
#line 456 "Album.c"
}


NoiseAlbum* noise_album_construct (GType object_type) {
	NoiseAlbum * self = NULL;
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	self = (NoiseAlbum*) g_object_new (object_type, NULL);
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	return self;
#line 466 "Album.c"
}


NoiseAlbum* noise_album_new (void) {
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	return noise_album_construct (NOISE_TYPE_ALBUM);
#line 473 "Album.c"
}


const gchar* noise_album_get_name (NoiseAlbum* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp0_ = self->priv->_name;
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	result = _tmp0_;
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	return result;
#line 488 "Album.c"
}


void noise_album_set_name (NoiseAlbum* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	g_return_if_fail (self != NULL);
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp0_ = value;
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_g_free0 (self->priv->_name);
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	self->priv->_name = _tmp1_;
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	g_object_notify ((GObject *) self, "name");
#line 507 "Album.c"
}


const gchar* noise_album_get_artist (NoiseAlbum* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
#line 47 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 47 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp0_ = self->priv->_artist;
#line 47 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	result = _tmp0_;
#line 47 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	return result;
#line 522 "Album.c"
}


void noise_album_set_artist (NoiseAlbum* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 47 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	g_return_if_fail (self != NULL);
#line 47 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp0_ = value;
#line 47 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 47 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_g_free0 (self->priv->_artist);
#line 47 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	self->priv->_artist = _tmp1_;
#line 47 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	g_object_notify ((GObject *) self, "artist");
#line 541 "Album.c"
}


guint noise_album_get_n_discs (NoiseAlbum* self) {
	guint result;
	guint _tmp0_ = 0U;
#line 50 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 50 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp0_ = self->priv->_n_discs;
#line 50 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	result = _tmp0_;
#line 50 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	return result;
#line 556 "Album.c"
}


void noise_album_set_n_discs (NoiseAlbum* self, guint value) {
	guint _tmp0_ = 0U;
#line 50 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	g_return_if_fail (self != NULL);
#line 50 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp0_ = value;
#line 50 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	self->priv->_n_discs = _tmp0_;
#line 50 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	g_object_notify ((GObject *) self, "n-discs");
#line 570 "Album.c"
}


guint noise_album_get_year (NoiseAlbum* self) {
	guint result;
	guint _tmp0_ = 0U;
#line 56 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 56 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp0_ = self->priv->_year;
#line 56 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	result = _tmp0_;
#line 56 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	return result;
#line 585 "Album.c"
}


void noise_album_set_year (NoiseAlbum* self, guint value) {
	guint _tmp0_ = 0U;
#line 56 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	g_return_if_fail (self != NULL);
#line 56 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp0_ = value;
#line 56 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	self->priv->_year = _tmp0_;
#line 56 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	g_object_notify ((GObject *) self, "year");
#line 599 "Album.c"
}


guint noise_album_get_n_media (NoiseAlbum* self) {
	guint result;
	GeeHashSet* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
#line 80 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 80 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp0_ = self->priv->media;
#line 80 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp0_);
#line 80 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp2_ = _tmp1_;
#line 80 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	result = (guint) _tmp2_;
#line 80 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	return result;
#line 620 "Album.c"
}


gboolean noise_album_get_is_empty (NoiseAlbum* self) {
	gboolean result;
	guint _tmp0_ = 0U;
	guint _tmp1_ = 0U;
#line 84 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 84 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp0_ = noise_album_get_n_media (self);
#line 84 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp1_ = _tmp0_;
#line 84 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	result = _tmp1_ < ((guint) 1);
#line 84 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	return result;
#line 638 "Album.c"
}


static void noise_album_class_init (NoiseAlbumClass * klass) {
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	noise_album_parent_class = g_type_class_peek_parent (klass);
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	g_type_class_add_private (klass, sizeof (NoiseAlbumPrivate));
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_album_get_property;
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_album_set_property;
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_album_finalize;
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_ALBUM_NAME, g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_ALBUM_ARTIST, g_param_spec_string ("artist", "artist", "artist", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_ALBUM_N_DISCS, g_param_spec_uint ("n-discs", "n-discs", "n-discs", 0, G_MAXUINT, (guint) 1, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_ALBUM_YEAR, g_param_spec_uint ("year", "year", "year", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_ALBUM_N_MEDIA, g_param_spec_uint ("n-media", "n-media", "n-media", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_ALBUM_IS_EMPTY, g_param_spec_boolean ("is-empty", "is-empty", "is-empty", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 665 "Album.c"
}


static void noise_album_instance_init (NoiseAlbum * self) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	GeeHashSet* _tmp2_ = NULL;
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	self->priv = NOISE_ALBUM_GET_PRIVATE (self);
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp0_ = g_strdup ("");
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	self->priv->_name = _tmp0_;
#line 47 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp1_ = g_strdup ("");
#line 47 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	self->priv->_artist = _tmp1_;
#line 50 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	self->priv->_n_discs = (guint) 1;
#line 56 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	self->priv->_year = (guint) 0;
#line 58 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp2_ = gee_hash_set_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 58 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	self->priv->media = _tmp2_;
#line 691 "Album.c"
}


static void noise_album_finalize (GObject* obj) {
	NoiseAlbum * self;
	GeeHashSet* _tmp0_ = NULL;
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_ALBUM, NoiseAlbum);
#line 61 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_tmp0_ = self->priv->media;
#line 61 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_g_free0 (self->priv->_name);
#line 47 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_g_free0 (self->priv->_artist);
#line 58 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	_g_object_unref0 (self->priv->media);
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	G_OBJECT_CLASS (noise_album_parent_class)->finalize (obj);
#line 712 "Album.c"
}


/**
 * An object representing an album.
 *
 * Currently only used by the album grid view to keep an internal cache.
 *
 * TODO (a lot of work for 1.0 ++)
 * - Replace album-related Media fields with an album object.
 * - Allow organizing media by disc number. Creating a Disc object would probably
 *   be overkill, considering our basic needs.
 * - Modify code accordingly
 * - Save albums to database
 * - Keep albums organized by library manager
 */
GType noise_album_get_type (void) {
	static volatile gsize noise_album_type_id__volatile = 0;
	if (g_once_init_enter (&noise_album_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseAlbumClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_album_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseAlbum), 0, (GInstanceInitFunc) noise_album_instance_init, NULL };
		GType noise_album_type_id;
		noise_album_type_id = g_type_register_static (G_TYPE_OBJECT, "NoiseAlbum", &g_define_type_info, 0);
		g_once_init_leave (&noise_album_type_id__volatile, noise_album_type_id);
	}
	return noise_album_type_id__volatile;
}


static void _vala_noise_album_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NoiseAlbum * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_ALBUM, NoiseAlbum);
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	switch (property_id) {
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		case NOISE_ALBUM_NAME:
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		g_value_set_string (value, noise_album_get_name (self));
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		break;
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		case NOISE_ALBUM_ARTIST:
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		g_value_set_string (value, noise_album_get_artist (self));
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		break;
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		case NOISE_ALBUM_N_DISCS:
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		g_value_set_uint (value, noise_album_get_n_discs (self));
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		break;
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		case NOISE_ALBUM_YEAR:
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		g_value_set_uint (value, noise_album_get_year (self));
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		break;
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		case NOISE_ALBUM_N_MEDIA:
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		g_value_set_uint (value, noise_album_get_n_media (self));
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		break;
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		case NOISE_ALBUM_IS_EMPTY:
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		g_value_set_boolean (value, noise_album_get_is_empty (self));
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		break;
#line 782 "Album.c"
		default:
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		break;
#line 788 "Album.c"
	}
}


static void _vala_noise_album_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	NoiseAlbum * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_ALBUM, NoiseAlbum);
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
	switch (property_id) {
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		case NOISE_ALBUM_NAME:
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		noise_album_set_name (self, g_value_get_string (value));
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		break;
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		case NOISE_ALBUM_ARTIST:
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		noise_album_set_artist (self, g_value_get_string (value));
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		break;
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		case NOISE_ALBUM_N_DISCS:
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		noise_album_set_n_discs (self, g_value_get_uint (value));
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		break;
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		case NOISE_ALBUM_YEAR:
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		noise_album_set_year (self, g_value_get_uint (value));
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		break;
#line 822 "Album.c"
		default:
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Album.vala"
		break;
#line 828 "Album.c"
	}
}



