/* Device.c generated by valac 0.28.1, the Vala compiler
 * generated from Device.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2013 Noise Developers (http://launchpad.net/noise)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Corentin Noël <tintou@mailoo.org>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <gee.h>


#define NOISE_TYPE_DEVICE (noise_device_get_type ())
#define NOISE_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_DEVICE, NoiseDevice))
#define NOISE_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_DEVICE))
#define NOISE_DEVICE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), NOISE_TYPE_DEVICE, NoiseDeviceIface))

typedef struct _NoiseDevice NoiseDevice;
typedef struct _NoiseDeviceIface NoiseDeviceIface;

#define NOISE_TYPE_DEVICE_PREFERENCES (noise_device_preferences_get_type ())
#define NOISE_DEVICE_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_DEVICE_PREFERENCES, NoiseDevicePreferences))
#define NOISE_DEVICE_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_DEVICE_PREFERENCES, NoiseDevicePreferencesClass))
#define NOISE_IS_DEVICE_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_DEVICE_PREFERENCES))
#define NOISE_IS_DEVICE_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_DEVICE_PREFERENCES))
#define NOISE_DEVICE_PREFERENCES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_DEVICE_PREFERENCES, NoiseDevicePreferencesClass))

typedef struct _NoiseDevicePreferences NoiseDevicePreferences;
typedef struct _NoiseDevicePreferencesClass NoiseDevicePreferencesClass;

#define NOISE_TYPE_LIBRARY (noise_library_get_type ())
#define NOISE_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LIBRARY, NoiseLibrary))
#define NOISE_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LIBRARY, NoiseLibraryClass))
#define NOISE_IS_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LIBRARY))
#define NOISE_IS_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LIBRARY))
#define NOISE_LIBRARY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LIBRARY, NoiseLibraryClass))

typedef struct _NoiseLibrary NoiseLibrary;
typedef struct _NoiseLibraryClass NoiseLibraryClass;

#define NOISE_TYPE_MEDIA (noise_media_get_type ())
#define NOISE_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_MEDIA, NoiseMedia))
#define NOISE_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_MEDIA, NoiseMediaClass))
#define NOISE_IS_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_MEDIA))
#define NOISE_IS_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_MEDIA))
#define NOISE_MEDIA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_MEDIA, NoiseMediaClass))

typedef struct _NoiseMedia NoiseMedia;
typedef struct _NoiseMediaClass NoiseMediaClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _NoiseDeviceIface {
	GTypeInterface parent_iface;
	NoiseDevicePreferences* (*get_preferences) (NoiseDevice* self);
	gboolean (*start_initialization) (NoiseDevice* self);
	void (*finish_initialization) (NoiseDevice* self);
	gchar* (*getContentType) (NoiseDevice* self);
	gchar* (*getDisplayName) (NoiseDevice* self);
	gchar* (*getEmptyDeviceTitle) (NoiseDevice* self);
	gchar* (*getEmptyDeviceDescription) (NoiseDevice* self);
	void (*setDisplayName) (NoiseDevice* self, const gchar* name);
	gchar* (*get_fancy_description) (NoiseDevice* self);
	void (*set_mount) (NoiseDevice* self, GMount* mount);
	GMount* (*get_mount) (NoiseDevice* self);
	gchar* (*get_uri) (NoiseDevice* self);
	void (*set_icon) (NoiseDevice* self, GIcon* icon);
	GIcon* (*get_icon) (NoiseDevice* self);
	guint64 (*get_capacity) (NoiseDevice* self);
	gchar* (*get_fancy_capacity) (NoiseDevice* self);
	guint64 (*get_used_space) (NoiseDevice* self);
	guint64 (*get_free_space) (NoiseDevice* self);
	void (*unmount) (NoiseDevice* self);
	void (*eject) (NoiseDevice* self);
	void (*synchronize) (NoiseDevice* self);
	gboolean (*only_use_custom_view) (NoiseDevice* self);
	GtkWidget* (*get_custom_view) (NoiseDevice* self);
	gboolean (*read_only) (NoiseDevice* self);
	NoiseLibrary* (*get_library) (NoiseDevice* self);
};



GType noise_device_preferences_get_type (void) G_GNUC_CONST;
GType noise_library_get_type (void) G_GNUC_CONST;
GType noise_device_get_type (void) G_GNUC_CONST;
NoiseDevicePreferences* noise_device_get_preferences (NoiseDevice* self);
gboolean noise_device_start_initialization (NoiseDevice* self);
void noise_device_finish_initialization (NoiseDevice* self);
gchar* noise_device_getContentType (NoiseDevice* self);
gchar* noise_device_getDisplayName (NoiseDevice* self);
gchar* noise_device_getEmptyDeviceTitle (NoiseDevice* self);
gchar* noise_device_getEmptyDeviceDescription (NoiseDevice* self);
void noise_device_setDisplayName (NoiseDevice* self, const gchar* name);
gchar* noise_device_get_fancy_description (NoiseDevice* self);
void noise_device_set_mount (NoiseDevice* self, GMount* mount);
GMount* noise_device_get_mount (NoiseDevice* self);
gchar* noise_device_get_uri (NoiseDevice* self);
void noise_device_set_icon (NoiseDevice* self, GIcon* icon);
GIcon* noise_device_get_icon (NoiseDevice* self);
guint64 noise_device_get_capacity (NoiseDevice* self);
gchar* noise_device_get_fancy_capacity (NoiseDevice* self);
guint64 noise_device_get_used_space (NoiseDevice* self);
guint64 noise_device_get_free_space (NoiseDevice* self);
void noise_device_unmount (NoiseDevice* self);
void noise_device_eject (NoiseDevice* self);
void noise_device_synchronize (NoiseDevice* self);
gboolean noise_device_only_use_custom_view (NoiseDevice* self);
GtkWidget* noise_device_get_custom_view (NoiseDevice* self);
gboolean noise_device_read_only (NoiseDevice* self);
NoiseLibrary* noise_device_get_library (NoiseDevice* self);
GType noise_media_get_type (void) G_GNUC_CONST;
GeeCollection* noise_device_delete_doubles (NoiseDevice* self, GeeCollection* source_list, GeeCollection* to_remove);
const gchar* noise_media_get_title (NoiseMedia* self);
const gchar* noise_media_get_album (NoiseMedia* self);
const gchar* noise_media_get_artist (NoiseMedia* self);
gboolean noise_device_will_fit (NoiseDevice* self, GeeCollection* list);
guint64 noise_media_get_file_size (NoiseMedia* self);
gboolean noise_device_will_fit_without (NoiseDevice* self, GeeCollection* list, GeeCollection* without);
gchar* noise_device_get_unique_identifier (NoiseDevice* self);
static void g_cclosure_user_marshal_VOID__STRING_ENUM (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);


NoiseDevicePreferences* noise_device_get_preferences (NoiseDevice* self) {
#line 38 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	return NOISE_DEVICE_GET_INTERFACE (self)->get_preferences (self);
#line 161 "Device.c"
}


gboolean noise_device_start_initialization (NoiseDevice* self) {
#line 39 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 39 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	return NOISE_DEVICE_GET_INTERFACE (self)->start_initialization (self);
#line 170 "Device.c"
}


void noise_device_finish_initialization (NoiseDevice* self) {
#line 40 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	g_return_if_fail (self != NULL);
#line 40 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	NOISE_DEVICE_GET_INTERFACE (self)->finish_initialization (self);
#line 179 "Device.c"
}


gchar* noise_device_getContentType (NoiseDevice* self) {
#line 41 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	return NOISE_DEVICE_GET_INTERFACE (self)->getContentType (self);
#line 188 "Device.c"
}


gchar* noise_device_getDisplayName (NoiseDevice* self) {
#line 42 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	return NOISE_DEVICE_GET_INTERFACE (self)->getDisplayName (self);
#line 197 "Device.c"
}


gchar* noise_device_getEmptyDeviceTitle (NoiseDevice* self) {
#line 43 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	return NOISE_DEVICE_GET_INTERFACE (self)->getEmptyDeviceTitle (self);
#line 206 "Device.c"
}


gchar* noise_device_getEmptyDeviceDescription (NoiseDevice* self) {
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	return NOISE_DEVICE_GET_INTERFACE (self)->getEmptyDeviceDescription (self);
#line 215 "Device.c"
}


void noise_device_setDisplayName (NoiseDevice* self, const gchar* name) {
#line 45 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	g_return_if_fail (self != NULL);
#line 45 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	NOISE_DEVICE_GET_INTERFACE (self)->setDisplayName (self, name);
#line 224 "Device.c"
}


gchar* noise_device_get_fancy_description (NoiseDevice* self) {
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	return NOISE_DEVICE_GET_INTERFACE (self)->get_fancy_description (self);
#line 233 "Device.c"
}


void noise_device_set_mount (NoiseDevice* self, GMount* mount) {
#line 47 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	g_return_if_fail (self != NULL);
#line 47 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	NOISE_DEVICE_GET_INTERFACE (self)->set_mount (self, mount);
#line 242 "Device.c"
}


GMount* noise_device_get_mount (NoiseDevice* self) {
#line 48 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	return NOISE_DEVICE_GET_INTERFACE (self)->get_mount (self);
#line 251 "Device.c"
}


gchar* noise_device_get_uri (NoiseDevice* self) {
#line 49 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	return NOISE_DEVICE_GET_INTERFACE (self)->get_uri (self);
#line 260 "Device.c"
}


void noise_device_set_icon (NoiseDevice* self, GIcon* icon) {
#line 50 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	g_return_if_fail (self != NULL);
#line 50 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	NOISE_DEVICE_GET_INTERFACE (self)->set_icon (self, icon);
#line 269 "Device.c"
}


GIcon* noise_device_get_icon (NoiseDevice* self) {
#line 51 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	return NOISE_DEVICE_GET_INTERFACE (self)->get_icon (self);
#line 278 "Device.c"
}


guint64 noise_device_get_capacity (NoiseDevice* self) {
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	return NOISE_DEVICE_GET_INTERFACE (self)->get_capacity (self);
#line 287 "Device.c"
}


gchar* noise_device_get_fancy_capacity (NoiseDevice* self) {
#line 53 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 53 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	return NOISE_DEVICE_GET_INTERFACE (self)->get_fancy_capacity (self);
#line 296 "Device.c"
}


guint64 noise_device_get_used_space (NoiseDevice* self) {
#line 54 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 54 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	return NOISE_DEVICE_GET_INTERFACE (self)->get_used_space (self);
#line 305 "Device.c"
}


guint64 noise_device_get_free_space (NoiseDevice* self) {
#line 55 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 55 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	return NOISE_DEVICE_GET_INTERFACE (self)->get_free_space (self);
#line 314 "Device.c"
}


void noise_device_unmount (NoiseDevice* self) {
#line 56 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	g_return_if_fail (self != NULL);
#line 56 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	NOISE_DEVICE_GET_INTERFACE (self)->unmount (self);
#line 323 "Device.c"
}


void noise_device_eject (NoiseDevice* self) {
#line 57 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	g_return_if_fail (self != NULL);
#line 57 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	NOISE_DEVICE_GET_INTERFACE (self)->eject (self);
#line 332 "Device.c"
}


void noise_device_synchronize (NoiseDevice* self) {
#line 58 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	g_return_if_fail (self != NULL);
#line 58 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	NOISE_DEVICE_GET_INTERFACE (self)->synchronize (self);
#line 341 "Device.c"
}


gboolean noise_device_only_use_custom_view (NoiseDevice* self) {
#line 59 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 59 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	return NOISE_DEVICE_GET_INTERFACE (self)->only_use_custom_view (self);
#line 350 "Device.c"
}


GtkWidget* noise_device_get_custom_view (NoiseDevice* self) {
#line 60 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 60 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	return NOISE_DEVICE_GET_INTERFACE (self)->get_custom_view (self);
#line 359 "Device.c"
}


gboolean noise_device_read_only (NoiseDevice* self) {
#line 61 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 61 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	return NOISE_DEVICE_GET_INTERFACE (self)->read_only (self);
#line 368 "Device.c"
}


NoiseLibrary* noise_device_get_library (NoiseDevice* self) {
#line 62 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 62 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	return NOISE_DEVICE_GET_INTERFACE (self)->get_library (self);
#line 377 "Device.c"
}


GeeCollection* noise_device_delete_doubles (NoiseDevice* self, GeeCollection* source_list, GeeCollection* to_remove) {
	GeeCollection* result = NULL;
	GeeLinkedList* new_list = NULL;
	GeeLinkedList* _tmp0_ = NULL;
#line 64 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	g_return_val_if_fail (source_list != NULL, NULL);
#line 64 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	g_return_val_if_fail (to_remove != NULL, NULL);
#line 65 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	_tmp0_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 65 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	new_list = _tmp0_;
#line 393 "Device.c"
	{
		GeeIterator* _m_it = NULL;
		GeeCollection* _tmp1_ = NULL;
		GeeIterator* _tmp2_ = NULL;
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		_tmp1_ = source_list;
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		_m_it = _tmp2_;
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		while (TRUE) {
#line 406 "Device.c"
			GeeIterator* _tmp3_ = NULL;
			gboolean _tmp4_ = FALSE;
			NoiseMedia* m = NULL;
			GeeIterator* _tmp5_ = NULL;
			gpointer _tmp6_ = NULL;
			NoiseMedia* _tmp7_ = NULL;
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp3_ = _m_it;
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp4_ = gee_iterator_next (_tmp3_);
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			if (!_tmp4_) {
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
				break;
#line 421 "Device.c"
			}
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp5_ = _m_it;
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			m = (NoiseMedia*) _tmp6_;
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp7_ = m;
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			if (_tmp7_ != NULL) {
#line 433 "Device.c"
				gboolean needed = FALSE;
				gboolean _tmp81_ = FALSE;
#line 68 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
				needed = TRUE;
#line 438 "Device.c"
				{
					GeeIterator* _med_it = NULL;
					GeeCollection* _tmp8_ = NULL;
					GeeIterator* _tmp9_ = NULL;
#line 69 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
					_tmp8_ = to_remove;
#line 69 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
					_tmp9_ = gee_iterable_iterator ((GeeIterable*) _tmp8_);
#line 69 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
					_med_it = _tmp9_;
#line 69 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
					while (TRUE) {
#line 451 "Device.c"
						GeeIterator* _tmp10_ = NULL;
						gboolean _tmp11_ = FALSE;
						NoiseMedia* med = NULL;
						GeeIterator* _tmp12_ = NULL;
						gpointer _tmp13_ = NULL;
						gboolean _tmp14_ = FALSE;
						NoiseMedia* _tmp15_ = NULL;
#line 69 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
						_tmp10_ = _med_it;
#line 69 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
						_tmp11_ = gee_iterator_next (_tmp10_);
#line 69 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
						if (!_tmp11_) {
#line 69 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
							break;
#line 467 "Device.c"
						}
#line 69 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
						_tmp12_ = _med_it;
#line 69 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
						_tmp13_ = gee_iterator_get (_tmp12_);
#line 69 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
						med = (NoiseMedia*) _tmp13_;
#line 70 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
						_tmp15_ = med;
#line 70 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
						if (_tmp15_ != NULL) {
#line 479 "Device.c"
							NoiseMedia* _tmp16_ = NULL;
							const gchar* _tmp17_ = NULL;
							const gchar* _tmp18_ = NULL;
#line 70 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
							_tmp16_ = med;
#line 70 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
							_tmp17_ = noise_media_get_title (_tmp16_);
#line 70 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
							_tmp18_ = _tmp17_;
#line 70 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
							_tmp14_ = _tmp18_ != NULL;
#line 491 "Device.c"
						} else {
#line 70 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
							_tmp14_ = FALSE;
#line 495 "Device.c"
						}
#line 70 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
						if (_tmp14_) {
#line 499 "Device.c"
							gboolean _tmp19_ = FALSE;
							NoiseMedia* _tmp20_ = NULL;
							const gchar* _tmp21_ = NULL;
							const gchar* _tmp22_ = NULL;
#line 71 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
							_tmp20_ = med;
#line 71 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
							_tmp21_ = noise_media_get_album (_tmp20_);
#line 71 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
							_tmp22_ = _tmp21_;
#line 71 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
							if (_tmp22_ != NULL) {
#line 512 "Device.c"
								NoiseMedia* _tmp23_ = NULL;
								const gchar* _tmp24_ = NULL;
								const gchar* _tmp25_ = NULL;
#line 71 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
								_tmp23_ = m;
#line 71 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
								_tmp24_ = noise_media_get_album (_tmp23_);
#line 71 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
								_tmp25_ = _tmp24_;
#line 71 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
								_tmp19_ = _tmp25_ != NULL;
#line 524 "Device.c"
							} else {
#line 71 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
								_tmp19_ = FALSE;
#line 528 "Device.c"
							}
#line 71 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
							if (_tmp19_) {
#line 532 "Device.c"
								gboolean _tmp26_ = FALSE;
								gboolean _tmp27_ = FALSE;
								NoiseMedia* _tmp28_ = NULL;
								const gchar* _tmp29_ = NULL;
								const gchar* _tmp30_ = NULL;
								gchar* _tmp31_ = NULL;
								gchar* _tmp32_ = NULL;
								NoiseMedia* _tmp33_ = NULL;
								const gchar* _tmp34_ = NULL;
								const gchar* _tmp35_ = NULL;
								gchar* _tmp36_ = NULL;
								gchar* _tmp37_ = NULL;
								gboolean _tmp38_ = FALSE;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
								_tmp28_ = med;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
								_tmp29_ = noise_media_get_title (_tmp28_);
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
								_tmp30_ = _tmp29_;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
								_tmp31_ = g_utf8_strdown (_tmp30_, (gssize) (-1));
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
								_tmp32_ = _tmp31_;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
								_tmp33_ = m;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
								_tmp34_ = noise_media_get_title (_tmp33_);
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
								_tmp35_ = _tmp34_;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
								_tmp36_ = g_utf8_strdown (_tmp35_, (gssize) (-1));
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
								_tmp37_ = _tmp36_;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
								_tmp38_ = g_strcmp0 (_tmp32_, _tmp37_) == 0;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
								_g_free0 (_tmp37_);
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
								_g_free0 (_tmp32_);
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
								if (_tmp38_) {
#line 574 "Device.c"
									NoiseMedia* _tmp39_ = NULL;
									const gchar* _tmp40_ = NULL;
									const gchar* _tmp41_ = NULL;
									gchar* _tmp42_ = NULL;
									gchar* _tmp43_ = NULL;
									NoiseMedia* _tmp44_ = NULL;
									const gchar* _tmp45_ = NULL;
									const gchar* _tmp46_ = NULL;
									gchar* _tmp47_ = NULL;
									gchar* _tmp48_ = NULL;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_tmp39_ = med;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_tmp40_ = noise_media_get_artist (_tmp39_);
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_tmp41_ = _tmp40_;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_tmp42_ = g_utf8_strdown (_tmp41_, (gssize) (-1));
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_tmp43_ = _tmp42_;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_tmp44_ = m;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_tmp45_ = noise_media_get_artist (_tmp44_);
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_tmp46_ = _tmp45_;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_tmp47_ = g_utf8_strdown (_tmp46_, (gssize) (-1));
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_tmp48_ = _tmp47_;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_tmp27_ = g_strcmp0 (_tmp43_, _tmp48_) == 0;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_g_free0 (_tmp48_);
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_g_free0 (_tmp43_);
#line 611 "Device.c"
								} else {
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_tmp27_ = FALSE;
#line 615 "Device.c"
								}
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
								if (_tmp27_) {
#line 619 "Device.c"
									NoiseMedia* _tmp49_ = NULL;
									const gchar* _tmp50_ = NULL;
									const gchar* _tmp51_ = NULL;
									gchar* _tmp52_ = NULL;
									gchar* _tmp53_ = NULL;
									NoiseMedia* _tmp54_ = NULL;
									const gchar* _tmp55_ = NULL;
									const gchar* _tmp56_ = NULL;
									gchar* _tmp57_ = NULL;
									gchar* _tmp58_ = NULL;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_tmp49_ = med;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_tmp50_ = noise_media_get_album (_tmp49_);
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_tmp51_ = _tmp50_;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_tmp52_ = g_utf8_strdown (_tmp51_, (gssize) (-1));
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_tmp53_ = _tmp52_;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_tmp54_ = m;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_tmp55_ = noise_media_get_album (_tmp54_);
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_tmp56_ = _tmp55_;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_tmp57_ = g_utf8_strdown (_tmp56_, (gssize) (-1));
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_tmp58_ = _tmp57_;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_tmp26_ = g_strcmp0 (_tmp53_, _tmp58_) == 0;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_g_free0 (_tmp58_);
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_g_free0 (_tmp53_);
#line 656 "Device.c"
								} else {
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_tmp26_ = FALSE;
#line 660 "Device.c"
								}
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
								if (_tmp26_) {
#line 73 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									needed = FALSE;
#line 74 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_g_object_unref0 (med);
#line 74 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									break;
#line 670 "Device.c"
								}
							} else {
								gboolean _tmp59_ = FALSE;
								NoiseMedia* _tmp60_ = NULL;
								const gchar* _tmp61_ = NULL;
								const gchar* _tmp62_ = NULL;
								gchar* _tmp63_ = NULL;
								gchar* _tmp64_ = NULL;
								NoiseMedia* _tmp65_ = NULL;
								const gchar* _tmp66_ = NULL;
								const gchar* _tmp67_ = NULL;
								gchar* _tmp68_ = NULL;
								gchar* _tmp69_ = NULL;
								gboolean _tmp70_ = FALSE;
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
								_tmp60_ = med;
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
								_tmp61_ = noise_media_get_title (_tmp60_);
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
								_tmp62_ = _tmp61_;
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
								_tmp63_ = g_utf8_strdown (_tmp62_, (gssize) (-1));
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
								_tmp64_ = _tmp63_;
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
								_tmp65_ = m;
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
								_tmp66_ = noise_media_get_title (_tmp65_);
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
								_tmp67_ = _tmp66_;
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
								_tmp68_ = g_utf8_strdown (_tmp67_, (gssize) (-1));
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
								_tmp69_ = _tmp68_;
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
								_tmp70_ = g_strcmp0 (_tmp64_, _tmp69_) == 0;
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
								_g_free0 (_tmp69_);
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
								_g_free0 (_tmp64_);
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
								if (_tmp70_) {
#line 713 "Device.c"
									NoiseMedia* _tmp71_ = NULL;
									const gchar* _tmp72_ = NULL;
									const gchar* _tmp73_ = NULL;
									gchar* _tmp74_ = NULL;
									gchar* _tmp75_ = NULL;
									NoiseMedia* _tmp76_ = NULL;
									const gchar* _tmp77_ = NULL;
									const gchar* _tmp78_ = NULL;
									gchar* _tmp79_ = NULL;
									gchar* _tmp80_ = NULL;
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_tmp71_ = med;
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_tmp72_ = noise_media_get_artist (_tmp71_);
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_tmp73_ = _tmp72_;
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_tmp74_ = g_utf8_strdown (_tmp73_, (gssize) (-1));
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_tmp75_ = _tmp74_;
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_tmp76_ = m;
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_tmp77_ = noise_media_get_artist (_tmp76_);
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_tmp78_ = _tmp77_;
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_tmp79_ = g_utf8_strdown (_tmp78_, (gssize) (-1));
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_tmp80_ = _tmp79_;
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_tmp59_ = g_strcmp0 (_tmp75_, _tmp80_) == 0;
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_g_free0 (_tmp80_);
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_g_free0 (_tmp75_);
#line 750 "Device.c"
								} else {
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_tmp59_ = FALSE;
#line 754 "Device.c"
								}
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
								if (_tmp59_) {
#line 78 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									needed = FALSE;
#line 79 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									_g_object_unref0 (med);
#line 79 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
									break;
#line 764 "Device.c"
								}
							}
						}
#line 69 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
						_g_object_unref0 (med);
#line 770 "Device.c"
					}
#line 69 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
					_g_object_unref0 (_med_it);
#line 774 "Device.c"
				}
#line 84 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
				_tmp81_ = needed;
#line 84 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
				if (_tmp81_ == TRUE) {
#line 780 "Device.c"
					GeeLinkedList* _tmp82_ = NULL;
					NoiseMedia* _tmp83_ = NULL;
#line 85 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
					_tmp82_ = new_list;
#line 85 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
					_tmp83_ = m;
#line 85 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp82_, _tmp83_);
#line 789 "Device.c"
				}
			}
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_g_object_unref0 (m);
#line 794 "Device.c"
		}
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		_g_object_unref0 (_m_it);
#line 798 "Device.c"
	}
#line 89 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	result = (GeeCollection*) new_list;
#line 89 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	return result;
#line 804 "Device.c"
}


gboolean noise_device_will_fit (NoiseDevice* self, GeeCollection* list) {
	gboolean result = FALSE;
	guint64 list_size = 0ULL;
	guint64 _tmp10_ = 0ULL;
	guint64 _tmp11_ = 0ULL;
#line 92 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	g_return_val_if_fail (list != NULL, FALSE);
#line 93 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	list_size = (guint64) 0;
#line 817 "Device.c"
	{
		GeeIterator* _m_it = NULL;
		GeeCollection* _tmp0_ = NULL;
		GeeIterator* _tmp1_ = NULL;
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		_tmp0_ = list;
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) _tmp0_);
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		_m_it = _tmp1_;
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		while (TRUE) {
#line 830 "Device.c"
			GeeIterator* _tmp2_ = NULL;
			gboolean _tmp3_ = FALSE;
			NoiseMedia* m = NULL;
			GeeIterator* _tmp4_ = NULL;
			gpointer _tmp5_ = NULL;
			guint64 _tmp6_ = 0ULL;
			NoiseMedia* _tmp7_ = NULL;
			guint64 _tmp8_ = 0ULL;
			guint64 _tmp9_ = 0ULL;
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp2_ = _m_it;
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			if (!_tmp3_) {
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
				break;
#line 848 "Device.c"
			}
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp4_ = _m_it;
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			m = (NoiseMedia*) _tmp5_;
#line 95 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp6_ = list_size;
#line 95 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp7_ = m;
#line 95 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp8_ = noise_media_get_file_size (_tmp7_);
#line 95 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp9_ = _tmp8_;
#line 95 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			list_size = _tmp6_ + _tmp9_;
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_g_object_unref0 (m);
#line 868 "Device.c"
		}
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		_g_object_unref0 (_m_it);
#line 872 "Device.c"
	}
#line 98 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	_tmp10_ = noise_device_get_capacity (self);
#line 98 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	_tmp11_ = list_size;
#line 98 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	result = _tmp10_ > _tmp11_;
#line 98 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	return result;
#line 882 "Device.c"
}


gboolean noise_device_will_fit_without (NoiseDevice* self, GeeCollection* list, GeeCollection* without) {
	gboolean result = FALSE;
	guint64 list_size = 0ULL;
	guint64 without_size = 0ULL;
	guint64 _tmp20_ = 0ULL;
	guint64 _tmp21_ = 0ULL;
#line 101 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	g_return_val_if_fail (list != NULL, FALSE);
#line 101 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	g_return_val_if_fail (without != NULL, FALSE);
#line 102 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	list_size = (guint64) 0;
#line 103 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	without_size = (guint64) 0;
#line 900 "Device.c"
	{
		GeeIterator* _m_it = NULL;
		GeeCollection* _tmp0_ = NULL;
		GeeIterator* _tmp1_ = NULL;
#line 104 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		_tmp0_ = list;
#line 104 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) _tmp0_);
#line 104 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		_m_it = _tmp1_;
#line 104 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		while (TRUE) {
#line 913 "Device.c"
			GeeIterator* _tmp2_ = NULL;
			gboolean _tmp3_ = FALSE;
			NoiseMedia* m = NULL;
			GeeIterator* _tmp4_ = NULL;
			gpointer _tmp5_ = NULL;
			guint64 _tmp6_ = 0ULL;
			NoiseMedia* _tmp7_ = NULL;
			guint64 _tmp8_ = 0ULL;
			guint64 _tmp9_ = 0ULL;
#line 104 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp2_ = _m_it;
#line 104 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 104 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			if (!_tmp3_) {
#line 104 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
				break;
#line 931 "Device.c"
			}
#line 104 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp4_ = _m_it;
#line 104 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 104 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			m = (NoiseMedia*) _tmp5_;
#line 105 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp6_ = list_size;
#line 105 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp7_ = m;
#line 105 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp8_ = noise_media_get_file_size (_tmp7_);
#line 105 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp9_ = _tmp8_;
#line 105 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			list_size = _tmp6_ + _tmp9_;
#line 104 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_g_object_unref0 (m);
#line 951 "Device.c"
		}
#line 104 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		_g_object_unref0 (_m_it);
#line 955 "Device.c"
	}
	{
		GeeIterator* _m_it = NULL;
		GeeCollection* _tmp10_ = NULL;
		GeeIterator* _tmp11_ = NULL;
#line 107 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		_tmp10_ = without;
#line 107 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		_tmp11_ = gee_iterable_iterator ((GeeIterable*) _tmp10_);
#line 107 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		_m_it = _tmp11_;
#line 107 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		while (TRUE) {
#line 969 "Device.c"
			GeeIterator* _tmp12_ = NULL;
			gboolean _tmp13_ = FALSE;
			NoiseMedia* m = NULL;
			GeeIterator* _tmp14_ = NULL;
			gpointer _tmp15_ = NULL;
			guint64 _tmp16_ = 0ULL;
			NoiseMedia* _tmp17_ = NULL;
			guint64 _tmp18_ = 0ULL;
			guint64 _tmp19_ = 0ULL;
#line 107 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp12_ = _m_it;
#line 107 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp13_ = gee_iterator_next (_tmp12_);
#line 107 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			if (!_tmp13_) {
#line 107 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
				break;
#line 987 "Device.c"
			}
#line 107 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp14_ = _m_it;
#line 107 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp15_ = gee_iterator_get (_tmp14_);
#line 107 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			m = (NoiseMedia*) _tmp15_;
#line 108 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp16_ = without_size;
#line 108 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp17_ = m;
#line 108 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp18_ = noise_media_get_file_size (_tmp17_);
#line 108 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp19_ = _tmp18_;
#line 108 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			without_size = _tmp16_ + _tmp19_;
#line 107 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_g_object_unref0 (m);
#line 1007 "Device.c"
		}
#line 107 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		_g_object_unref0 (_m_it);
#line 1011 "Device.c"
	}
#line 110 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	_tmp20_ = without_size;
#line 110 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	_tmp21_ = list_size;
#line 110 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	if (_tmp20_ > _tmp21_) {
#line 111 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		result = TRUE;
#line 111 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		return result;
#line 1023 "Device.c"
	} else {
		guint64 _tmp22_ = 0ULL;
		guint64 _tmp23_ = 0ULL;
		guint64 _tmp24_ = 0ULL;
#line 113 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		_tmp22_ = noise_device_get_capacity (self);
#line 113 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		_tmp23_ = list_size;
#line 113 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		_tmp24_ = without_size;
#line 113 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		result = _tmp22_ > (_tmp23_ - _tmp24_);
#line 113 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		return result;
#line 1038 "Device.c"
	}
}


gchar* noise_device_get_unique_identifier (NoiseDevice* self) {
	gchar* result = NULL;
	GMount* m = NULL;
	GMount* _tmp0_ = NULL;
	GMount* _tmp1_ = NULL;
#line 118 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	_tmp0_ = noise_device_get_mount (self);
#line 118 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	m = _tmp0_;
#line 119 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	_tmp1_ = m;
#line 119 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	if (_tmp1_ != NULL) {
#line 1056 "Device.c"
		gchar* uuid = NULL;
		GMount* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
		GFile* root = NULL;
		GMount* _tmp4_ = NULL;
		GFile* _tmp5_ = NULL;
		gchar* rv = NULL;
		gchar* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gboolean _tmp8_ = FALSE;
		GFile* _tmp9_ = NULL;
		gboolean _tmp18_ = FALSE;
		const gchar* _tmp19_ = NULL;
#line 120 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		_tmp2_ = m;
#line 120 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		_tmp3_ = g_mount_get_uuid (_tmp2_);
#line 120 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		uuid = _tmp3_;
#line 121 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		_tmp4_ = m;
#line 121 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		_tmp5_ = g_mount_get_root (_tmp4_);
#line 121 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		root = _tmp5_;
#line 122 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		_tmp6_ = g_strdup ("");
#line 122 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		rv = _tmp6_;
#line 123 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		_tmp7_ = uuid;
#line 123 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		g_debug ("Device.vala:123: uuid: %s\n", _tmp7_);
#line 124 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		_tmp9_ = root;
#line 124 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		if (_tmp9_ != NULL) {
#line 1094 "Device.c"
			GFile* _tmp10_ = NULL;
			gchar* _tmp11_ = NULL;
			gchar* _tmp12_ = NULL;
#line 124 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp10_ = root;
#line 124 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp11_ = g_file_get_uri (_tmp10_);
#line 124 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp12_ = _tmp11_;
#line 124 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp8_ = _tmp12_ != NULL;
#line 124 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_g_free0 (_tmp12_);
#line 1108 "Device.c"
		} else {
#line 124 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp8_ = FALSE;
#line 1112 "Device.c"
		}
#line 124 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		if (_tmp8_) {
#line 1116 "Device.c"
			const gchar* _tmp13_ = NULL;
			GFile* _tmp14_ = NULL;
			gchar* _tmp15_ = NULL;
			gchar* _tmp16_ = NULL;
			gchar* _tmp17_ = NULL;
#line 125 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp13_ = rv;
#line 125 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp14_ = root;
#line 125 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp15_ = g_file_get_uri (_tmp14_);
#line 125 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp16_ = _tmp15_;
#line 125 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp17_ = g_strconcat (_tmp13_, _tmp16_, NULL);
#line 125 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_g_free0 (rv);
#line 125 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			rv = _tmp17_;
#line 125 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_g_free0 (_tmp16_);
#line 1138 "Device.c"
		}
#line 127 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		_tmp19_ = uuid;
#line 127 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		if (_tmp19_ != NULL) {
#line 1144 "Device.c"
			const gchar* _tmp20_ = NULL;
#line 127 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp20_ = uuid;
#line 127 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp18_ = g_strcmp0 (_tmp20_, "") != 0;
#line 1150 "Device.c"
		} else {
#line 127 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp18_ = FALSE;
#line 1154 "Device.c"
		}
#line 127 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		if (_tmp18_) {
#line 1158 "Device.c"
			const gchar* _tmp21_ = NULL;
			const gchar* _tmp22_ = NULL;
			gchar* _tmp23_ = NULL;
			gchar* _tmp24_ = NULL;
			gchar* _tmp25_ = NULL;
#line 128 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp21_ = rv;
#line 128 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp22_ = uuid;
#line 128 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp23_ = g_strconcat ("/", _tmp22_, NULL);
#line 128 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp24_ = _tmp23_;
#line 128 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_tmp25_ = g_strconcat (_tmp21_, _tmp24_, NULL);
#line 128 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_g_free0 (rv);
#line 128 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			rv = _tmp25_;
#line 128 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
			_g_free0 (_tmp24_);
#line 1180 "Device.c"
		}
#line 131 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		result = rv;
#line 131 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		_g_object_unref0 (root);
#line 131 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		_g_free0 (uuid);
#line 131 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		_g_object_unref0 (m);
#line 131 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		return result;
#line 1192 "Device.c"
	} else {
		gchar* _tmp26_ = NULL;
#line 133 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		_tmp26_ = noise_device_get_uri (self);
#line 133 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		result = _tmp26_;
#line 133 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		_g_object_unref0 (m);
#line 133 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		return result;
#line 1203 "Device.c"
	}
#line 117 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	_g_object_unref0 (m);
#line 1207 "Device.c"
}


static void g_cclosure_user_marshal_VOID__STRING_ENUM (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_ENUM) (gpointer data1, const char* arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_ENUM callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 33 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	g_return_if_fail (n_param_values == 3);
#line 33 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 33 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		data1 = closure->data;
#line 33 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		data2 = param_values->data[0].v_pointer;
#line 1226 "Device.c"
	} else {
#line 33 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		data1 = param_values->data[0].v_pointer;
#line 33 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		data2 = closure->data;
#line 1232 "Device.c"
	}
#line 33 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	callback = (GMarshalFunc_VOID__STRING_ENUM) (marshal_data ? marshal_data : cc->callback);
#line 33 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_enum (param_values + 2), data2);
#line 1238 "Device.c"
}


static void noise_device_base_init (NoiseDeviceIface * iface) {
#line 33 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	static gboolean initialized = FALSE;
#line 33 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
	if (!initialized) {
#line 33 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		initialized = TRUE;
#line 33 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		g_signal_new ("initialized", NOISE_TYPE_DEVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, NOISE_TYPE_DEVICE);
#line 33 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		g_signal_new ("device_unmounted", NOISE_TYPE_DEVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 33 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/Device.vala"
		g_signal_new ("infobar_message", NOISE_TYPE_DEVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_ENUM, G_TYPE_NONE, 2, G_TYPE_STRING, GTK_TYPE_MESSAGE_TYPE);
#line 1255 "Device.c"
	}
}


GType noise_device_get_type (void) {
	static volatile gsize noise_device_type_id__volatile = 0;
	if (g_once_init_enter (&noise_device_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseDeviceIface), (GBaseInitFunc) noise_device_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType noise_device_type_id;
		noise_device_type_id = g_type_register_static (G_TYPE_INTERFACE, "NoiseDevice", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (noise_device_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&noise_device_type_id__volatile, noise_device_type_id);
	}
	return noise_device_type_id__volatile;
}



