/* DevicePreferences.c generated by valac 0.28.1, the Vala compiler
 * generated from DevicePreferences.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2013 Noise Developers (http://launchpad.net/noise)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Corentin Noël <tintou@mailoo.org>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


#define NOISE_TYPE_DEVICE_PREFERENCES (noise_device_preferences_get_type ())
#define NOISE_DEVICE_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_DEVICE_PREFERENCES, NoiseDevicePreferences))
#define NOISE_DEVICE_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_DEVICE_PREFERENCES, NoiseDevicePreferencesClass))
#define NOISE_IS_DEVICE_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_DEVICE_PREFERENCES))
#define NOISE_IS_DEVICE_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_DEVICE_PREFERENCES))
#define NOISE_DEVICE_PREFERENCES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_DEVICE_PREFERENCES, NoiseDevicePreferencesClass))

typedef struct _NoiseDevicePreferences NoiseDevicePreferences;
typedef struct _NoiseDevicePreferencesClass NoiseDevicePreferencesClass;
typedef struct _NoiseDevicePreferencesPrivate NoiseDevicePreferencesPrivate;

#define NOISE_TYPE_PLAYLIST (noise_playlist_get_type ())
#define NOISE_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_PLAYLIST, NoisePlaylist))
#define NOISE_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_PLAYLIST, NoisePlaylistClass))
#define NOISE_IS_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_PLAYLIST))
#define NOISE_IS_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_PLAYLIST))
#define NOISE_PLAYLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_PLAYLIST, NoisePlaylistClass))

typedef struct _NoisePlaylist NoisePlaylist;
typedef struct _NoisePlaylistClass NoisePlaylistClass;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _NoiseDevicePreferences {
	GObject parent_instance;
	NoiseDevicePreferencesPrivate * priv;
};

struct _NoiseDevicePreferencesClass {
	GObjectClass parent_class;
};

struct _NoiseDevicePreferencesPrivate {
	gchar* _id;
	gboolean _sync_when_mounted;
	gint _last_sync_time;
	gboolean _sync_music;
	gboolean _sync_podcasts;
	gboolean _sync_audiobooks;
	gboolean _sync_all_music;
	gboolean _sync_all_podcasts;
	gboolean _sync_all_audiobooks;
	NoisePlaylist* _music_playlist;
	NoisePlaylist* _podcast_playlist;
	NoisePlaylist* _audiobook_playlist;
};


static gpointer noise_device_preferences_parent_class = NULL;

GType noise_device_preferences_get_type (void) G_GNUC_CONST;
GType noise_playlist_get_type (void) G_GNUC_CONST;
#define NOISE_DEVICE_PREFERENCES_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NOISE_TYPE_DEVICE_PREFERENCES, NoiseDevicePreferencesPrivate))
enum  {
	NOISE_DEVICE_PREFERENCES_DUMMY_PROPERTY,
	NOISE_DEVICE_PREFERENCES_ID,
	NOISE_DEVICE_PREFERENCES_SYNC_WHEN_MOUNTED,
	NOISE_DEVICE_PREFERENCES_LAST_SYNC_TIME,
	NOISE_DEVICE_PREFERENCES_SYNC_MUSIC,
	NOISE_DEVICE_PREFERENCES_SYNC_PODCASTS,
	NOISE_DEVICE_PREFERENCES_SYNC_AUDIOBOOKS,
	NOISE_DEVICE_PREFERENCES_SYNC_ALL_MUSIC,
	NOISE_DEVICE_PREFERENCES_SYNC_ALL_PODCASTS,
	NOISE_DEVICE_PREFERENCES_SYNC_ALL_AUDIOBOOKS,
	NOISE_DEVICE_PREFERENCES_MUSIC_PLAYLIST,
	NOISE_DEVICE_PREFERENCES_PODCAST_PLAYLIST,
	NOISE_DEVICE_PREFERENCES_AUDIOBOOK_PLAYLIST
};
NoiseDevicePreferences* noise_device_preferences_new (const gchar* id);
NoiseDevicePreferences* noise_device_preferences_construct (GType object_type, const gchar* id);
void noise_device_preferences_set_id (NoiseDevicePreferences* self, const gchar* value);
const gchar* noise_device_preferences_get_id (NoiseDevicePreferences* self);
gboolean noise_device_preferences_get_sync_when_mounted (NoiseDevicePreferences* self);
void noise_device_preferences_set_sync_when_mounted (NoiseDevicePreferences* self, gboolean value);
gint noise_device_preferences_get_last_sync_time (NoiseDevicePreferences* self);
void noise_device_preferences_set_last_sync_time (NoiseDevicePreferences* self, gint value);
gboolean noise_device_preferences_get_sync_music (NoiseDevicePreferences* self);
void noise_device_preferences_set_sync_music (NoiseDevicePreferences* self, gboolean value);
gboolean noise_device_preferences_get_sync_podcasts (NoiseDevicePreferences* self);
void noise_device_preferences_set_sync_podcasts (NoiseDevicePreferences* self, gboolean value);
gboolean noise_device_preferences_get_sync_audiobooks (NoiseDevicePreferences* self);
void noise_device_preferences_set_sync_audiobooks (NoiseDevicePreferences* self, gboolean value);
gboolean noise_device_preferences_get_sync_all_music (NoiseDevicePreferences* self);
void noise_device_preferences_set_sync_all_music (NoiseDevicePreferences* self, gboolean value);
gboolean noise_device_preferences_get_sync_all_podcasts (NoiseDevicePreferences* self);
void noise_device_preferences_set_sync_all_podcasts (NoiseDevicePreferences* self, gboolean value);
gboolean noise_device_preferences_get_sync_all_audiobooks (NoiseDevicePreferences* self);
void noise_device_preferences_set_sync_all_audiobooks (NoiseDevicePreferences* self, gboolean value);
NoisePlaylist* noise_device_preferences_get_music_playlist (NoiseDevicePreferences* self);
void noise_device_preferences_set_music_playlist (NoiseDevicePreferences* self, NoisePlaylist* value);
NoisePlaylist* noise_device_preferences_get_podcast_playlist (NoiseDevicePreferences* self);
void noise_device_preferences_set_podcast_playlist (NoiseDevicePreferences* self, NoisePlaylist* value);
NoisePlaylist* noise_device_preferences_get_audiobook_playlist (NoiseDevicePreferences* self);
void noise_device_preferences_set_audiobook_playlist (NoiseDevicePreferences* self, NoisePlaylist* value);
static void noise_device_preferences_finalize (GObject* obj);
static void _vala_noise_device_preferences_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_noise_device_preferences_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


NoiseDevicePreferences* noise_device_preferences_construct (GType object_type, const gchar* id) {
	NoiseDevicePreferences * self = NULL;
	const gchar* _tmp0_ = NULL;
#line 50 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 50 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	self = (NoiseDevicePreferences*) g_object_new (object_type, NULL);
#line 51 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	_tmp0_ = id;
#line 51 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	noise_device_preferences_set_id (self, _tmp0_);
#line 50 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	return self;
#line 153 "DevicePreferences.c"
}


NoiseDevicePreferences* noise_device_preferences_new (const gchar* id) {
#line 50 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	return noise_device_preferences_construct (NOISE_TYPE_DEVICE_PREFERENCES, id);
#line 160 "DevicePreferences.c"
}


const gchar* noise_device_preferences_get_id (NoiseDevicePreferences* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
#line 33 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	_tmp0_ = self->priv->_id;
#line 33 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	result = _tmp0_;
#line 33 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	return result;
#line 175 "DevicePreferences.c"
}


void noise_device_preferences_set_id (NoiseDevicePreferences* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 33 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_return_if_fail (self != NULL);
#line 33 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	_tmp0_ = value;
#line 33 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 33 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	_g_free0 (self->priv->_id);
#line 33 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	self->priv->_id = _tmp1_;
#line 33 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_object_notify ((GObject *) self, "id");
#line 194 "DevicePreferences.c"
}


gboolean noise_device_preferences_get_sync_when_mounted (NoiseDevicePreferences* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 35 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 35 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	_tmp0_ = self->priv->_sync_when_mounted;
#line 35 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	result = _tmp0_;
#line 35 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	return result;
#line 209 "DevicePreferences.c"
}


void noise_device_preferences_set_sync_when_mounted (NoiseDevicePreferences* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
#line 35 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_return_if_fail (self != NULL);
#line 35 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	_tmp0_ = value;
#line 35 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	self->priv->_sync_when_mounted = _tmp0_;
#line 35 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_object_notify ((GObject *) self, "sync-when-mounted");
#line 223 "DevicePreferences.c"
}


gint noise_device_preferences_get_last_sync_time (NoiseDevicePreferences* self) {
	gint result;
	gint _tmp0_ = 0;
#line 36 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 36 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	_tmp0_ = self->priv->_last_sync_time;
#line 36 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	result = _tmp0_;
#line 36 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	return result;
#line 238 "DevicePreferences.c"
}


void noise_device_preferences_set_last_sync_time (NoiseDevicePreferences* self, gint value) {
	gint _tmp0_ = 0;
#line 36 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_return_if_fail (self != NULL);
#line 36 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	_tmp0_ = value;
#line 36 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	self->priv->_last_sync_time = _tmp0_;
#line 36 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_object_notify ((GObject *) self, "last-sync-time");
#line 252 "DevicePreferences.c"
}


gboolean noise_device_preferences_get_sync_music (NoiseDevicePreferences* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 38 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 38 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	_tmp0_ = self->priv->_sync_music;
#line 38 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	result = _tmp0_;
#line 38 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	return result;
#line 267 "DevicePreferences.c"
}


void noise_device_preferences_set_sync_music (NoiseDevicePreferences* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
#line 38 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_return_if_fail (self != NULL);
#line 38 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	_tmp0_ = value;
#line 38 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	self->priv->_sync_music = _tmp0_;
#line 38 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_object_notify ((GObject *) self, "sync-music");
#line 281 "DevicePreferences.c"
}


gboolean noise_device_preferences_get_sync_podcasts (NoiseDevicePreferences* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 39 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 39 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	_tmp0_ = self->priv->_sync_podcasts;
#line 39 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	result = _tmp0_;
#line 39 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	return result;
#line 296 "DevicePreferences.c"
}


void noise_device_preferences_set_sync_podcasts (NoiseDevicePreferences* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
#line 39 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_return_if_fail (self != NULL);
#line 39 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	_tmp0_ = value;
#line 39 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	self->priv->_sync_podcasts = _tmp0_;
#line 39 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_object_notify ((GObject *) self, "sync-podcasts");
#line 310 "DevicePreferences.c"
}


gboolean noise_device_preferences_get_sync_audiobooks (NoiseDevicePreferences* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 40 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 40 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	_tmp0_ = self->priv->_sync_audiobooks;
#line 40 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	result = _tmp0_;
#line 40 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	return result;
#line 325 "DevicePreferences.c"
}


void noise_device_preferences_set_sync_audiobooks (NoiseDevicePreferences* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
#line 40 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_return_if_fail (self != NULL);
#line 40 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	_tmp0_ = value;
#line 40 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	self->priv->_sync_audiobooks = _tmp0_;
#line 40 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_object_notify ((GObject *) self, "sync-audiobooks");
#line 339 "DevicePreferences.c"
}


gboolean noise_device_preferences_get_sync_all_music (NoiseDevicePreferences* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 42 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 42 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	_tmp0_ = self->priv->_sync_all_music;
#line 42 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	result = _tmp0_;
#line 42 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	return result;
#line 354 "DevicePreferences.c"
}


void noise_device_preferences_set_sync_all_music (NoiseDevicePreferences* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
#line 42 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_return_if_fail (self != NULL);
#line 42 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	_tmp0_ = value;
#line 42 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	self->priv->_sync_all_music = _tmp0_;
#line 42 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_object_notify ((GObject *) self, "sync-all-music");
#line 368 "DevicePreferences.c"
}


gboolean noise_device_preferences_get_sync_all_podcasts (NoiseDevicePreferences* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 43 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 43 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	_tmp0_ = self->priv->_sync_all_podcasts;
#line 43 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	result = _tmp0_;
#line 43 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	return result;
#line 383 "DevicePreferences.c"
}


void noise_device_preferences_set_sync_all_podcasts (NoiseDevicePreferences* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
#line 43 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_return_if_fail (self != NULL);
#line 43 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	_tmp0_ = value;
#line 43 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	self->priv->_sync_all_podcasts = _tmp0_;
#line 43 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_object_notify ((GObject *) self, "sync-all-podcasts");
#line 397 "DevicePreferences.c"
}


gboolean noise_device_preferences_get_sync_all_audiobooks (NoiseDevicePreferences* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	_tmp0_ = self->priv->_sync_all_audiobooks;
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	result = _tmp0_;
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	return result;
#line 412 "DevicePreferences.c"
}


void noise_device_preferences_set_sync_all_audiobooks (NoiseDevicePreferences* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_return_if_fail (self != NULL);
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	_tmp0_ = value;
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	self->priv->_sync_all_audiobooks = _tmp0_;
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_object_notify ((GObject *) self, "sync-all-audiobooks");
#line 426 "DevicePreferences.c"
}


NoisePlaylist* noise_device_preferences_get_music_playlist (NoiseDevicePreferences* self) {
	NoisePlaylist* result;
	NoisePlaylist* _tmp0_ = NULL;
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	_tmp0_ = self->priv->_music_playlist;
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	result = _tmp0_;
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	return result;
#line 441 "DevicePreferences.c"
}


void noise_device_preferences_set_music_playlist (NoiseDevicePreferences* self, NoisePlaylist* value) {
	NoisePlaylist* _tmp0_ = NULL;
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_return_if_fail (self != NULL);
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	_tmp0_ = value;
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	self->priv->_music_playlist = _tmp0_;
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_object_notify ((GObject *) self, "music-playlist");
#line 455 "DevicePreferences.c"
}


NoisePlaylist* noise_device_preferences_get_podcast_playlist (NoiseDevicePreferences* self) {
	NoisePlaylist* result;
	NoisePlaylist* _tmp0_ = NULL;
#line 47 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 47 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	_tmp0_ = self->priv->_podcast_playlist;
#line 47 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	result = _tmp0_;
#line 47 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	return result;
#line 470 "DevicePreferences.c"
}


void noise_device_preferences_set_podcast_playlist (NoiseDevicePreferences* self, NoisePlaylist* value) {
	NoisePlaylist* _tmp0_ = NULL;
#line 47 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_return_if_fail (self != NULL);
#line 47 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	_tmp0_ = value;
#line 47 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	self->priv->_podcast_playlist = _tmp0_;
#line 47 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_object_notify ((GObject *) self, "podcast-playlist");
#line 484 "DevicePreferences.c"
}


NoisePlaylist* noise_device_preferences_get_audiobook_playlist (NoiseDevicePreferences* self) {
	NoisePlaylist* result;
	NoisePlaylist* _tmp0_ = NULL;
#line 48 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	_tmp0_ = self->priv->_audiobook_playlist;
#line 48 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	result = _tmp0_;
#line 48 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	return result;
#line 499 "DevicePreferences.c"
}


void noise_device_preferences_set_audiobook_playlist (NoiseDevicePreferences* self, NoisePlaylist* value) {
	NoisePlaylist* _tmp0_ = NULL;
#line 48 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_return_if_fail (self != NULL);
#line 48 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	_tmp0_ = value;
#line 48 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	self->priv->_audiobook_playlist = _tmp0_;
#line 48 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_object_notify ((GObject *) self, "audiobook-playlist");
#line 513 "DevicePreferences.c"
}


static void noise_device_preferences_class_init (NoiseDevicePreferencesClass * klass) {
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	noise_device_preferences_parent_class = g_type_class_peek_parent (klass);
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_type_class_add_private (klass, sizeof (NoiseDevicePreferencesPrivate));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_device_preferences_get_property;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_device_preferences_set_property;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_device_preferences_finalize;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_DEVICE_PREFERENCES_ID, g_param_spec_string ("id", "id", "id", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_DEVICE_PREFERENCES_SYNC_WHEN_MOUNTED, g_param_spec_boolean ("sync-when-mounted", "sync-when-mounted", "sync-when-mounted", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_DEVICE_PREFERENCES_LAST_SYNC_TIME, g_param_spec_int ("last-sync-time", "last-sync-time", "last-sync-time", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_DEVICE_PREFERENCES_SYNC_MUSIC, g_param_spec_boolean ("sync-music", "sync-music", "sync-music", TRUE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_DEVICE_PREFERENCES_SYNC_PODCASTS, g_param_spec_boolean ("sync-podcasts", "sync-podcasts", "sync-podcasts", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_DEVICE_PREFERENCES_SYNC_AUDIOBOOKS, g_param_spec_boolean ("sync-audiobooks", "sync-audiobooks", "sync-audiobooks", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_DEVICE_PREFERENCES_SYNC_ALL_MUSIC, g_param_spec_boolean ("sync-all-music", "sync-all-music", "sync-all-music", TRUE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_DEVICE_PREFERENCES_SYNC_ALL_PODCASTS, g_param_spec_boolean ("sync-all-podcasts", "sync-all-podcasts", "sync-all-podcasts", TRUE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_DEVICE_PREFERENCES_SYNC_ALL_AUDIOBOOKS, g_param_spec_boolean ("sync-all-audiobooks", "sync-all-audiobooks", "sync-all-audiobooks", TRUE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_DEVICE_PREFERENCES_MUSIC_PLAYLIST, g_param_spec_object ("music-playlist", "music-playlist", "music-playlist", NOISE_TYPE_PLAYLIST, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_DEVICE_PREFERENCES_PODCAST_PLAYLIST, g_param_spec_object ("podcast-playlist", "podcast-playlist", "podcast-playlist", NOISE_TYPE_PLAYLIST, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_DEVICE_PREFERENCES_AUDIOBOOK_PLAYLIST, g_param_spec_object ("audiobook-playlist", "audiobook-playlist", "audiobook-playlist", NOISE_TYPE_PLAYLIST, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 552 "DevicePreferences.c"
}


static void noise_device_preferences_instance_init (NoiseDevicePreferences * self) {
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	self->priv = NOISE_DEVICE_PREFERENCES_GET_PRIVATE (self);
#line 38 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	self->priv->_sync_music = TRUE;
#line 39 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	self->priv->_sync_podcasts = FALSE;
#line 40 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	self->priv->_sync_audiobooks = FALSE;
#line 42 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	self->priv->_sync_all_music = TRUE;
#line 43 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	self->priv->_sync_all_podcasts = TRUE;
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	self->priv->_sync_all_audiobooks = TRUE;
#line 571 "DevicePreferences.c"
}


static void noise_device_preferences_finalize (GObject* obj) {
	NoiseDevicePreferences * self;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_DEVICE_PREFERENCES, NoiseDevicePreferences);
#line 33 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	_g_free0 (self->priv->_id);
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	G_OBJECT_CLASS (noise_device_preferences_parent_class)->finalize (obj);
#line 583 "DevicePreferences.c"
}


GType noise_device_preferences_get_type (void) {
	static volatile gsize noise_device_preferences_type_id__volatile = 0;
	if (g_once_init_enter (&noise_device_preferences_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseDevicePreferencesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_device_preferences_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseDevicePreferences), 0, (GInstanceInitFunc) noise_device_preferences_instance_init, NULL };
		GType noise_device_preferences_type_id;
		noise_device_preferences_type_id = g_type_register_static (G_TYPE_OBJECT, "NoiseDevicePreferences", &g_define_type_info, 0);
		g_once_init_leave (&noise_device_preferences_type_id__volatile, noise_device_preferences_type_id);
	}
	return noise_device_preferences_type_id__volatile;
}


static void _vala_noise_device_preferences_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NoiseDevicePreferences * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_DEVICE_PREFERENCES, NoiseDevicePreferences);
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	switch (property_id) {
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		case NOISE_DEVICE_PREFERENCES_ID:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		g_value_set_string (value, noise_device_preferences_get_id (self));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		break;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		case NOISE_DEVICE_PREFERENCES_SYNC_WHEN_MOUNTED:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		g_value_set_boolean (value, noise_device_preferences_get_sync_when_mounted (self));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		break;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		case NOISE_DEVICE_PREFERENCES_LAST_SYNC_TIME:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		g_value_set_int (value, noise_device_preferences_get_last_sync_time (self));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		break;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		case NOISE_DEVICE_PREFERENCES_SYNC_MUSIC:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		g_value_set_boolean (value, noise_device_preferences_get_sync_music (self));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		break;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		case NOISE_DEVICE_PREFERENCES_SYNC_PODCASTS:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		g_value_set_boolean (value, noise_device_preferences_get_sync_podcasts (self));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		break;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		case NOISE_DEVICE_PREFERENCES_SYNC_AUDIOBOOKS:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		g_value_set_boolean (value, noise_device_preferences_get_sync_audiobooks (self));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		break;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		case NOISE_DEVICE_PREFERENCES_SYNC_ALL_MUSIC:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		g_value_set_boolean (value, noise_device_preferences_get_sync_all_music (self));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		break;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		case NOISE_DEVICE_PREFERENCES_SYNC_ALL_PODCASTS:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		g_value_set_boolean (value, noise_device_preferences_get_sync_all_podcasts (self));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		break;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		case NOISE_DEVICE_PREFERENCES_SYNC_ALL_AUDIOBOOKS:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		g_value_set_boolean (value, noise_device_preferences_get_sync_all_audiobooks (self));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		break;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		case NOISE_DEVICE_PREFERENCES_MUSIC_PLAYLIST:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		g_value_set_object (value, noise_device_preferences_get_music_playlist (self));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		break;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		case NOISE_DEVICE_PREFERENCES_PODCAST_PLAYLIST:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		g_value_set_object (value, noise_device_preferences_get_podcast_playlist (self));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		break;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		case NOISE_DEVICE_PREFERENCES_AUDIOBOOK_PLAYLIST:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		g_value_set_object (value, noise_device_preferences_get_audiobook_playlist (self));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		break;
#line 676 "DevicePreferences.c"
		default:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		break;
#line 682 "DevicePreferences.c"
	}
}


static void _vala_noise_device_preferences_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	NoiseDevicePreferences * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_DEVICE_PREFERENCES, NoiseDevicePreferences);
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
	switch (property_id) {
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		case NOISE_DEVICE_PREFERENCES_ID:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		noise_device_preferences_set_id (self, g_value_get_string (value));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		break;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		case NOISE_DEVICE_PREFERENCES_SYNC_WHEN_MOUNTED:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		noise_device_preferences_set_sync_when_mounted (self, g_value_get_boolean (value));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		break;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		case NOISE_DEVICE_PREFERENCES_LAST_SYNC_TIME:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		noise_device_preferences_set_last_sync_time (self, g_value_get_int (value));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		break;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		case NOISE_DEVICE_PREFERENCES_SYNC_MUSIC:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		noise_device_preferences_set_sync_music (self, g_value_get_boolean (value));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		break;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		case NOISE_DEVICE_PREFERENCES_SYNC_PODCASTS:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		noise_device_preferences_set_sync_podcasts (self, g_value_get_boolean (value));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		break;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		case NOISE_DEVICE_PREFERENCES_SYNC_AUDIOBOOKS:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		noise_device_preferences_set_sync_audiobooks (self, g_value_get_boolean (value));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		break;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		case NOISE_DEVICE_PREFERENCES_SYNC_ALL_MUSIC:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		noise_device_preferences_set_sync_all_music (self, g_value_get_boolean (value));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		break;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		case NOISE_DEVICE_PREFERENCES_SYNC_ALL_PODCASTS:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		noise_device_preferences_set_sync_all_podcasts (self, g_value_get_boolean (value));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		break;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		case NOISE_DEVICE_PREFERENCES_SYNC_ALL_AUDIOBOOKS:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		noise_device_preferences_set_sync_all_audiobooks (self, g_value_get_boolean (value));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		break;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		case NOISE_DEVICE_PREFERENCES_MUSIC_PLAYLIST:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		noise_device_preferences_set_music_playlist (self, g_value_get_object (value));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		break;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		case NOISE_DEVICE_PREFERENCES_PODCAST_PLAYLIST:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		noise_device_preferences_set_podcast_playlist (self, g_value_get_object (value));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		break;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		case NOISE_DEVICE_PREFERENCES_AUDIOBOOK_PLAYLIST:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		noise_device_preferences_set_audiobook_playlist (self, g_value_get_object (value));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		break;
#line 764 "DevicePreferences.c"
		default:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Devices/DevicePreferences.vala"
		break;
#line 770 "DevicePreferences.c"
	}
}



