/* SmartQuery.c generated by valac 0.28.1, the Vala compiler
 * generated from SmartQuery.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2013 Noise Developers (http://launchpad.net/noise)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Corentin Noël <tintou@mailoo.org>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


#define NOISE_TYPE_SMART_QUERY (noise_smart_query_get_type ())
#define NOISE_SMART_QUERY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_SMART_QUERY, NoiseSmartQuery))
#define NOISE_SMART_QUERY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_SMART_QUERY, NoiseSmartQueryClass))
#define NOISE_IS_SMART_QUERY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_SMART_QUERY))
#define NOISE_IS_SMART_QUERY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_SMART_QUERY))
#define NOISE_SMART_QUERY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_SMART_QUERY, NoiseSmartQueryClass))

typedef struct _NoiseSmartQuery NoiseSmartQuery;
typedef struct _NoiseSmartQueryClass NoiseSmartQueryClass;
typedef struct _NoiseSmartQueryPrivate NoiseSmartQueryPrivate;

#define NOISE_SMART_QUERY_TYPE_FIELD_TYPE (noise_smart_query_field_type_get_type ())

#define NOISE_SMART_QUERY_TYPE_COMPARATOR_TYPE (noise_smart_query_comparator_type_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))

struct _NoiseSmartQuery {
	GObject parent_instance;
	NoiseSmartQueryPrivate * priv;
};

struct _NoiseSmartQueryClass {
	GObjectClass parent_class;
};

typedef enum  {
	NOISE_SMART_QUERY_FIELD_TYPE_ALBUM,
	NOISE_SMART_QUERY_FIELD_TYPE_ARTIST,
	NOISE_SMART_QUERY_FIELD_TYPE_BITRATE,
	NOISE_SMART_QUERY_FIELD_TYPE_COMMENT,
	NOISE_SMART_QUERY_FIELD_TYPE_COMPOSER,
	NOISE_SMART_QUERY_FIELD_TYPE_DATE_ADDED,
	NOISE_SMART_QUERY_FIELD_TYPE_DATE_RELEASED,
	NOISE_SMART_QUERY_FIELD_TYPE_GENRE,
	NOISE_SMART_QUERY_FIELD_TYPE_GROUPING,
	NOISE_SMART_QUERY_FIELD_TYPE_LAST_PLAYED,
	NOISE_SMART_QUERY_FIELD_TYPE_LENGTH,
	NOISE_SMART_QUERY_FIELD_TYPE_PLAYCOUNT,
	NOISE_SMART_QUERY_FIELD_TYPE_RATING,
	NOISE_SMART_QUERY_FIELD_TYPE_SKIPCOUNT,
	NOISE_SMART_QUERY_FIELD_TYPE_TITLE,
	NOISE_SMART_QUERY_FIELD_TYPE_YEAR
} NoiseSmartQueryFieldType;

typedef enum  {
	NOISE_SMART_QUERY_COMPARATOR_TYPE_IS,
	NOISE_SMART_QUERY_COMPARATOR_TYPE_IS_NOT,
	NOISE_SMART_QUERY_COMPARATOR_TYPE_CONTAINS,
	NOISE_SMART_QUERY_COMPARATOR_TYPE_NOT_CONTAINS,
	NOISE_SMART_QUERY_COMPARATOR_TYPE_IS_EXACTLY,
	NOISE_SMART_QUERY_COMPARATOR_TYPE_IS_AT_MOST,
	NOISE_SMART_QUERY_COMPARATOR_TYPE_IS_AT_LEAST,
	NOISE_SMART_QUERY_COMPARATOR_TYPE_IS_WITHIN,
	NOISE_SMART_QUERY_COMPARATOR_TYPE_IS_BEFORE
} NoiseSmartQueryComparatorType;

struct _NoiseSmartQueryPrivate {
	gint _rowid;
	NoiseSmartQueryFieldType _field;
	NoiseSmartQueryComparatorType _comparator;
	gchar* _value;
};


static gpointer noise_smart_query_parent_class = NULL;

GType noise_smart_query_get_type (void) G_GNUC_CONST;
GType noise_smart_query_field_type_get_type (void) G_GNUC_CONST;
GType noise_smart_query_comparator_type_get_type (void) G_GNUC_CONST;
#define NOISE_SMART_QUERY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NOISE_TYPE_SMART_QUERY, NoiseSmartQueryPrivate))
enum  {
	NOISE_SMART_QUERY_DUMMY_PROPERTY,
	NOISE_SMART_QUERY_ROWID,
	NOISE_SMART_QUERY_FIELD,
	NOISE_SMART_QUERY_COMPARATOR,
	NOISE_SMART_QUERY_VALUE
};
NoiseSmartQuery* noise_smart_query_new (void);
NoiseSmartQuery* noise_smart_query_construct (GType object_type);
NoiseSmartQuery* noise_smart_query_new_with_info (NoiseSmartQueryFieldType field, NoiseSmartQueryComparatorType comparator, const gchar* value);
NoiseSmartQuery* noise_smart_query_construct_with_info (GType object_type, NoiseSmartQueryFieldType field, NoiseSmartQueryComparatorType comparator, const gchar* value);
void noise_smart_query_set_field (NoiseSmartQuery* self, NoiseSmartQueryFieldType value);
void noise_smart_query_set_comparator (NoiseSmartQuery* self, NoiseSmartQueryComparatorType value);
void noise_smart_query_set_value (NoiseSmartQuery* self, const gchar* value);
gint noise_smart_query_get_rowid (NoiseSmartQuery* self);
void noise_smart_query_set_rowid (NoiseSmartQuery* self, gint value);
NoiseSmartQueryFieldType noise_smart_query_get_field (NoiseSmartQuery* self);
NoiseSmartQueryComparatorType noise_smart_query_get_comparator (NoiseSmartQuery* self);
const gchar* noise_smart_query_get_value (NoiseSmartQuery* self);
static void noise_smart_query_finalize (GObject* obj);
static void _vala_noise_smart_query_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_noise_smart_query_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GType noise_smart_query_comparator_type_get_type (void) {
	static volatile gsize noise_smart_query_comparator_type_type_id__volatile = 0;
	if (g_once_init_enter (&noise_smart_query_comparator_type_type_id__volatile)) {
		static const GEnumValue values[] = {{NOISE_SMART_QUERY_COMPARATOR_TYPE_IS, "NOISE_SMART_QUERY_COMPARATOR_TYPE_IS", "is"}, {NOISE_SMART_QUERY_COMPARATOR_TYPE_IS_NOT, "NOISE_SMART_QUERY_COMPARATOR_TYPE_IS_NOT", "is-not"}, {NOISE_SMART_QUERY_COMPARATOR_TYPE_CONTAINS, "NOISE_SMART_QUERY_COMPARATOR_TYPE_CONTAINS", "contains"}, {NOISE_SMART_QUERY_COMPARATOR_TYPE_NOT_CONTAINS, "NOISE_SMART_QUERY_COMPARATOR_TYPE_NOT_CONTAINS", "not-contains"}, {NOISE_SMART_QUERY_COMPARATOR_TYPE_IS_EXACTLY, "NOISE_SMART_QUERY_COMPARATOR_TYPE_IS_EXACTLY", "is-exactly"}, {NOISE_SMART_QUERY_COMPARATOR_TYPE_IS_AT_MOST, "NOISE_SMART_QUERY_COMPARATOR_TYPE_IS_AT_MOST", "is-at-most"}, {NOISE_SMART_QUERY_COMPARATOR_TYPE_IS_AT_LEAST, "NOISE_SMART_QUERY_COMPARATOR_TYPE_IS_AT_LEAST", "is-at-least"}, {NOISE_SMART_QUERY_COMPARATOR_TYPE_IS_WITHIN, "NOISE_SMART_QUERY_COMPARATOR_TYPE_IS_WITHIN", "is-within"}, {NOISE_SMART_QUERY_COMPARATOR_TYPE_IS_BEFORE, "NOISE_SMART_QUERY_COMPARATOR_TYPE_IS_BEFORE", "is-before"}, {0, NULL, NULL}};
		GType noise_smart_query_comparator_type_type_id;
		noise_smart_query_comparator_type_type_id = g_enum_register_static ("NoiseSmartQueryComparatorType", values);
		g_once_init_leave (&noise_smart_query_comparator_type_type_id__volatile, noise_smart_query_comparator_type_type_id);
	}
	return noise_smart_query_comparator_type_type_id__volatile;
}


GType noise_smart_query_field_type_get_type (void) {
	static volatile gsize noise_smart_query_field_type_type_id__volatile = 0;
	if (g_once_init_enter (&noise_smart_query_field_type_type_id__volatile)) {
		static const GEnumValue values[] = {{NOISE_SMART_QUERY_FIELD_TYPE_ALBUM, "NOISE_SMART_QUERY_FIELD_TYPE_ALBUM", "album"}, {NOISE_SMART_QUERY_FIELD_TYPE_ARTIST, "NOISE_SMART_QUERY_FIELD_TYPE_ARTIST", "artist"}, {NOISE_SMART_QUERY_FIELD_TYPE_BITRATE, "NOISE_SMART_QUERY_FIELD_TYPE_BITRATE", "bitrate"}, {NOISE_SMART_QUERY_FIELD_TYPE_COMMENT, "NOISE_SMART_QUERY_FIELD_TYPE_COMMENT", "comment"}, {NOISE_SMART_QUERY_FIELD_TYPE_COMPOSER, "NOISE_SMART_QUERY_FIELD_TYPE_COMPOSER", "composer"}, {NOISE_SMART_QUERY_FIELD_TYPE_DATE_ADDED, "NOISE_SMART_QUERY_FIELD_TYPE_DATE_ADDED", "date-added"}, {NOISE_SMART_QUERY_FIELD_TYPE_DATE_RELEASED, "NOISE_SMART_QUERY_FIELD_TYPE_DATE_RELEASED", "date-released"}, {NOISE_SMART_QUERY_FIELD_TYPE_GENRE, "NOISE_SMART_QUERY_FIELD_TYPE_GENRE", "genre"}, {NOISE_SMART_QUERY_FIELD_TYPE_GROUPING, "NOISE_SMART_QUERY_FIELD_TYPE_GROUPING", "grouping"}, {NOISE_SMART_QUERY_FIELD_TYPE_LAST_PLAYED, "NOISE_SMART_QUERY_FIELD_TYPE_LAST_PLAYED", "last-played"}, {NOISE_SMART_QUERY_FIELD_TYPE_LENGTH, "NOISE_SMART_QUERY_FIELD_TYPE_LENGTH", "length"}, {NOISE_SMART_QUERY_FIELD_TYPE_PLAYCOUNT, "NOISE_SMART_QUERY_FIELD_TYPE_PLAYCOUNT", "playcount"}, {NOISE_SMART_QUERY_FIELD_TYPE_RATING, "NOISE_SMART_QUERY_FIELD_TYPE_RATING", "rating"}, {NOISE_SMART_QUERY_FIELD_TYPE_SKIPCOUNT, "NOISE_SMART_QUERY_FIELD_TYPE_SKIPCOUNT", "skipcount"}, {NOISE_SMART_QUERY_FIELD_TYPE_TITLE, "NOISE_SMART_QUERY_FIELD_TYPE_TITLE", "title"}, {NOISE_SMART_QUERY_FIELD_TYPE_YEAR, "NOISE_SMART_QUERY_FIELD_TYPE_YEAR", "year"}, {0, NULL, NULL}};
		GType noise_smart_query_field_type_type_id;
		noise_smart_query_field_type_type_id = g_enum_register_static ("NoiseSmartQueryFieldType", values);
		g_once_init_leave (&noise_smart_query_field_type_type_id__volatile, noise_smart_query_field_type_type_id);
	}
	return noise_smart_query_field_type_type_id__volatile;
}


NoiseSmartQuery* noise_smart_query_construct (GType object_type) {
	NoiseSmartQuery * self = NULL;
#line 70 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	self = (NoiseSmartQuery*) g_object_new (object_type, NULL);
#line 70 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	return self;
#line 166 "SmartQuery.c"
}


NoiseSmartQuery* noise_smart_query_new (void) {
#line 70 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	return noise_smart_query_construct (NOISE_TYPE_SMART_QUERY);
#line 173 "SmartQuery.c"
}


NoiseSmartQuery* noise_smart_query_construct_with_info (GType object_type, NoiseSmartQueryFieldType field, NoiseSmartQueryComparatorType comparator, const gchar* value) {
	NoiseSmartQuery * self = NULL;
	NoiseSmartQueryFieldType _tmp0_ = 0;
	NoiseSmartQueryComparatorType _tmp1_ = 0;
	const gchar* _tmp2_ = NULL;
#line 74 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 74 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	self = (NoiseSmartQuery*) g_object_new (object_type, NULL);
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	_tmp0_ = field;
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	noise_smart_query_set_field (self, _tmp0_);
#line 76 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	_tmp1_ = comparator;
#line 76 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	noise_smart_query_set_comparator (self, _tmp1_);
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	_tmp2_ = value;
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	noise_smart_query_set_value (self, _tmp2_);
#line 74 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	return self;
#line 200 "SmartQuery.c"
}


NoiseSmartQuery* noise_smart_query_new_with_info (NoiseSmartQueryFieldType field, NoiseSmartQueryComparatorType comparator, const gchar* value) {
#line 74 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	return noise_smart_query_construct_with_info (NOISE_TYPE_SMART_QUERY, field, comparator, value);
#line 207 "SmartQuery.c"
}


gint noise_smart_query_get_rowid (NoiseSmartQuery* self) {
	gint result;
	gint _tmp0_ = 0;
#line 65 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 65 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	_tmp0_ = self->priv->_rowid;
#line 65 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	result = _tmp0_;
#line 65 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	return result;
#line 222 "SmartQuery.c"
}


void noise_smart_query_set_rowid (NoiseSmartQuery* self, gint value) {
	gint _tmp0_ = 0;
#line 65 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	g_return_if_fail (self != NULL);
#line 65 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	_tmp0_ = value;
#line 65 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	self->priv->_rowid = _tmp0_;
#line 65 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	g_object_notify ((GObject *) self, "rowid");
#line 236 "SmartQuery.c"
}


NoiseSmartQueryFieldType noise_smart_query_get_field (NoiseSmartQuery* self) {
	NoiseSmartQueryFieldType result;
	NoiseSmartQueryFieldType _tmp0_ = 0;
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	_tmp0_ = self->priv->_field;
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	result = _tmp0_;
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	return result;
#line 251 "SmartQuery.c"
}


void noise_smart_query_set_field (NoiseSmartQuery* self, NoiseSmartQueryFieldType value) {
	NoiseSmartQueryFieldType _tmp0_ = 0;
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	g_return_if_fail (self != NULL);
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	_tmp0_ = value;
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	self->priv->_field = _tmp0_;
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	g_object_notify ((GObject *) self, "field");
#line 265 "SmartQuery.c"
}


NoiseSmartQueryComparatorType noise_smart_query_get_comparator (NoiseSmartQuery* self) {
	NoiseSmartQueryComparatorType result;
	NoiseSmartQueryComparatorType _tmp0_ = 0;
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	_tmp0_ = self->priv->_comparator;
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	result = _tmp0_;
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	return result;
#line 280 "SmartQuery.c"
}


void noise_smart_query_set_comparator (NoiseSmartQuery* self, NoiseSmartQueryComparatorType value) {
	NoiseSmartQueryComparatorType _tmp0_ = 0;
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	g_return_if_fail (self != NULL);
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	_tmp0_ = value;
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	self->priv->_comparator = _tmp0_;
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	g_object_notify ((GObject *) self, "comparator");
#line 294 "SmartQuery.c"
}


const gchar* noise_smart_query_get_value (NoiseSmartQuery* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
#line 68 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 68 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	_tmp0_ = self->priv->_value;
#line 68 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	result = _tmp0_;
#line 68 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	return result;
#line 309 "SmartQuery.c"
}


void noise_smart_query_set_value (NoiseSmartQuery* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 68 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	g_return_if_fail (self != NULL);
#line 68 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	_tmp0_ = value;
#line 68 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 68 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	_g_free0 (self->priv->_value);
#line 68 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	self->priv->_value = _tmp1_;
#line 68 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	g_object_notify ((GObject *) self, "value");
#line 328 "SmartQuery.c"
}


static void noise_smart_query_class_init (NoiseSmartQueryClass * klass) {
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	noise_smart_query_parent_class = g_type_class_peek_parent (klass);
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	g_type_class_add_private (klass, sizeof (NoiseSmartQueryPrivate));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_smart_query_get_property;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_smart_query_set_property;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_smart_query_finalize;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_SMART_QUERY_ROWID, g_param_spec_int ("rowid", "rowid", "rowid", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_SMART_QUERY_FIELD, g_param_spec_enum ("field", "field", "field", NOISE_SMART_QUERY_TYPE_FIELD_TYPE, NOISE_SMART_QUERY_FIELD_TYPE_ALBUM, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_SMART_QUERY_COMPARATOR, g_param_spec_enum ("comparator", "comparator", "comparator", NOISE_SMART_QUERY_TYPE_COMPARATOR_TYPE, NOISE_SMART_QUERY_COMPARATOR_TYPE_IS, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_SMART_QUERY_VALUE, g_param_spec_string ("value", "value", "value", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 351 "SmartQuery.c"
}


static void noise_smart_query_instance_init (NoiseSmartQuery * self) {
	gchar* _tmp0_ = NULL;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	self->priv = NOISE_SMART_QUERY_GET_PRIVATE (self);
#line 65 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	self->priv->_rowid = 0;
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	self->priv->_field = NOISE_SMART_QUERY_FIELD_TYPE_ALBUM;
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	self->priv->_comparator = NOISE_SMART_QUERY_COMPARATOR_TYPE_IS;
#line 68 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	_tmp0_ = g_strdup ("");
#line 68 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	self->priv->_value = _tmp0_;
#line 369 "SmartQuery.c"
}


static void noise_smart_query_finalize (GObject* obj) {
	NoiseSmartQuery * self;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_SMART_QUERY, NoiseSmartQuery);
#line 68 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	_g_free0 (self->priv->_value);
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	G_OBJECT_CLASS (noise_smart_query_parent_class)->finalize (obj);
#line 381 "SmartQuery.c"
}


GType noise_smart_query_get_type (void) {
	static volatile gsize noise_smart_query_type_id__volatile = 0;
	if (g_once_init_enter (&noise_smart_query_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseSmartQueryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_smart_query_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseSmartQuery), 0, (GInstanceInitFunc) noise_smart_query_instance_init, NULL };
		GType noise_smart_query_type_id;
		noise_smart_query_type_id = g_type_register_static (G_TYPE_OBJECT, "NoiseSmartQuery", &g_define_type_info, 0);
		g_once_init_leave (&noise_smart_query_type_id__volatile, noise_smart_query_type_id);
	}
	return noise_smart_query_type_id__volatile;
}


static void _vala_noise_smart_query_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NoiseSmartQuery * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_SMART_QUERY, NoiseSmartQuery);
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	switch (property_id) {
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
		case NOISE_SMART_QUERY_ROWID:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
		g_value_set_int (value, noise_smart_query_get_rowid (self));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
		break;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
		case NOISE_SMART_QUERY_FIELD:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
		g_value_set_enum (value, noise_smart_query_get_field (self));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
		break;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
		case NOISE_SMART_QUERY_COMPARATOR:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
		g_value_set_enum (value, noise_smart_query_get_comparator (self));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
		break;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
		case NOISE_SMART_QUERY_VALUE:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
		g_value_set_string (value, noise_smart_query_get_value (self));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
		break;
#line 426 "SmartQuery.c"
		default:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
		break;
#line 432 "SmartQuery.c"
	}
}


static void _vala_noise_smart_query_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	NoiseSmartQuery * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_SMART_QUERY, NoiseSmartQuery);
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
	switch (property_id) {
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
		case NOISE_SMART_QUERY_ROWID:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
		noise_smart_query_set_rowid (self, g_value_get_int (value));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
		break;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
		case NOISE_SMART_QUERY_FIELD:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
		noise_smart_query_set_field (self, g_value_get_enum (value));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
		break;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
		case NOISE_SMART_QUERY_COMPARATOR:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
		noise_smart_query_set_comparator (self, g_value_get_enum (value));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
		break;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
		case NOISE_SMART_QUERY_VALUE:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
		noise_smart_query_set_value (self, g_value_get_string (value));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
		break;
#line 466 "SmartQuery.c"
		default:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/SmartQuery.vala"
		break;
#line 472 "SmartQuery.c"
	}
}



