/* StaticPlaylist.c generated by valac 0.28.1, the Vala compiler
 * generated from StaticPlaylist.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2013 Noise Developers (http://launchpad.net/noise)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Corentin Noël <tintou@mailoo.org>
 */

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>


#define NOISE_TYPE_PLAYLIST (noise_playlist_get_type ())
#define NOISE_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_PLAYLIST, NoisePlaylist))
#define NOISE_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_PLAYLIST, NoisePlaylistClass))
#define NOISE_IS_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_PLAYLIST))
#define NOISE_IS_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_PLAYLIST))
#define NOISE_PLAYLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_PLAYLIST, NoisePlaylistClass))

typedef struct _NoisePlaylist NoisePlaylist;
typedef struct _NoisePlaylistClass NoisePlaylistClass;
typedef struct _NoisePlaylistPrivate NoisePlaylistPrivate;

#define NOISE_TYPE_MEDIA (noise_media_get_type ())
#define NOISE_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_MEDIA, NoiseMedia))
#define NOISE_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_MEDIA, NoiseMediaClass))
#define NOISE_IS_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_MEDIA))
#define NOISE_IS_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_MEDIA))
#define NOISE_MEDIA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_MEDIA, NoiseMediaClass))

typedef struct _NoiseMedia NoiseMedia;
typedef struct _NoiseMediaClass NoiseMediaClass;

#define NOISE_TYPE_STATIC_PLAYLIST (noise_static_playlist_get_type ())
#define NOISE_STATIC_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_STATIC_PLAYLIST, NoiseStaticPlaylist))
#define NOISE_STATIC_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_STATIC_PLAYLIST, NoiseStaticPlaylistClass))
#define NOISE_IS_STATIC_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_STATIC_PLAYLIST))
#define NOISE_IS_STATIC_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_STATIC_PLAYLIST))
#define NOISE_STATIC_PLAYLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_STATIC_PLAYLIST, NoiseStaticPlaylistClass))

typedef struct _NoiseStaticPlaylist NoiseStaticPlaylist;
typedef struct _NoiseStaticPlaylistClass NoiseStaticPlaylistClass;
typedef struct _NoiseStaticPlaylistPrivate NoiseStaticPlaylistPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define NOISE_TYPE_ICON (noise_icon_get_type ())
#define NOISE_ICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_ICON, NoiseIcon))
#define NOISE_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_ICON, NoiseIconClass))
#define NOISE_IS_ICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_ICON))
#define NOISE_IS_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_ICON))
#define NOISE_ICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_ICON, NoiseIconClass))

typedef struct _NoiseIcon NoiseIcon;
typedef struct _NoiseIconClass NoiseIconClass;

struct _NoisePlaylist {
	GObject parent_instance;
	NoisePlaylistPrivate * priv;
	GIcon* icon;
};

struct _NoisePlaylistClass {
	GObjectClass parent_class;
	void (*add_media) (NoisePlaylist* self, NoiseMedia* to_remove);
	void (*add_medias) (NoisePlaylist* self, GeeCollection* to_add);
	void (*remove_media) (NoisePlaylist* self, NoiseMedia* to_remove);
	void (*remove_medias) (NoisePlaylist* self, GeeCollection* to_remove);
	void (*clear) (NoisePlaylist* self);
	GeeArrayQueue* (*get_medias) (NoisePlaylist* self);
	void (*set_medias) (NoisePlaylist* self, GeeArrayQueue* value);
};

struct _NoiseStaticPlaylist {
	NoisePlaylist parent_instance;
	NoiseStaticPlaylistPrivate * priv;
};

struct _NoiseStaticPlaylistClass {
	NoisePlaylistClass parent_class;
};

struct _NoiseStaticPlaylistPrivate {
	gboolean _read_only;
	gboolean _show_badge;
	gboolean _allow_duplicate;
};


static gpointer noise_static_playlist_parent_class = NULL;

GType noise_playlist_get_type (void) G_GNUC_CONST;
GType noise_media_get_type (void) G_GNUC_CONST;
GType noise_static_playlist_get_type (void) G_GNUC_CONST;
#define NOISE_STATIC_PLAYLIST_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NOISE_TYPE_STATIC_PLAYLIST, NoiseStaticPlaylistPrivate))
enum  {
	NOISE_STATIC_PLAYLIST_DUMMY_PROPERTY,
	NOISE_STATIC_PLAYLIST_READ_ONLY,
	NOISE_STATIC_PLAYLIST_SHOW_BADGE,
	NOISE_STATIC_PLAYLIST_ALLOW_DUPLICATE
};
NoiseStaticPlaylist* noise_static_playlist_new (void);
NoiseStaticPlaylist* noise_static_playlist_construct (GType object_type);
NoisePlaylist* noise_playlist_construct (GType object_type);
void noise_playlist_set_name (NoisePlaylist* self, const gchar* value);
void noise_playlist_set_medias (NoisePlaylist* self, GeeArrayQueue* value);
GType noise_icon_get_type (void) G_GNUC_CONST;
NoiseIcon* noise_icons_get_PLAYLIST (void);
GIcon* noise_icon_get_gicon (NoiseIcon* self);
NoiseStaticPlaylist* noise_static_playlist_new_with_info (gint rowid, const gchar* name);
NoiseStaticPlaylist* noise_static_playlist_construct_with_info (GType object_type, gint rowid, const gchar* name);
void noise_playlist_set_rowid (NoisePlaylist* self, gint value);
static void noise_static_playlist_real_add_media (NoisePlaylist* base, NoiseMedia* m);
gboolean noise_static_playlist_get_allow_duplicate (NoiseStaticPlaylist* self);
GeeArrayQueue* noise_playlist_get_medias (NoisePlaylist* self);
static void noise_static_playlist_real_add_medias (NoisePlaylist* base, GeeCollection* to_add);
static void noise_static_playlist_real_remove_media (NoisePlaylist* base, NoiseMedia* to_remove);
static void noise_static_playlist_real_remove_medias (NoisePlaylist* base, GeeCollection* to_remove);
static void noise_static_playlist_real_clear (NoisePlaylist* base);
gboolean noise_static_playlist_get_read_only (NoiseStaticPlaylist* self);
void noise_static_playlist_set_read_only (NoiseStaticPlaylist* self, gboolean value);
gboolean noise_static_playlist_get_show_badge (NoiseStaticPlaylist* self);
void noise_static_playlist_set_show_badge (NoiseStaticPlaylist* self, gboolean value);
void noise_static_playlist_set_allow_duplicate (NoiseStaticPlaylist* self, gboolean value);
static void noise_static_playlist_finalize (GObject* obj);
static void _vala_noise_static_playlist_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_noise_static_playlist_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static gpointer _g_object_ref0 (gpointer self) {
#line 40 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	return self ? g_object_ref (self) : NULL;
#line 163 "StaticPlaylist.c"
}


NoiseStaticPlaylist* noise_static_playlist_construct (GType object_type) {
	NoiseStaticPlaylist * self = NULL;
	GeeArrayQueue* _tmp0_ = NULL;
	GeeArrayQueue* _tmp1_ = NULL;
	NoiseIcon* _tmp2_ = NULL;
	NoiseIcon* _tmp3_ = NULL;
	GIcon* _tmp4_ = NULL;
	GIcon* _tmp5_ = NULL;
	GIcon* _tmp6_ = NULL;
#line 37 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	self = (NoiseStaticPlaylist*) noise_playlist_construct (object_type);
#line 38 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	noise_playlist_set_name ((NoisePlaylist*) self, "");
#line 39 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	_tmp0_ = gee_array_queue_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 39 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	_tmp1_ = _tmp0_;
#line 39 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	noise_playlist_set_medias ((NoisePlaylist*) self, _tmp1_);
#line 39 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	_g_object_unref0 (_tmp1_);
#line 40 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	_tmp2_ = noise_icons_get_PLAYLIST ();
#line 40 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	_tmp3_ = _tmp2_;
#line 40 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	_tmp4_ = noise_icon_get_gicon (_tmp3_);
#line 40 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	_tmp5_ = _tmp4_;
#line 40 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 40 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	_g_object_unref0 (((NoisePlaylist*) self)->icon);
#line 40 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	((NoisePlaylist*) self)->icon = _tmp6_;
#line 37 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	return self;
#line 204 "StaticPlaylist.c"
}


NoiseStaticPlaylist* noise_static_playlist_new (void) {
#line 37 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	return noise_static_playlist_construct (NOISE_TYPE_STATIC_PLAYLIST);
#line 211 "StaticPlaylist.c"
}


NoiseStaticPlaylist* noise_static_playlist_construct_with_info (GType object_type, gint rowid, const gchar* name) {
	NoiseStaticPlaylist * self = NULL;
	gint _tmp0_ = 0;
	const gchar* _tmp1_ = NULL;
#line 43 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	self = (NoiseStaticPlaylist*) noise_playlist_construct (object_type);
#line 45 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	_tmp0_ = rowid;
#line 45 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	noise_playlist_set_rowid ((NoisePlaylist*) self, _tmp0_);
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	_tmp1_ = name;
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	noise_playlist_set_name ((NoisePlaylist*) self, _tmp1_);
#line 43 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	return self;
#line 233 "StaticPlaylist.c"
}


NoiseStaticPlaylist* noise_static_playlist_new_with_info (gint rowid, const gchar* name) {
#line 43 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	return noise_static_playlist_construct_with_info (NOISE_TYPE_STATIC_PLAYLIST, rowid, name);
#line 240 "StaticPlaylist.c"
}


static void noise_static_playlist_real_add_media (NoisePlaylist* base, NoiseMedia* m) {
	NoiseStaticPlaylist * self;
	GeeLinkedList* added_media = NULL;
	GeeLinkedList* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 49 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	self = (NoiseStaticPlaylist*) base;
#line 49 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	g_return_if_fail (m != NULL);
#line 50 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	_tmp0_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 50 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	added_media = _tmp0_;
#line 51 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	_tmp2_ = self->priv->_allow_duplicate;
#line 51 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	if (_tmp2_) {
#line 51 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		_tmp1_ = TRUE;
#line 264 "StaticPlaylist.c"
	} else {
		GeeArrayQueue* _tmp3_ = NULL;
		GeeArrayQueue* _tmp4_ = NULL;
		NoiseMedia* _tmp5_ = NULL;
		gboolean _tmp6_ = FALSE;
#line 51 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		_tmp3_ = noise_playlist_get_medias ((NoisePlaylist*) self);
#line 51 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		_tmp4_ = _tmp3_;
#line 51 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		_tmp5_ = m;
#line 51 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		_tmp6_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp4_, _tmp5_);
#line 51 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		_tmp1_ = _tmp6_ == FALSE;
#line 280 "StaticPlaylist.c"
	}
#line 51 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	if (_tmp1_) {
#line 284 "StaticPlaylist.c"
		GeeArrayQueue* _tmp7_ = NULL;
		GeeArrayQueue* _tmp8_ = NULL;
		NoiseMedia* _tmp9_ = NULL;
		GeeLinkedList* _tmp10_ = NULL;
		NoiseMedia* _tmp11_ = NULL;
		GeeLinkedList* _tmp12_ = NULL;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		_tmp7_ = noise_playlist_get_medias ((NoisePlaylist*) self);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		_tmp8_ = _tmp7_;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		_tmp9_ = m;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp8_, _tmp9_);
#line 53 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		_tmp10_ = added_media;
#line 53 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		_tmp11_ = m;
#line 53 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp11_);
#line 54 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		_tmp12_ = added_media;
#line 54 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		g_signal_emit_by_name ((NoisePlaylist*) self, "media-added", (GeeCollection*) _tmp12_);
#line 309 "StaticPlaylist.c"
	}
#line 57 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	g_signal_emit_by_name ((NoisePlaylist*) self, "updated", NULL);
#line 49 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	_g_object_unref0 (added_media);
#line 315 "StaticPlaylist.c"
}


static void noise_static_playlist_real_add_medias (NoisePlaylist* base, GeeCollection* to_add) {
	NoiseStaticPlaylist * self;
	GeeLinkedList* added_media = NULL;
	GeeLinkedList* _tmp0_ = NULL;
	GeeLinkedList* _tmp18_ = NULL;
#line 60 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	self = (NoiseStaticPlaylist*) base;
#line 60 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	g_return_if_fail (to_add != NULL);
#line 61 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	_tmp0_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 61 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	added_media = _tmp0_;
#line 332 "StaticPlaylist.c"
	{
		GeeIterator* _m_it = NULL;
		GeeCollection* _tmp1_ = NULL;
		GeeIterator* _tmp2_ = NULL;
#line 62 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		_tmp1_ = to_add;
#line 62 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 62 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		_m_it = _tmp2_;
#line 62 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		while (TRUE) {
#line 345 "StaticPlaylist.c"
			GeeIterator* _tmp3_ = NULL;
			gboolean _tmp4_ = FALSE;
			NoiseMedia* m = NULL;
			GeeIterator* _tmp5_ = NULL;
			gpointer _tmp6_ = NULL;
			gboolean _tmp7_ = FALSE;
			gboolean _tmp8_ = FALSE;
#line 62 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
			_tmp3_ = _m_it;
#line 62 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
			_tmp4_ = gee_iterator_next (_tmp3_);
#line 62 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
			if (!_tmp4_) {
#line 62 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
				break;
#line 361 "StaticPlaylist.c"
			}
#line 62 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
			_tmp5_ = _m_it;
#line 62 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 62 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
			m = (NoiseMedia*) _tmp6_;
#line 63 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
			_tmp8_ = self->priv->_allow_duplicate;
#line 63 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
			if (_tmp8_) {
#line 63 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
				_tmp7_ = TRUE;
#line 375 "StaticPlaylist.c"
			} else {
				GeeArrayQueue* _tmp9_ = NULL;
				GeeArrayQueue* _tmp10_ = NULL;
				NoiseMedia* _tmp11_ = NULL;
				gboolean _tmp12_ = FALSE;
#line 63 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
				_tmp9_ = noise_playlist_get_medias ((NoisePlaylist*) self);
#line 63 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
				_tmp10_ = _tmp9_;
#line 63 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
				_tmp11_ = m;
#line 63 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
				_tmp12_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp10_, _tmp11_);
#line 63 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
				_tmp7_ = _tmp12_ == FALSE;
#line 391 "StaticPlaylist.c"
			}
#line 63 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
			if (_tmp7_) {
#line 395 "StaticPlaylist.c"
				GeeArrayQueue* _tmp13_ = NULL;
				GeeArrayQueue* _tmp14_ = NULL;
				NoiseMedia* _tmp15_ = NULL;
				GeeLinkedList* _tmp16_ = NULL;
				NoiseMedia* _tmp17_ = NULL;
#line 64 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
				_tmp13_ = noise_playlist_get_medias ((NoisePlaylist*) self);
#line 64 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
				_tmp14_ = _tmp13_;
#line 64 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
				_tmp15_ = m;
#line 64 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, _tmp15_);
#line 65 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
				_tmp16_ = added_media;
#line 65 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
				_tmp17_ = m;
#line 65 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp17_);
#line 415 "StaticPlaylist.c"
			}
#line 62 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
			_g_object_unref0 (m);
#line 419 "StaticPlaylist.c"
		}
#line 62 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		_g_object_unref0 (_m_it);
#line 423 "StaticPlaylist.c"
	}
#line 69 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	g_signal_emit_by_name ((NoisePlaylist*) self, "updated", NULL);
#line 70 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	_tmp18_ = added_media;
#line 70 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	g_signal_emit_by_name ((NoisePlaylist*) self, "media-added", (GeeCollection*) _tmp18_);
#line 60 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	_g_object_unref0 (added_media);
#line 433 "StaticPlaylist.c"
}


static void noise_static_playlist_real_remove_media (NoisePlaylist* base, NoiseMedia* to_remove) {
	NoiseStaticPlaylist * self;
	gboolean _tmp0_ = FALSE;
	NoiseMedia* _tmp1_ = NULL;
#line 73 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	self = (NoiseStaticPlaylist*) base;
#line 73 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	g_return_if_fail (to_remove != NULL);
#line 74 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	_tmp1_ = to_remove;
#line 74 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	if (_tmp1_ != NULL) {
#line 449 "StaticPlaylist.c"
		GeeArrayQueue* _tmp2_ = NULL;
		GeeArrayQueue* _tmp3_ = NULL;
		NoiseMedia* _tmp4_ = NULL;
		gboolean _tmp5_ = FALSE;
#line 74 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		_tmp2_ = noise_playlist_get_medias ((NoisePlaylist*) self);
#line 74 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		_tmp3_ = _tmp2_;
#line 74 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		_tmp4_ = to_remove;
#line 74 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		_tmp5_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp3_, _tmp4_);
#line 74 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		_tmp0_ = _tmp5_;
#line 464 "StaticPlaylist.c"
	} else {
#line 74 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		_tmp0_ = FALSE;
#line 468 "StaticPlaylist.c"
	}
#line 74 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	if (_tmp0_) {
#line 472 "StaticPlaylist.c"
		GeeLinkedList* removed_media = NULL;
		GeeLinkedList* _tmp6_ = NULL;
		GeeLinkedList* _tmp7_ = NULL;
		NoiseMedia* _tmp8_ = NULL;
		GeeArrayQueue* _tmp9_ = NULL;
		GeeArrayQueue* _tmp10_ = NULL;
		NoiseMedia* _tmp11_ = NULL;
		GeeLinkedList* _tmp12_ = NULL;
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		_tmp6_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		removed_media = _tmp6_;
#line 76 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		_tmp7_ = removed_media;
#line 76 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		_tmp8_ = to_remove;
#line 76 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp7_, _tmp8_);
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		_tmp9_ = noise_playlist_get_medias ((NoisePlaylist*) self);
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		_tmp10_ = _tmp9_;
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		_tmp11_ = to_remove;
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp10_, _tmp11_);
#line 78 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		_tmp12_ = removed_media;
#line 78 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		g_signal_emit_by_name ((NoisePlaylist*) self, "media-removed", (GeeCollection*) _tmp12_);
#line 74 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		_g_object_unref0 (removed_media);
#line 505 "StaticPlaylist.c"
	}
#line 81 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	g_signal_emit_by_name ((NoisePlaylist*) self, "updated", NULL);
#line 509 "StaticPlaylist.c"
}


static void noise_static_playlist_real_remove_medias (NoisePlaylist* base, GeeCollection* to_remove) {
	NoiseStaticPlaylist * self;
	GeeLinkedList* removed_media = NULL;
	GeeLinkedList* _tmp0_ = NULL;
	GeeLinkedList* _tmp18_ = NULL;
#line 84 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	self = (NoiseStaticPlaylist*) base;
#line 84 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	g_return_if_fail (to_remove != NULL);
#line 85 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	_tmp0_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 85 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	removed_media = _tmp0_;
#line 526 "StaticPlaylist.c"
	{
		GeeIterator* _m_it = NULL;
		GeeCollection* _tmp1_ = NULL;
		GeeIterator* _tmp2_ = NULL;
#line 86 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		_tmp1_ = to_remove;
#line 86 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 86 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		_m_it = _tmp2_;
#line 86 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		while (TRUE) {
#line 539 "StaticPlaylist.c"
			GeeIterator* _tmp3_ = NULL;
			gboolean _tmp4_ = FALSE;
			NoiseMedia* m = NULL;
			GeeIterator* _tmp5_ = NULL;
			gpointer _tmp6_ = NULL;
			gboolean _tmp7_ = FALSE;
			NoiseMedia* _tmp8_ = NULL;
#line 86 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
			_tmp3_ = _m_it;
#line 86 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
			_tmp4_ = gee_iterator_next (_tmp3_);
#line 86 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
			if (!_tmp4_) {
#line 86 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
				break;
#line 555 "StaticPlaylist.c"
			}
#line 86 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
			_tmp5_ = _m_it;
#line 86 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 86 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
			m = (NoiseMedia*) _tmp6_;
#line 87 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
			_tmp8_ = m;
#line 87 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
			if (_tmp8_ != NULL) {
#line 567 "StaticPlaylist.c"
				GeeArrayQueue* _tmp9_ = NULL;
				GeeArrayQueue* _tmp10_ = NULL;
				NoiseMedia* _tmp11_ = NULL;
				gboolean _tmp12_ = FALSE;
#line 87 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
				_tmp9_ = noise_playlist_get_medias ((NoisePlaylist*) self);
#line 87 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
				_tmp10_ = _tmp9_;
#line 87 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
				_tmp11_ = m;
#line 87 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
				_tmp12_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp10_, _tmp11_);
#line 87 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
				_tmp7_ = _tmp12_;
#line 582 "StaticPlaylist.c"
			} else {
#line 87 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
				_tmp7_ = FALSE;
#line 586 "StaticPlaylist.c"
			}
#line 87 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
			if (_tmp7_) {
#line 590 "StaticPlaylist.c"
				GeeLinkedList* _tmp13_ = NULL;
				NoiseMedia* _tmp14_ = NULL;
				GeeArrayQueue* _tmp15_ = NULL;
				GeeArrayQueue* _tmp16_ = NULL;
				NoiseMedia* _tmp17_ = NULL;
#line 88 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
				_tmp13_ = removed_media;
#line 88 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
				_tmp14_ = m;
#line 88 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp13_, _tmp14_);
#line 89 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
				_tmp15_ = noise_playlist_get_medias ((NoisePlaylist*) self);
#line 89 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
				_tmp16_ = _tmp15_;
#line 89 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
				_tmp17_ = m;
#line 89 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
				gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp16_, _tmp17_);
#line 610 "StaticPlaylist.c"
			}
#line 86 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
			_g_object_unref0 (m);
#line 614 "StaticPlaylist.c"
		}
#line 86 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		_g_object_unref0 (_m_it);
#line 618 "StaticPlaylist.c"
	}
#line 93 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	g_signal_emit_by_name ((NoisePlaylist*) self, "updated", NULL);
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	_tmp18_ = removed_media;
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	g_signal_emit_by_name ((NoisePlaylist*) self, "media-removed", (GeeCollection*) _tmp18_);
#line 84 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	_g_object_unref0 (removed_media);
#line 628 "StaticPlaylist.c"
}


static void noise_static_playlist_real_clear (NoisePlaylist* base) {
	NoiseStaticPlaylist * self;
	GeeArrayQueue* _tmp0_ = NULL;
	GeeArrayQueue* _tmp1_ = NULL;
#line 97 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	self = (NoiseStaticPlaylist*) base;
#line 98 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	_tmp0_ = noise_playlist_get_medias ((NoisePlaylist*) self);
#line 98 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	_tmp1_ = _tmp0_;
#line 98 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp1_);
#line 99 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	g_signal_emit_by_name ((NoisePlaylist*) self, "cleared");
#line 100 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	g_signal_emit_by_name ((NoisePlaylist*) self, "updated", NULL);
#line 648 "StaticPlaylist.c"
}


gboolean noise_static_playlist_get_read_only (NoiseStaticPlaylist* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 33 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 33 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	_tmp0_ = self->priv->_read_only;
#line 33 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	result = _tmp0_;
#line 33 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	return result;
#line 663 "StaticPlaylist.c"
}


void noise_static_playlist_set_read_only (NoiseStaticPlaylist* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
#line 33 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	g_return_if_fail (self != NULL);
#line 33 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	_tmp0_ = value;
#line 33 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	self->priv->_read_only = _tmp0_;
#line 33 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	g_object_notify ((GObject *) self, "read-only");
#line 677 "StaticPlaylist.c"
}


gboolean noise_static_playlist_get_show_badge (NoiseStaticPlaylist* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 34 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 34 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	_tmp0_ = self->priv->_show_badge;
#line 34 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	result = _tmp0_;
#line 34 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	return result;
#line 692 "StaticPlaylist.c"
}


void noise_static_playlist_set_show_badge (NoiseStaticPlaylist* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
#line 34 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	g_return_if_fail (self != NULL);
#line 34 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	_tmp0_ = value;
#line 34 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	self->priv->_show_badge = _tmp0_;
#line 34 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	g_object_notify ((GObject *) self, "show-badge");
#line 706 "StaticPlaylist.c"
}


gboolean noise_static_playlist_get_allow_duplicate (NoiseStaticPlaylist* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 35 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 35 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	_tmp0_ = self->priv->_allow_duplicate;
#line 35 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	result = _tmp0_;
#line 35 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	return result;
#line 721 "StaticPlaylist.c"
}


void noise_static_playlist_set_allow_duplicate (NoiseStaticPlaylist* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
#line 35 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	g_return_if_fail (self != NULL);
#line 35 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	_tmp0_ = value;
#line 35 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	self->priv->_allow_duplicate = _tmp0_;
#line 35 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	g_object_notify ((GObject *) self, "allow-duplicate");
#line 735 "StaticPlaylist.c"
}


static void noise_static_playlist_class_init (NoiseStaticPlaylistClass * klass) {
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	noise_static_playlist_parent_class = g_type_class_peek_parent (klass);
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	g_type_class_add_private (klass, sizeof (NoiseStaticPlaylistPrivate));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	((NoisePlaylistClass *) klass)->add_media = noise_static_playlist_real_add_media;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	((NoisePlaylistClass *) klass)->add_medias = noise_static_playlist_real_add_medias;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	((NoisePlaylistClass *) klass)->remove_media = noise_static_playlist_real_remove_media;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	((NoisePlaylistClass *) klass)->remove_medias = noise_static_playlist_real_remove_medias;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	((NoisePlaylistClass *) klass)->clear = noise_static_playlist_real_clear;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_static_playlist_get_property;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_static_playlist_set_property;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_static_playlist_finalize;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_STATIC_PLAYLIST_READ_ONLY, g_param_spec_boolean ("read-only", "read-only", "read-only", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_STATIC_PLAYLIST_SHOW_BADGE, g_param_spec_boolean ("show-badge", "show-badge", "show-badge", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_STATIC_PLAYLIST_ALLOW_DUPLICATE, g_param_spec_boolean ("allow-duplicate", "allow-duplicate", "allow-duplicate", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 766 "StaticPlaylist.c"
}


static void noise_static_playlist_instance_init (NoiseStaticPlaylist * self) {
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	self->priv = NOISE_STATIC_PLAYLIST_GET_PRIVATE (self);
#line 33 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	self->priv->_read_only = FALSE;
#line 34 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	self->priv->_show_badge = FALSE;
#line 35 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	self->priv->_allow_duplicate = FALSE;
#line 779 "StaticPlaylist.c"
}


static void noise_static_playlist_finalize (GObject* obj) {
	NoiseStaticPlaylist * self;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_STATIC_PLAYLIST, NoiseStaticPlaylist);
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	G_OBJECT_CLASS (noise_static_playlist_parent_class)->finalize (obj);
#line 789 "StaticPlaylist.c"
}


GType noise_static_playlist_get_type (void) {
	static volatile gsize noise_static_playlist_type_id__volatile = 0;
	if (g_once_init_enter (&noise_static_playlist_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseStaticPlaylistClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_static_playlist_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseStaticPlaylist), 0, (GInstanceInitFunc) noise_static_playlist_instance_init, NULL };
		GType noise_static_playlist_type_id;
		noise_static_playlist_type_id = g_type_register_static (NOISE_TYPE_PLAYLIST, "NoiseStaticPlaylist", &g_define_type_info, 0);
		g_once_init_leave (&noise_static_playlist_type_id__volatile, noise_static_playlist_type_id);
	}
	return noise_static_playlist_type_id__volatile;
}


static void _vala_noise_static_playlist_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NoiseStaticPlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_STATIC_PLAYLIST, NoiseStaticPlaylist);
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	switch (property_id) {
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		case NOISE_STATIC_PLAYLIST_READ_ONLY:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		g_value_set_boolean (value, noise_static_playlist_get_read_only (self));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		break;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		case NOISE_STATIC_PLAYLIST_SHOW_BADGE:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		g_value_set_boolean (value, noise_static_playlist_get_show_badge (self));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		break;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		case NOISE_STATIC_PLAYLIST_ALLOW_DUPLICATE:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		g_value_set_boolean (value, noise_static_playlist_get_allow_duplicate (self));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		break;
#line 828 "StaticPlaylist.c"
		default:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		break;
#line 834 "StaticPlaylist.c"
	}
}


static void _vala_noise_static_playlist_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	NoiseStaticPlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_STATIC_PLAYLIST, NoiseStaticPlaylist);
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
	switch (property_id) {
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		case NOISE_STATIC_PLAYLIST_READ_ONLY:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		noise_static_playlist_set_read_only (self, g_value_get_boolean (value));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		break;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		case NOISE_STATIC_PLAYLIST_SHOW_BADGE:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		noise_static_playlist_set_show_badge (self, g_value_get_boolean (value));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		break;
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		case NOISE_STATIC_PLAYLIST_ALLOW_DUPLICATE:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		noise_static_playlist_set_allow_duplicate (self, g_value_get_boolean (value));
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		break;
#line 862 "StaticPlaylist.c"
		default:
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "/usr/src/RPM/BUILD/noise-0.3.1/core/Playlists/StaticPlaylist.vala"
		break;
#line 868 "StaticPlaylist.c"
	}
}



