/* Numeric.c generated by valac 0.28.1, the Vala compiler
 * generated from Numeric.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2013 Noise Developers (http://launchpad.net/noise)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Victor Eduardo <victoreduardm@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>

#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);



#define NOISE_NUMERIC_NANO_INV ((guint64) 1000000000)
#define NOISE_NUMERIC_MILI_INV ((guint64) 1000)
gint noise_numeric_compare (gint64 a, gint64 b);
guint64 noise_numeric_uint_from_string (const gchar* str);
guint noise_numeric_lowest_uint_from_double (gdouble number) G_GNUC_DEPRECATED;
gint noise_numeric_lowest_int_from_float (gfloat number) G_GNUC_DEPRECATED;
guint noise_numeric_uint_from_double (gdouble number) G_GNUC_DEPRECATED;
gint noise_numeric_int_from_float (gfloat number) G_GNUC_DEPRECATED;


inline gint noise_numeric_compare (gint64 a, gint64 b) {
	gint result = 0;
	gint64 diff = 0LL;
	gint64 _tmp0_ = 0LL;
	gint64 _tmp1_ = 0LL;
	gint64 _tmp2_ = 0LL;
#line 40 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
	_tmp0_ = a;
#line 40 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
	_tmp1_ = b;
#line 40 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
	diff = _tmp0_ - _tmp1_;
#line 41 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
	_tmp2_ = CLAMP (diff, (gint64) G_MININT, (gint64) G_MAXINT);
#line 41 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
	result = (gint) _tmp2_;
#line 41 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
	return result;
#line 78 "Numeric.c"
}


/**
     * A method for extracting integers from strings.
     *
     * The method does its best to extract a number from a string by cleaning up
     * non-numeric characters before parsing the string with uint64.parse(). The
     * purpose of this method is to provide a safe way of extracting numbers
     * from strings without making everything crash when passing a weird localized
     * string that would normally lead uint64.parse, int64.parse or int.parse
     * to a segmentation fault. This happens due to encoding incompatibilities:
     * Remember that the standard C library doesn't know how to deal with variable-
     * length UTF-8 characters!
     *
     * If no number is found in the string, zero is returned.
     *
     * Examples:
     * "a23oe ew2" => 232
     " "32 text"   => 32
     * "ins1 32"   => 132
     * "a word"    => 0
     *
     * @param str string known to contain a valid integer
     * @return Result of parsing the string.
     */
static gboolean string_get_next_char (const gchar* self, gint* index, gunichar* c) {
	gunichar _vala_c = 0U;
	gboolean result = FALSE;
	gint _tmp0_ = 0;
	gunichar _tmp1_ = 0U;
	gunichar _tmp2_ = 0U;
#line 1015 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1016 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	_tmp0_ = *index;
#line 1016 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	_tmp1_ = g_utf8_get_char (((gchar*) self) + _tmp0_);
#line 1016 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	_vala_c = _tmp1_;
#line 1017 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	_tmp2_ = _vala_c;
#line 1017 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	if (_tmp2_ != ((gunichar) 0)) {
#line 123 "Numeric.c"
		gint _tmp3_ = 0;
		gchar* _tmp4_ = NULL;
#line 1018 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		_tmp3_ = *index;
#line 1018 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		_tmp4_ = g_utf8_next_char (((gchar*) self) + _tmp3_);
#line 1018 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		*index = (gint) (_tmp4_ - ((gchar*) self));
#line 1019 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		result = TRUE;
#line 1019 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		if (c) {
#line 1019 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
			*c = _vala_c;
#line 138 "Numeric.c"
		}
#line 1019 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		return result;
#line 142 "Numeric.c"
	} else {
#line 1021 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		result = FALSE;
#line 1021 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		if (c) {
#line 1021 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
			*c = _vala_c;
#line 150 "Numeric.c"
		}
#line 1021 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		return result;
#line 154 "Numeric.c"
	}
#line 1015 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	if (c) {
#line 1015 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		*c = _vala_c;
#line 160 "Numeric.c"
	}
}


static guint64 uint64_parse (const gchar* str) {
	guint64 result = 0ULL;
	const gchar* _tmp0_ = NULL;
	guint64 _tmp1_ = 0ULL;
#line 657 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0ULL);
#line 658 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 658 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	_tmp1_ = g_ascii_strtoull (_tmp0_, NULL, (guint) 0);
#line 658 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	result = _tmp1_;
#line 658 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	return result;
#line 179 "Numeric.c"
}


inline guint64 noise_numeric_uint_from_string (const gchar* str) {
	guint64 result = 0ULL;
#line 69 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
	static const gushort MAX_DIGITS = (gushort) 18;
#line 187 "Numeric.c"
	gushort ndigits = 0U;
	GString* _result_ = NULL;
	GString* _tmp0_ = NULL;
	gunichar c = 0U;
	guint64 _tmp12_ = 0ULL;
	gushort _tmp13_ = 0U;
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
	g_return_val_if_fail (str != NULL, 0ULL);
#line 70 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
	ndigits = (gushort) 0;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
	_tmp0_ = g_string_new ("");
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
	_result_ = _tmp0_;
#line 202 "Numeric.c"
	{
		gint i = 0;
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
		i = 0;
#line 207 "Numeric.c"
		{
			gboolean _tmp1_ = FALSE;
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
			_tmp1_ = TRUE;
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
			while (TRUE) {
#line 214 "Numeric.c"
				gboolean _tmp2_ = FALSE;
				const gchar* _tmp3_ = NULL;
				gunichar _tmp4_ = 0U;
				gboolean _tmp5_ = FALSE;
				gunichar _tmp7_ = 0U;
				gboolean _tmp8_ = FALSE;
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
				if (!_tmp1_) {
#line 223 "Numeric.c"
				}
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
				_tmp1_ = FALSE;
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
				_tmp3_ = str;
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
				_tmp5_ = string_get_next_char (_tmp3_, &i, &_tmp4_);
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
				c = _tmp4_;
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
				if (_tmp5_) {
#line 235 "Numeric.c"
					gushort _tmp6_ = 0U;
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
					_tmp6_ = ndigits;
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
					_tmp2_ = _tmp6_ < MAX_DIGITS;
#line 241 "Numeric.c"
				} else {
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
					_tmp2_ = FALSE;
#line 245 "Numeric.c"
				}
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
				if (!_tmp2_) {
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
					break;
#line 251 "Numeric.c"
				}
#line 76 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
				_tmp7_ = c;
#line 76 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
				_tmp8_ = g_unichar_isdigit (_tmp7_);
#line 76 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
				if (_tmp8_) {
#line 259 "Numeric.c"
					GString* _tmp9_ = NULL;
					gunichar _tmp10_ = 0U;
					gushort _tmp11_ = 0U;
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
					_tmp9_ = _result_;
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
					_tmp10_ = c;
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
					g_string_append_unichar (_tmp9_, _tmp10_);
#line 78 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
					_tmp11_ = ndigits;
#line 78 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
					ndigits = _tmp11_ + 1;
#line 273 "Numeric.c"
				}
			}
		}
	}
#line 82 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
	_tmp13_ = ndigits;
#line 82 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
	if (((gint) _tmp13_) == 0) {
#line 82 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
		_tmp12_ = (guint64) 0;
#line 284 "Numeric.c"
	} else {
		GString* _tmp14_ = NULL;
		const gchar* _tmp15_ = NULL;
		guint64 _tmp16_ = 0ULL;
#line 82 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
		_tmp14_ = _result_;
#line 82 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
		_tmp15_ = _tmp14_->str;
#line 82 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
		_tmp16_ = uint64_parse (_tmp15_);
#line 82 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
		_tmp12_ = _tmp16_;
#line 297 "Numeric.c"
	}
#line 82 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
	result = _tmp12_;
#line 82 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
	_g_string_free0 (_result_);
#line 82 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
	return result;
#line 305 "Numeric.c"
}


/**
     * Returns the lowest uint given a double.
     * For instance:
     * INPUT => OUTPUT
     *  7.02 => 7
     *  7.51 => 7
     *  7.99 => 7
     */
inline guint noise_numeric_lowest_uint_from_double (gdouble number) {
	guint result = 0U;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
	_tmp0_ = number;
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
	_vala_return_val_if_fail (_tmp0_ >= ((gdouble) 0), "number >= 0", 0U);
#line 97 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
	_tmp1_ = number;
#line 97 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
	_tmp2_ = trunc (_tmp1_);
#line 97 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
	result = (guint) _tmp2_;
#line 97 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
	return result;
#line 334 "Numeric.c"
}


/**
     * Returns the lowest int given a float.
     * For instance:
     * INPUT => OUTPUT
     *  7.02 => 7
     *  7.51 => 7
     *  7.99 => 7
     */
inline gint noise_numeric_lowest_int_from_float (gfloat number) {
	gint result = 0;
	gfloat _tmp0_ = 0.0F;
	gfloat _tmp1_ = 0.0F;
#line 110 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
	_tmp0_ = number;
#line 110 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
	_tmp1_ = truncf (_tmp0_);
#line 110 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
	result = (gint) _tmp1_;
#line 110 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
	return result;
#line 358 "Numeric.c"
}


/**
     * Approximates a double to the best uint.
     */
inline guint noise_numeric_uint_from_double (gdouble number) {
	guint result = 0U;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
#line 117 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
	_tmp0_ = number;
#line 117 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
	_vala_return_val_if_fail (_tmp0_ >= ((gdouble) 0), "number >= 0", 0U);
#line 120 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
	_tmp1_ = number;
#line 120 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
	_tmp2_ = round (_tmp1_);
#line 120 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
	result = (guint) _tmp2_;
#line 120 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
	return result;
#line 382 "Numeric.c"
}


/**
     * Approximates a float to the best integer.
     */
inline gint noise_numeric_int_from_float (gfloat number) {
	gint result = 0;
	gfloat _tmp0_ = 0.0F;
	gfloat _tmp1_ = 0.0F;
#line 128 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
	_tmp0_ = number;
#line 128 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
	_tmp1_ = roundf (_tmp0_);
#line 128 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
	result = (gint) _tmp1_;
#line 128 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/Numeric.vala"
	return result;
#line 401 "Numeric.c"
}



