/* PixbufCache.c generated by valac 0.28.1, the Vala compiler
 * generated from PixbufCache.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012 Noise Developers (http://launchpad.net/noise)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Victor Eduardo <victoreduardm@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>


#define NOISE_TYPE_PIXBUF_CACHE (noise_pixbuf_cache_get_type ())
#define NOISE_PIXBUF_CACHE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_PIXBUF_CACHE, NoisePixbufCache))
#define NOISE_PIXBUF_CACHE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_PIXBUF_CACHE, NoisePixbufCacheClass))
#define NOISE_IS_PIXBUF_CACHE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_PIXBUF_CACHE))
#define NOISE_IS_PIXBUF_CACHE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_PIXBUF_CACHE))
#define NOISE_PIXBUF_CACHE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_PIXBUF_CACHE, NoisePixbufCacheClass))

typedef struct _NoisePixbufCache NoisePixbufCache;
typedef struct _NoisePixbufCacheClass NoisePixbufCacheClass;
typedef struct _NoisePixbufCachePrivate NoisePixbufCachePrivate;
#define __vala_GdkPixbufFormat_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkPixbufFormat_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_slist_free0(var) ((var == NULL) ? NULL : (var = (g_slist_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _noise_pixbuf_cache_unref0(var) ((var == NULL) ? NULL : (var = (noise_pixbuf_cache_unref (var), NULL)))
typedef struct _NoisePixbufCacheCacheImageAsyncData NoisePixbufCacheCacheImageAsyncData;
typedef struct _NoisePixbufCacheCacheImageFromFileAsyncData NoisePixbufCacheCacheImageFromFileAsyncData;
typedef struct _NoisePixbufCacheGetImageAsyncData NoisePixbufCacheGetImageAsyncData;
typedef struct _NoisePixbufCacheCacheImageInternalAsyncData NoisePixbufCacheCacheImageInternalAsyncData;
typedef struct _NoisePixbufCacheLoadImageFromFileAsyncData NoisePixbufCacheLoadImageFromFileAsyncData;
typedef struct _NoisePixbufCacheSaveImageToFileData NoisePixbufCacheSaveImageToFileData;
typedef struct _NoiseParamSpecPixbufCache NoiseParamSpecPixbufCache;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef GdkPixbuf* (*NoisePixbufCacheFilterFunction) (const gchar* key, GdkPixbuf* orig_pixbuf, void* user_data);
struct _NoisePixbufCache {
	GTypeInstance parent_instance;
	volatile int ref_count;
	NoisePixbufCachePrivate * priv;
	NoisePixbufCacheFilterFunction filter_func;
	gpointer filter_func_target;
};

struct _NoisePixbufCacheClass {
	GTypeClass parent_class;
	void (*finalize) (NoisePixbufCache *self);
};

struct _NoisePixbufCachePrivate {
	GdkPixbufFormat* _image_format;
	GFile* image_dir;
	GeeHashMap* image_map;
	GRecMutex __lock_image_map;
};

struct _NoisePixbufCacheCacheImageAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	NoisePixbufCache* self;
	gchar* key;
	GdkPixbuf* image;
	const gchar* _tmp0_;
	GdkPixbuf* _tmp1_;
};

struct _NoisePixbufCacheCacheImageFromFileAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	NoisePixbufCache* self;
	gchar* key;
	GFile* image_file;
	GCancellable* c;
	GdkPixbuf* image;
	GFile* _tmp0_;
	GCancellable* _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	const gchar* _tmp4_;
	GdkPixbuf* _tmp5_;
};

struct _NoisePixbufCacheGetImageAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	NoisePixbufCache* self;
	gchar* key;
	gboolean lookup_file;
	GdkPixbuf* result;
	gboolean _tmp0_;
	gboolean _tmp1_;
	const gchar* _tmp2_;
	gboolean _tmp3_;
	GFile* image_file;
	const gchar* _tmp4_;
	GFile* _tmp5_;
	GdkPixbuf* image;
	GFile* _tmp6_;
	GdkPixbuf* _tmp7_;
	GdkPixbuf* _tmp8_;
	const gchar* _tmp9_;
	GdkPixbuf* _tmp10_;
	GeeHashMap* _tmp11_;
	const gchar* _tmp12_;
	gpointer _tmp13_;
};

struct _NoisePixbufCacheCacheImageInternalAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	NoisePixbufCache* self;
	gchar* key;
	GdkPixbuf* image;
	gboolean save_to_disk;
	GdkPixbuf* _tmp0_;
	NoisePixbufCacheFilterFunction _tmp1_;
	void* _tmp1__target;
	NoisePixbufCacheFilterFunction _tmp2_;
	void* _tmp2__target;
	const gchar* _tmp3_;
	GdkPixbuf* _tmp4_;
	GdkPixbuf* _tmp5_;
	GdkPixbuf* _tmp6_;
	GdkPixbuf* _tmp7_;
	GdkPixbuf* modified_image;
	GdkPixbuf* _tmp8_;
	GdkPixbuf* _tmp9_;
	GeeHashMap* _tmp10_;
	GeeHashMap* _tmp11_;
	const gchar* _tmp12_;
	GdkPixbuf* _tmp13_;
	gboolean _tmp14_;
	const gchar* _tmp15_;
	GdkPixbuf* _tmp16_;
	GeeHashMap* _tmp17_;
	GError * _inner_error_;
};

struct _NoisePixbufCacheLoadImageFromFileAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	NoisePixbufCache* self;
	GFile* image_file;
	GCancellable* cancellable;
	GdkPixbuf* result;
	GdkPixbuf* image;
	GdkPixbuf* _tmp0_;
	GFile* _tmp1_;
	GCancellable* _tmp2_;
	GdkPixbuf* _tmp3_;
	GdkPixbuf* _tmp4_;
	GError* err;
	GFile* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GError* _tmp8_;
	const gchar* _tmp9_;
	GError * _inner_error_;
};

struct _NoisePixbufCacheSaveImageToFileData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	NoisePixbufCache* self;
	gchar* key;
	GdkPixbuf* to_save;
	const gchar* _tmp0_;
	GFile* dest_file;
	const gchar* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	gboolean _tmp4_;
	GdkPixbuf* _tmp5_;
	GFile* _tmp6_;
	GdkPixbufFormat* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	GError* err;
	GError* _tmp10_;
	const gchar* _tmp11_;
	GError * _inner_error_;
};

struct _NoiseParamSpecPixbufCache {
	GParamSpec parent_instance;
};


static gpointer noise_pixbuf_cache_parent_class = NULL;

gpointer noise_pixbuf_cache_ref (gpointer instance);
void noise_pixbuf_cache_unref (gpointer instance);
GParamSpec* noise_param_spec_pixbuf_cache (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void noise_value_set_pixbuf_cache (GValue* value, gpointer v_object);
void noise_value_take_pixbuf_cache (GValue* value, gpointer v_object);
gpointer noise_value_get_pixbuf_cache (const GValue* value);
GType noise_pixbuf_cache_get_type (void) G_GNUC_CONST;
#define NOISE_PIXBUF_CACHE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NOISE_TYPE_PIXBUF_CACHE, NoisePixbufCachePrivate))
enum  {
	NOISE_PIXBUF_CACHE_DUMMY_PROPERTY
};
static void _vala_GdkPixbufFormat_free (GdkPixbufFormat* self);
#define NOISE_PIXBUF_CACHE_DEFAULT_FORMAT_NAME "jpeg"
NoisePixbufCache* noise_pixbuf_cache_new (GFile* image_dir, GdkPixbufFormat* image_format);
NoisePixbufCache* noise_pixbuf_cache_construct (GType object_type, GFile* image_dir, GdkPixbufFormat* image_format);
static void noise_pixbuf_cache_set_image_format (NoisePixbufCache* self, GdkPixbufFormat* value);
GdkPixbufFormat* noise_pixbuf_cache_get_image_format (NoisePixbufCache* self);
gboolean noise_pixbuf_cache_has_image (NoisePixbufCache* self, const gchar* key);
GFile* noise_pixbuf_cache_get_cached_image_file (NoisePixbufCache* self, const gchar* key);
GdkPixbuf* noise_pixbuf_cache_decache_image (NoisePixbufCache* self, const gchar* key);
static gboolean noise_pixbuf_cache_delete_file (NoisePixbufCache* self, GFile* file);
static void noise_pixbuf_cache_cache_image_async_data_free (gpointer _data);
void noise_pixbuf_cache_cache_image_async (NoisePixbufCache* self, const gchar* key, GdkPixbuf* image, GAsyncReadyCallback _callback_, gpointer _user_data_);
void noise_pixbuf_cache_cache_image_finish (NoisePixbufCache* self, GAsyncResult* _res_);
static gboolean noise_pixbuf_cache_cache_image_async_co (NoisePixbufCacheCacheImageAsyncData* _data_);
static void noise_pixbuf_cache_cache_image_internal_async (NoisePixbufCache* self, const gchar* key, GdkPixbuf* image, gboolean save_to_disk, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void noise_pixbuf_cache_cache_image_internal_finish (NoisePixbufCache* self, GAsyncResult* _res_);
static void noise_pixbuf_cache_cache_image_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static void noise_pixbuf_cache_cache_image_from_file_async_data_free (gpointer _data);
void noise_pixbuf_cache_cache_image_from_file_async (NoisePixbufCache* self, const gchar* key, GFile* image_file, GCancellable* c, GAsyncReadyCallback _callback_, gpointer _user_data_);
void noise_pixbuf_cache_cache_image_from_file_finish (NoisePixbufCache* self, GAsyncResult* _res_);
static gboolean noise_pixbuf_cache_cache_image_from_file_async_co (NoisePixbufCacheCacheImageFromFileAsyncData* _data_);
static void noise_pixbuf_cache_load_image_from_file_async (NoisePixbufCache* self, GFile* image_file, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
static GdkPixbuf* noise_pixbuf_cache_load_image_from_file_finish (NoisePixbufCache* self, GAsyncResult* _res_);
static void noise_pixbuf_cache_cache_image_from_file_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
GdkPixbuf* noise_pixbuf_cache_get_image (NoisePixbufCache* self, const gchar* key);
static void noise_pixbuf_cache_get_image_async_data_free (gpointer _data);
void noise_pixbuf_cache_get_image_async (NoisePixbufCache* self, const gchar* key, gboolean lookup_file, GAsyncReadyCallback _callback_, gpointer _user_data_);
GdkPixbuf* noise_pixbuf_cache_get_image_finish (NoisePixbufCache* self, GAsyncResult* _res_);
static gboolean noise_pixbuf_cache_get_image_async_co (NoisePixbufCacheGetImageAsyncData* _data_);
static void noise_pixbuf_cache_get_image_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static void noise_pixbuf_cache_cache_image_internal_async_data_free (gpointer _data);
static gboolean noise_pixbuf_cache_cache_image_internal_async_co (NoisePixbufCacheCacheImageInternalAsyncData* _data_);
static void noise_pixbuf_cache_save_image_to_file (NoisePixbufCache* self, const gchar* key, GdkPixbuf* to_save, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void noise_pixbuf_cache_save_image_to_file_finish (NoisePixbufCache* self, GAsyncResult* _res_);
static void noise_pixbuf_cache_load_image_from_file_async_data_free (gpointer _data);
static gboolean noise_pixbuf_cache_load_image_from_file_async_co (NoisePixbufCacheLoadImageFromFileAsyncData* _data_);
void noise_pixbuf_utils_get_pixbuf_from_file_async (GFile* file, GCancellable* c, GAsyncReadyCallback _callback_, gpointer _user_data_);
GdkPixbuf* noise_pixbuf_utils_get_pixbuf_from_file_finish (GAsyncResult* _res_, GError** error);
static void noise_pixbuf_cache_load_image_from_file_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static void noise_pixbuf_cache_save_image_to_file_data_free (gpointer _data);
static gboolean noise_pixbuf_cache_save_image_to_file_co (NoisePixbufCacheSaveImageToFileData* _data_);
void noise_pixbuf_utils_save_pixbuf_async (GdkPixbuf* pixbuf, GFile* dest_file, const gchar* image_format, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
void noise_pixbuf_utils_save_pixbuf_finish (GAsyncResult* _res_, GError** error);
static void noise_pixbuf_cache_save_image_to_file_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
GeeMap* noise_pixbuf_cache_get_images (NoisePixbufCache* self);
static GdkPixbufFormat* _vala_GdkPixbufFormat_copy (GdkPixbufFormat* self);
static void noise_pixbuf_cache_finalize (NoisePixbufCache* obj);

const gchar* NOISE_PIXBUF_CACHE_IMAGE_TYPES[3] = {"image/jpeg", "image/png", "image/tiff"};

static void _vala_GdkPixbufFormat_free (GdkPixbufFormat* self) {
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_boxed_free (gdk_pixbuf_format_get_type (), self);
#line 305 "PixbufCache.c"
}


/**
     * Creates a new {@link Noise.PixbufCache} object.
     * It also creates the cache directory if it doesn't exist, and thus expect blocking I/O.
     *
     * @param image_dir a {@link GLib.File} representing the cache directory.
     * @param image_format a string specifying the image format, or null to use the default
     * format (JPEG). Valid image formats are those supported by {@link Gdk.Pixbuf.save}.
     */
static gpointer _g_object_ref0 (gpointer self) {
#line 96 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	return self ? g_object_ref (self) : NULL;
#line 320 "PixbufCache.c"
}


NoisePixbufCache* noise_pixbuf_cache_construct (GType object_type, GFile* image_dir, GdkPixbufFormat* image_format) {
	NoisePixbufCache* self = NULL;
	GdkPixbufFormat* _tmp0_ = NULL;
	gboolean _tmp8_ = FALSE;
	GdkPixbufFormat* _tmp9_ = NULL;
	GFile* _tmp12_ = NULL;
	GFile* _tmp13_ = NULL;
	GeeHashMap* _tmp18_ = NULL;
	GError * _inner_error_ = NULL;
#line 81 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_return_val_if_fail (image_dir != NULL, NULL);
#line 81 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	self = (NoisePixbufCache*) g_type_create_instance (object_type);
#line 82 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp0_ = image_format;
#line 82 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	if (_tmp0_ == NULL) {
#line 341 "PixbufCache.c"
		GSList* _tmp1_ = NULL;
#line 83 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_tmp1_ = gdk_pixbuf_get_formats ();
#line 345 "PixbufCache.c"
		{
			GSList* format_collection = NULL;
			GSList* format_it = NULL;
#line 83 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			format_collection = _tmp1_;
#line 83 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			for (format_it = format_collection; format_it != NULL; format_it = format_it->next) {
#line 353 "PixbufCache.c"
				GdkPixbufFormat* format = NULL;
#line 83 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
				format = (GdkPixbufFormat*) format_it->data;
#line 357 "PixbufCache.c"
				{
					GdkPixbufFormat* _tmp2_ = NULL;
					gchar* _tmp3_ = NULL;
					gchar* _tmp4_ = NULL;
					gboolean _tmp5_ = FALSE;
#line 84 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
					_tmp2_ = format;
#line 84 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
					_tmp3_ = gdk_pixbuf_format_get_name (_tmp2_);
#line 84 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
					_tmp4_ = _tmp3_;
#line 84 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
					_tmp5_ = g_strcmp0 (_tmp4_, NOISE_PIXBUF_CACHE_DEFAULT_FORMAT_NAME) == 0;
#line 84 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
					_g_free0 (_tmp4_);
#line 84 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
					if (_tmp5_) {
#line 375 "PixbufCache.c"
						GdkPixbufFormat* _tmp6_ = NULL;
#line 85 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
						_tmp6_ = format;
#line 85 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
						noise_pixbuf_cache_set_image_format (self, _tmp6_);
#line 86 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
						break;
#line 383 "PixbufCache.c"
					}
				}
			}
#line 83 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			_g_slist_free0 (format_collection);
#line 389 "PixbufCache.c"
		}
	} else {
		GdkPixbufFormat* _tmp7_ = NULL;
#line 90 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_tmp7_ = image_format;
#line 90 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		noise_pixbuf_cache_set_image_format (self, _tmp7_);
#line 397 "PixbufCache.c"
	}
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp9_ = self->priv->_image_format;
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	if (_tmp9_ != NULL) {
#line 403 "PixbufCache.c"
		GdkPixbufFormat* _tmp10_ = NULL;
		gboolean _tmp11_ = FALSE;
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_tmp10_ = self->priv->_image_format;
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_tmp11_ = gdk_pixbuf_format_is_writable (_tmp10_);
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_tmp8_ = _tmp11_;
#line 412 "PixbufCache.c"
	} else {
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_tmp8_ = FALSE;
#line 416 "PixbufCache.c"
	}
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_vala_assert (_tmp8_, "this.image_format != null && this.image_format.is_writable ()");
#line 96 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp12_ = image_dir;
#line 96 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp13_ = _g_object_ref0 (_tmp12_);
#line 96 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_g_object_unref0 (self->priv->image_dir);
#line 96 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	self->priv->image_dir = _tmp13_;
#line 428 "PixbufCache.c"
	{
		GFile* _tmp14_ = NULL;
#line 99 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_tmp14_ = image_dir;
#line 99 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_file_make_directory_with_parents (_tmp14_, NULL, &_inner_error_);
#line 99 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 437 "PixbufCache.c"
			goto __catch19_g_error;
		}
	}
	goto __finally19;
	__catch19_g_error:
	{
		GError* err = NULL;
		GError* _tmp15_ = NULL;
#line 98 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		err = _inner_error_;
#line 98 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_inner_error_ = NULL;
#line 101 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_tmp15_ = err;
#line 101 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		if (!g_error_matches (_tmp15_, G_IO_ERROR, G_IO_ERROR_EXISTS)) {
#line 454 "PixbufCache.c"
			GError* _tmp16_ = NULL;
			const gchar* _tmp17_ = NULL;
#line 102 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			_tmp16_ = err;
#line 102 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			_tmp17_ = _tmp16_->message;
#line 102 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			g_warning ("PixbufCache.vala:102: Could not create image cache directory: %s", _tmp17_);
#line 463 "PixbufCache.c"
		}
#line 98 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_g_error_free0 (err);
#line 467 "PixbufCache.c"
	}
	__finally19:
#line 98 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 98 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 98 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_clear_error (&_inner_error_);
#line 98 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		return NULL;
#line 478 "PixbufCache.c"
	}
#line 105 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp18_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, GDK_TYPE_PIXBUF, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 105 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_g_object_unref0 (self->priv->image_map);
#line 105 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	self->priv->image_map = _tmp18_;
#line 81 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	return self;
#line 488 "PixbufCache.c"
}


NoisePixbufCache* noise_pixbuf_cache_new (GFile* image_dir, GdkPixbufFormat* image_format) {
#line 81 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	return noise_pixbuf_cache_construct (NOISE_TYPE_PIXBUF_CACHE, image_dir, image_format);
#line 495 "PixbufCache.c"
}


/**
     * Verifies whether the key has a corresponding image in the cache.
     */
gboolean noise_pixbuf_cache_has_image (NoisePixbufCache* self, const gchar* key) {
	gboolean result = FALSE;
	GeeHashMap* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
#line 124 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 124 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_return_val_if_fail (key != NULL, FALSE);
#line 125 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp0_ = self->priv->image_map;
#line 125 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp1_ = key;
#line 125 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp2_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, _tmp1_);
#line 125 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	result = _tmp2_;
#line 125 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	return result;
#line 521 "PixbufCache.c"
}


/**
     * Returns a file representing the key's image on disk. This call does no blocking I/O.
     * Use it to consistently read cached image files. Pixbuf cache uses it internally
     * to save the images.
     *
     * This method only creates a file based on the passed key, and thus it doesn't
     * know whether the file it points to exists or not. It is recommended to pair
     * calls to {@link Noise.PixbufCache.has_image} to check for that.
     */
GFile* noise_pixbuf_cache_get_cached_image_file (NoisePixbufCache* self, const gchar* key) {
	GFile* result = NULL;
	GString* builder = NULL;
	GString* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GdkPixbufFormat* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* filename = NULL;
	const gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	GFile* _tmp7_ = NULL;
	GFile* _tmp8_ = NULL;
#line 137 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 137 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 138 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp0_ = g_string_new ("");
#line 138 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	builder = _tmp0_;
#line 139 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp1_ = key;
#line 139 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_string_append (builder, _tmp1_);
#line 140 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp2_ = self->priv->_image_format;
#line 140 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp3_ = gdk_pixbuf_format_get_name (_tmp2_);
#line 140 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp4_ = _tmp3_;
#line 140 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_string_append (builder, _tmp4_);
#line 140 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_g_free0 (_tmp4_);
#line 141 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp5_ = builder->str;
#line 141 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp6_ = g_compute_checksum_for_string (G_CHECKSUM_MD5, _tmp5_, (gsize) (-1));
#line 141 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	filename = _tmp6_;
#line 142 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp7_ = self->priv->image_dir;
#line 142 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp8_ = g_file_get_child (_tmp7_, filename);
#line 142 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	result = _tmp8_;
#line 142 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_g_free0 (filename);
#line 142 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_g_string_free0 (builder);
#line 142 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	return result;
#line 587 "PixbufCache.c"
}


/**
     * Removes the image corresponding to the key from the table. It also deletes
     * the associated file from the cache directory.
     */
GdkPixbuf* noise_pixbuf_cache_decache_image (NoisePixbufCache* self, const gchar* key) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* val = NULL;
	GError * _inner_error_ = NULL;
#line 149 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 149 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 603 "PixbufCache.c"
	{
		GeeHashMap* _tmp0_ = NULL;
#line 152 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_tmp0_ = self->priv->image_map;
#line 152 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_rec_mutex_lock (&self->priv->__lock_image_map);
#line 610 "PixbufCache.c"
		{
			GeeHashMap* _tmp1_ = NULL;
			const gchar* _tmp2_ = NULL;
			gpointer _tmp3_ = NULL;
			const gchar* _tmp4_ = NULL;
			GFile* _tmp5_ = NULL;
			GFile* _tmp6_ = NULL;
#line 153 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			_tmp1_ = self->priv->image_map;
#line 153 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			_tmp2_ = key;
#line 153 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			gee_abstract_map_unset ((GeeAbstractMap*) _tmp1_, _tmp2_, &_tmp3_);
#line 153 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			_g_object_unref0 (val);
#line 153 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			val = _tmp3_;
#line 154 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			_tmp4_ = key;
#line 154 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			_tmp5_ = noise_pixbuf_cache_get_cached_image_file (self, _tmp4_);
#line 154 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			_tmp6_ = _tmp5_;
#line 154 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			noise_pixbuf_cache_delete_file (self, _tmp6_);
#line 154 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			_g_object_unref0 (_tmp6_);
#line 638 "PixbufCache.c"
		}
		__finally20:
		{
			GeeHashMap* _tmp7_ = NULL;
#line 152 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			_tmp7_ = self->priv->image_map;
#line 152 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			g_rec_mutex_unlock (&self->priv->__lock_image_map);
#line 647 "PixbufCache.c"
		}
#line 152 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 152 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			_g_object_unref0 (val);
#line 152 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 152 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			g_clear_error (&_inner_error_);
#line 152 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			return NULL;
#line 659 "PixbufCache.c"
		}
	}
#line 157 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	result = val;
#line 157 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	return result;
#line 666 "PixbufCache.c"
}


static void noise_pixbuf_cache_cache_image_async_data_free (gpointer _data) {
	NoisePixbufCacheCacheImageAsyncData* _data_;
	_data_ = _data;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_g_free0 (_data_->key);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_g_object_unref0 (_data_->image);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_noise_pixbuf_cache_unref0 (_data_->self);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_slice_free (NoisePixbufCacheCacheImageAsyncData, _data_);
#line 681 "PixbufCache.c"
}


static gpointer _noise_pixbuf_cache_ref0 (gpointer self) {
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	return self ? noise_pixbuf_cache_ref (self) : NULL;
#line 688 "PixbufCache.c"
}


void noise_pixbuf_cache_cache_image_async (NoisePixbufCache* self, const gchar* key, GdkPixbuf* image, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	NoisePixbufCacheCacheImageAsyncData* _data_;
	NoisePixbufCache* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	GdkPixbuf* _tmp3_ = NULL;
	GdkPixbuf* _tmp4_ = NULL;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_ = g_slice_new0 (NoisePixbufCacheCacheImageAsyncData);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_async_result = g_simple_async_result_new (NULL, _callback_, _user_data_, noise_pixbuf_cache_cache_image_async);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, noise_pixbuf_cache_cache_image_async_data_free);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp0_ = _noise_pixbuf_cache_ref0 (self);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->self = _tmp0_;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp1_ = key;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_g_free0 (_data_->key);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->key = _tmp2_;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp3_ = image;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_g_object_unref0 (_data_->image);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->image = _tmp4_;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	noise_pixbuf_cache_cache_image_async_co (_data_);
#line 727 "PixbufCache.c"
}


void noise_pixbuf_cache_cache_image_finish (NoisePixbufCache* self, GAsyncResult* _res_) {
	NoisePixbufCacheCacheImageAsyncData* _data_;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 735 "PixbufCache.c"
}


/**
     * Associates an image to a key.
     *
     * The image is stored on an internal table and on disk, and can be later
     * retrieved through {@link Noise.PixbufCache.get_image}.
     *
     * This method can also be used to update image buffers when they have changed,
     * since the old image is overwritten (in both primary memory and disk.)
     */
static void noise_pixbuf_cache_cache_image_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	NoisePixbufCacheCacheImageAsyncData* _data_;
#line 170 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_ = _user_data_;
#line 170 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_source_object_ = source_object;
#line 170 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_res_ = _res_;
#line 170 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	noise_pixbuf_cache_cache_image_async_co (_data_);
#line 758 "PixbufCache.c"
}


static gboolean noise_pixbuf_cache_cache_image_async_co (NoisePixbufCacheCacheImageAsyncData* _data_) {
#line 169 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	switch (_data_->_state_) {
#line 169 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		case 0:
#line 767 "PixbufCache.c"
		goto _state_0;
#line 169 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		case 1:
#line 771 "PixbufCache.c"
		goto _state_1;
		default:
#line 169 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_assert_not_reached ();
#line 776 "PixbufCache.c"
	}
	_state_0:
#line 170 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_tmp0_ = NULL;
#line 170 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_tmp0_ = _data_->key;
#line 170 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_tmp1_ = NULL;
#line 170 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_tmp1_ = _data_->image;
#line 170 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_state_ = 1;
#line 170 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	noise_pixbuf_cache_cache_image_internal_async (_data_->self, _data_->_tmp0_, _data_->_tmp1_, TRUE, noise_pixbuf_cache_cache_image_async_ready, _data_);
#line 170 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	return FALSE;
#line 793 "PixbufCache.c"
	_state_1:
#line 170 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	noise_pixbuf_cache_cache_image_internal_finish (_data_->self, _data_->_res_);
#line 169 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	if (_data_->_state_ == 0) {
#line 169 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 801 "PixbufCache.c"
	} else {
#line 169 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 805 "PixbufCache.c"
	}
#line 169 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_object_unref (_data_->_async_result);
#line 169 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	return FALSE;
#line 811 "PixbufCache.c"
}


static void noise_pixbuf_cache_cache_image_from_file_async_data_free (gpointer _data) {
	NoisePixbufCacheCacheImageFromFileAsyncData* _data_;
	_data_ = _data;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_g_free0 (_data_->key);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_g_object_unref0 (_data_->image_file);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_g_object_unref0 (_data_->c);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_noise_pixbuf_cache_unref0 (_data_->self);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_slice_free (NoisePixbufCacheCacheImageFromFileAsyncData, _data_);
#line 828 "PixbufCache.c"
}


void noise_pixbuf_cache_cache_image_from_file_async (NoisePixbufCache* self, const gchar* key, GFile* image_file, GCancellable* c, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	NoisePixbufCacheCacheImageFromFileAsyncData* _data_;
	NoisePixbufCache* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	GFile* _tmp3_ = NULL;
	GFile* _tmp4_ = NULL;
	GCancellable* _tmp5_ = NULL;
	GCancellable* _tmp6_ = NULL;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_ = g_slice_new0 (NoisePixbufCacheCacheImageFromFileAsyncData);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_async_result = g_simple_async_result_new (NULL, _callback_, _user_data_, noise_pixbuf_cache_cache_image_from_file_async);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, noise_pixbuf_cache_cache_image_from_file_async_data_free);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp0_ = _noise_pixbuf_cache_ref0 (self);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->self = _tmp0_;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp1_ = key;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_g_free0 (_data_->key);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->key = _tmp2_;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp3_ = image_file;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_g_object_unref0 (_data_->image_file);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->image_file = _tmp4_;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp5_ = c;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_g_object_unref0 (_data_->c);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->c = _tmp6_;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	noise_pixbuf_cache_cache_image_from_file_async_co (_data_);
#line 877 "PixbufCache.c"
}


void noise_pixbuf_cache_cache_image_from_file_finish (NoisePixbufCache* self, GAsyncResult* _res_) {
	NoisePixbufCacheCacheImageFromFileAsyncData* _data_;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 885 "PixbufCache.c"
}


/**
     * This method does the same as {@link Noise.PixbufCache.cache_image}, with the only
     * difference that it first fetches the image from the given file.
     */
static void noise_pixbuf_cache_cache_image_from_file_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	NoisePixbufCacheCacheImageFromFileAsyncData* _data_;
#line 178 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_ = _user_data_;
#line 178 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_source_object_ = source_object;
#line 178 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_res_ = _res_;
#line 178 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	noise_pixbuf_cache_cache_image_from_file_async_co (_data_);
#line 903 "PixbufCache.c"
}


static gboolean noise_pixbuf_cache_cache_image_from_file_async_co (NoisePixbufCacheCacheImageFromFileAsyncData* _data_) {
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	switch (_data_->_state_) {
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		case 0:
#line 912 "PixbufCache.c"
		goto _state_0;
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		case 1:
#line 916 "PixbufCache.c"
		goto _state_1;
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		case 2:
#line 920 "PixbufCache.c"
		goto _state_2;
		default:
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_assert_not_reached ();
#line 925 "PixbufCache.c"
	}
	_state_0:
#line 178 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_tmp0_ = NULL;
#line 178 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_tmp0_ = _data_->image_file;
#line 178 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_tmp1_ = NULL;
#line 178 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_tmp1_ = _data_->c;
#line 178 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_state_ = 1;
#line 178 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	noise_pixbuf_cache_load_image_from_file_async (_data_->self, _data_->_tmp0_, _data_->_tmp1_, noise_pixbuf_cache_cache_image_from_file_async_ready, _data_);
#line 178 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	return FALSE;
#line 942 "PixbufCache.c"
	_state_1:
#line 178 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_tmp2_ = NULL;
#line 178 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_tmp2_ = noise_pixbuf_cache_load_image_from_file_finish (_data_->self, _data_->_res_);
#line 178 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->image = _data_->_tmp2_;
#line 179 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_tmp3_ = NULL;
#line 179 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_tmp3_ = _data_->image;
#line 179 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	if (_data_->_tmp3_ != NULL) {
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp4_ = NULL;
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp4_ = _data_->key;
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp5_ = NULL;
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp5_ = _data_->image;
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_state_ = 2;
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		noise_pixbuf_cache_cache_image_async (_data_->self, _data_->_tmp4_, _data_->_tmp5_, noise_pixbuf_cache_cache_image_from_file_async_ready, _data_);
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		return FALSE;
#line 970 "PixbufCache.c"
		_state_2:
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		noise_pixbuf_cache_cache_image_finish (_data_->self, _data_->_res_);
#line 974 "PixbufCache.c"
	}
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_g_object_unref0 (_data_->image);
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	if (_data_->_state_ == 0) {
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 982 "PixbufCache.c"
	} else {
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 986 "PixbufCache.c"
	}
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_object_unref (_data_->_async_result);
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	return FALSE;
#line 992 "PixbufCache.c"
}


/**
     * Retrieves the image for the given key from the cache.
     *
     * @return A valid {@link Gdk.Pixbuf}, or null if the image is not found.
     */
GdkPixbuf* noise_pixbuf_cache_get_image (NoisePixbufCache* self, const gchar* key) {
	GdkPixbuf* result = NULL;
	GeeHashMap* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gpointer _tmp2_ = NULL;
#line 188 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 188 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 189 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp0_ = self->priv->image_map;
#line 189 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp1_ = key;
#line 189 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp1_);
#line 189 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	result = (GdkPixbuf*) _tmp2_;
#line 189 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	return result;
#line 1020 "PixbufCache.c"
}


static void noise_pixbuf_cache_get_image_async_data_free (gpointer _data) {
	NoisePixbufCacheGetImageAsyncData* _data_;
	_data_ = _data;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_g_free0 (_data_->key);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_g_object_unref0 (_data_->result);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_noise_pixbuf_cache_unref0 (_data_->self);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_slice_free (NoisePixbufCacheGetImageAsyncData, _data_);
#line 1035 "PixbufCache.c"
}


void noise_pixbuf_cache_get_image_async (NoisePixbufCache* self, const gchar* key, gboolean lookup_file, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	NoisePixbufCacheGetImageAsyncData* _data_;
	NoisePixbufCache* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_ = g_slice_new0 (NoisePixbufCacheGetImageAsyncData);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_async_result = g_simple_async_result_new (NULL, _callback_, _user_data_, noise_pixbuf_cache_get_image_async);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, noise_pixbuf_cache_get_image_async_data_free);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp0_ = _noise_pixbuf_cache_ref0 (self);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->self = _tmp0_;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp1_ = key;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_g_free0 (_data_->key);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->key = _tmp2_;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp3_ = lookup_file;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->lookup_file = _tmp3_;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	noise_pixbuf_cache_get_image_async_co (_data_);
#line 1069 "PixbufCache.c"
}


GdkPixbuf* noise_pixbuf_cache_get_image_finish (NoisePixbufCache* self, GAsyncResult* _res_) {
	GdkPixbuf* result;
	NoisePixbufCacheGetImageAsyncData* _data_;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	result = _data_->result;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->result = NULL;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	return result;
#line 1084 "PixbufCache.c"
}


/**
     * Retrieves the image for the given key from the cache. If lookup_file
     * is true, it attempts to load the image from the disk cache in case
     * it wasn't found in the table. The lookup_file parameter provides an
     * efficient way to initialize the cache, since -when set to true-, files
     * are retrieved from disk as they are needed.
     *
     * @return null if the key's corresponding image was not found; Otherwise
     *         a valid {@link Gdk.Pixbuf}
     */
static void noise_pixbuf_cache_get_image_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	NoisePixbufCacheGetImageAsyncData* _data_;
#line 205 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_ = _user_data_;
#line 205 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_source_object_ = source_object;
#line 205 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_res_ = _res_;
#line 205 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	noise_pixbuf_cache_get_image_async_co (_data_);
#line 1108 "PixbufCache.c"
}


static gboolean noise_pixbuf_cache_get_image_async_co (NoisePixbufCacheGetImageAsyncData* _data_) {
#line 202 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	switch (_data_->_state_) {
#line 202 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		case 0:
#line 1117 "PixbufCache.c"
		goto _state_0;
#line 202 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		case 1:
#line 1121 "PixbufCache.c"
		goto _state_1;
#line 202 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		case 2:
#line 1125 "PixbufCache.c"
		goto _state_2;
		default:
#line 202 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_assert_not_reached ();
#line 1130 "PixbufCache.c"
	}
	_state_0:
#line 203 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_tmp1_ = FALSE;
#line 203 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_tmp1_ = _data_->lookup_file;
#line 203 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	if (_data_->_tmp1_) {
#line 203 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp2_ = NULL;
#line 203 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp2_ = _data_->key;
#line 203 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp3_ = FALSE;
#line 203 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp3_ = noise_pixbuf_cache_has_image (_data_->self, _data_->_tmp2_);
#line 203 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp0_ = !_data_->_tmp3_;
#line 1149 "PixbufCache.c"
	} else {
#line 203 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp0_ = FALSE;
#line 1153 "PixbufCache.c"
	}
#line 203 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	if (_data_->_tmp0_) {
#line 204 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp4_ = NULL;
#line 204 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp4_ = _data_->key;
#line 204 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp5_ = NULL;
#line 204 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp5_ = noise_pixbuf_cache_get_cached_image_file (_data_->self, _data_->_tmp4_);
#line 204 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->image_file = _data_->_tmp5_;
#line 205 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp6_ = NULL;
#line 205 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp6_ = _data_->image_file;
#line 205 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_state_ = 1;
#line 205 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		noise_pixbuf_cache_load_image_from_file_async (_data_->self, _data_->_tmp6_, NULL, noise_pixbuf_cache_get_image_async_ready, _data_);
#line 205 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		return FALSE;
#line 1177 "PixbufCache.c"
		_state_1:
#line 205 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp7_ = NULL;
#line 205 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp7_ = noise_pixbuf_cache_load_image_from_file_finish (_data_->self, _data_->_res_);
#line 205 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->image = _data_->_tmp7_;
#line 206 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp8_ = NULL;
#line 206 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp8_ = _data_->image;
#line 206 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		if (_data_->_tmp8_ != NULL) {
#line 207 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			_data_->_tmp9_ = NULL;
#line 207 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			_data_->_tmp9_ = _data_->key;
#line 207 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			_data_->_tmp10_ = NULL;
#line 207 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			_data_->_tmp10_ = _data_->image;
#line 207 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			_data_->_state_ = 2;
#line 207 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			noise_pixbuf_cache_cache_image_internal_async (_data_->self, _data_->_tmp9_, _data_->_tmp10_, FALSE, noise_pixbuf_cache_get_image_async_ready, _data_);
#line 207 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			return FALSE;
#line 1205 "PixbufCache.c"
			_state_2:
#line 207 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			noise_pixbuf_cache_cache_image_internal_finish (_data_->self, _data_->_res_);
#line 1209 "PixbufCache.c"
		}
#line 203 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_g_object_unref0 (_data_->image);
#line 203 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_g_object_unref0 (_data_->image_file);
#line 1215 "PixbufCache.c"
	}
#line 210 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_tmp11_ = NULL;
#line 210 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_tmp11_ = _data_->self->priv->image_map;
#line 210 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_tmp12_ = NULL;
#line 210 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_tmp12_ = _data_->key;
#line 210 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_tmp13_ = NULL;
#line 210 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_tmp13_ = gee_abstract_map_get ((GeeAbstractMap*) _data_->_tmp11_, _data_->_tmp12_);
#line 210 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->result = (GdkPixbuf*) _data_->_tmp13_;
#line 210 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	if (_data_->_state_ == 0) {
#line 210 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 1235 "PixbufCache.c"
	} else {
#line 210 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 1239 "PixbufCache.c"
	}
#line 210 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_object_unref (_data_->_async_result);
#line 210 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	return FALSE;
#line 202 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	if (_data_->_state_ == 0) {
#line 202 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 1249 "PixbufCache.c"
	} else {
#line 202 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 1253 "PixbufCache.c"
	}
#line 202 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_object_unref (_data_->_async_result);
#line 202 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	return FALSE;
#line 1259 "PixbufCache.c"
}


static void noise_pixbuf_cache_cache_image_internal_async_data_free (gpointer _data) {
	NoisePixbufCacheCacheImageInternalAsyncData* _data_;
	_data_ = _data;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_g_free0 (_data_->key);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_g_object_unref0 (_data_->image);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_noise_pixbuf_cache_unref0 (_data_->self);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_slice_free (NoisePixbufCacheCacheImageInternalAsyncData, _data_);
#line 1274 "PixbufCache.c"
}


static void noise_pixbuf_cache_cache_image_internal_async (NoisePixbufCache* self, const gchar* key, GdkPixbuf* image, gboolean save_to_disk, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	NoisePixbufCacheCacheImageInternalAsyncData* _data_;
	NoisePixbufCache* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	GdkPixbuf* _tmp3_ = NULL;
	GdkPixbuf* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_ = g_slice_new0 (NoisePixbufCacheCacheImageInternalAsyncData);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_async_result = g_simple_async_result_new (NULL, _callback_, _user_data_, noise_pixbuf_cache_cache_image_internal_async);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, noise_pixbuf_cache_cache_image_internal_async_data_free);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp0_ = _noise_pixbuf_cache_ref0 (self);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->self = _tmp0_;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp1_ = key;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_g_free0 (_data_->key);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->key = _tmp2_;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp3_ = image;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_g_object_unref0 (_data_->image);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->image = _tmp4_;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp5_ = save_to_disk;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->save_to_disk = _tmp5_;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	noise_pixbuf_cache_cache_image_internal_async_co (_data_);
#line 1318 "PixbufCache.c"
}


static void noise_pixbuf_cache_cache_image_internal_finish (NoisePixbufCache* self, GAsyncResult* _res_) {
	NoisePixbufCacheCacheImageInternalAsyncData* _data_;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 1326 "PixbufCache.c"
}


/**
     * Adds an image to the hash map and also writes the image to disk if save_to_disk is true.
     */
static gboolean noise_pixbuf_cache_cache_image_internal_async_co (NoisePixbufCacheCacheImageInternalAsyncData* _data_) {
#line 216 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	switch (_data_->_state_) {
#line 216 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		case 0:
#line 1338 "PixbufCache.c"
		goto _state_0;
		default:
#line 216 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_assert_not_reached ();
#line 1343 "PixbufCache.c"
	}
	_state_0:
#line 217 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_tmp1_ = NULL;
#line 217 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_tmp1__target = NULL;
#line 217 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_tmp1_ = _data_->self->filter_func;
#line 217 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_tmp1__target = _data_->self->filter_func_target;
#line 217 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	if (_data_->_tmp1_ != NULL) {
#line 217 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp2_ = NULL;
#line 217 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp2__target = NULL;
#line 217 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp2_ = _data_->self->filter_func;
#line 217 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp2__target = _data_->self->filter_func_target;
#line 217 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp3_ = NULL;
#line 217 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp3_ = _data_->key;
#line 217 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp4_ = NULL;
#line 217 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp4_ = _data_->image;
#line 217 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp5_ = NULL;
#line 217 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp5_ = _data_->_tmp2_ (_data_->_tmp3_, _data_->_tmp4_, _data_->_tmp2__target);
#line 217 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_g_object_unref0 (_data_->_tmp0_);
#line 217 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp0_ = _data_->_tmp5_;
#line 1380 "PixbufCache.c"
	} else {
#line 217 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp6_ = NULL;
#line 217 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp6_ = _data_->image;
#line 217 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp7_ = NULL;
#line 217 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp7_ = _g_object_ref0 (_data_->_tmp6_);
#line 217 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_g_object_unref0 (_data_->_tmp0_);
#line 217 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp0_ = _data_->_tmp7_;
#line 1394 "PixbufCache.c"
	}
#line 217 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_tmp8_ = NULL;
#line 217 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_tmp8_ = _g_object_ref0 (_data_->_tmp0_);
#line 217 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->modified_image = _data_->_tmp8_;
#line 219 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_tmp9_ = NULL;
#line 219 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_tmp9_ = _data_->modified_image;
#line 219 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	if (_data_->_tmp9_ != NULL) {
#line 1408 "PixbufCache.c"
		{
#line 220 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			_data_->_tmp10_ = NULL;
#line 220 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			_data_->_tmp10_ = _data_->self->priv->image_map;
#line 220 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			g_rec_mutex_lock (&_data_->self->priv->__lock_image_map);
#line 1416 "PixbufCache.c"
			{
#line 221 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
				_data_->_tmp11_ = NULL;
#line 221 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
				_data_->_tmp11_ = _data_->self->priv->image_map;
#line 221 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
				_data_->_tmp12_ = NULL;
#line 221 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
				_data_->_tmp12_ = _data_->key;
#line 221 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
				_data_->_tmp13_ = NULL;
#line 221 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
				_data_->_tmp13_ = _data_->modified_image;
#line 221 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _data_->_tmp11_, _data_->_tmp12_, _data_->_tmp13_);
#line 225 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
				_data_->_tmp14_ = FALSE;
#line 225 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
				_data_->_tmp14_ = _data_->save_to_disk;
#line 225 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
				if (_data_->_tmp14_) {
#line 226 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
					_data_->_tmp15_ = NULL;
#line 226 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
					_data_->_tmp15_ = _data_->key;
#line 226 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
					_data_->_tmp16_ = NULL;
#line 226 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
					_data_->_tmp16_ = _data_->image;
#line 226 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
					noise_pixbuf_cache_save_image_to_file (_data_->self, _data_->_tmp15_, _data_->_tmp16_, NULL, NULL);
#line 1448 "PixbufCache.c"
				}
			}
			__finally21:
			{
#line 220 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
				_data_->_tmp17_ = NULL;
#line 220 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
				_data_->_tmp17_ = _data_->self->priv->image_map;
#line 220 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
				g_rec_mutex_unlock (&_data_->self->priv->__lock_image_map);
#line 1459 "PixbufCache.c"
			}
#line 220 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 220 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
				_g_object_unref0 (_data_->modified_image);
#line 220 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
				_g_object_unref0 (_data_->_tmp0_);
#line 220 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 220 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
				g_clear_error (&_data_->_inner_error_);
#line 220 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
				return FALSE;
#line 1473 "PixbufCache.c"
			}
		}
	}
#line 216 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_g_object_unref0 (_data_->modified_image);
#line 216 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_g_object_unref0 (_data_->_tmp0_);
#line 216 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	if (_data_->_state_ == 0) {
#line 216 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 1485 "PixbufCache.c"
	} else {
#line 216 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 1489 "PixbufCache.c"
	}
#line 216 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_object_unref (_data_->_async_result);
#line 216 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	return FALSE;
#line 1495 "PixbufCache.c"
}


static void noise_pixbuf_cache_load_image_from_file_async_data_free (gpointer _data) {
	NoisePixbufCacheLoadImageFromFileAsyncData* _data_;
	_data_ = _data;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_g_object_unref0 (_data_->image_file);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_g_object_unref0 (_data_->cancellable);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_g_object_unref0 (_data_->result);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_noise_pixbuf_cache_unref0 (_data_->self);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_slice_free (NoisePixbufCacheLoadImageFromFileAsyncData, _data_);
#line 1512 "PixbufCache.c"
}


static void noise_pixbuf_cache_load_image_from_file_async (NoisePixbufCache* self, GFile* image_file, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	NoisePixbufCacheLoadImageFromFileAsyncData* _data_;
	NoisePixbufCache* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	GCancellable* _tmp3_ = NULL;
	GCancellable* _tmp4_ = NULL;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_ = g_slice_new0 (NoisePixbufCacheLoadImageFromFileAsyncData);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_async_result = g_simple_async_result_new (NULL, _callback_, _user_data_, noise_pixbuf_cache_load_image_from_file_async);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, noise_pixbuf_cache_load_image_from_file_async_data_free);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp0_ = _noise_pixbuf_cache_ref0 (self);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->self = _tmp0_;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp1_ = image_file;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_g_object_unref0 (_data_->image_file);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->image_file = _tmp2_;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp3_ = cancellable;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_g_object_unref0 (_data_->cancellable);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->cancellable = _tmp4_;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	noise_pixbuf_cache_load_image_from_file_async_co (_data_);
#line 1551 "PixbufCache.c"
}


static GdkPixbuf* noise_pixbuf_cache_load_image_from_file_finish (NoisePixbufCache* self, GAsyncResult* _res_) {
	GdkPixbuf* result;
	NoisePixbufCacheLoadImageFromFileAsyncData* _data_;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	result = _data_->result;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->result = NULL;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	return result;
#line 1566 "PixbufCache.c"
}


/**
     * Central place for retrieving images from permanent-storage locations. This is not
     * limited to this cache's local directory.
     */
static void noise_pixbuf_cache_load_image_from_file_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	NoisePixbufCacheLoadImageFromFileAsyncData* _data_;
#line 239 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_ = _user_data_;
#line 239 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_source_object_ = source_object;
#line 239 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_res_ = _res_;
#line 239 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	noise_pixbuf_cache_load_image_from_file_async_co (_data_);
#line 1584 "PixbufCache.c"
}


static gboolean noise_pixbuf_cache_load_image_from_file_async_co (NoisePixbufCacheLoadImageFromFileAsyncData* _data_) {
#line 235 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	switch (_data_->_state_) {
#line 235 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		case 0:
#line 1593 "PixbufCache.c"
		goto _state_0;
#line 235 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		case 1:
#line 1597 "PixbufCache.c"
		goto _state_1;
		default:
#line 235 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_assert_not_reached ();
#line 1602 "PixbufCache.c"
	}
	_state_0:
#line 236 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->image = NULL;
#line 1607 "PixbufCache.c"
	{
#line 239 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp1_ = NULL;
#line 239 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp1_ = _data_->image_file;
#line 239 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp2_ = NULL;
#line 239 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp2_ = _data_->cancellable;
#line 239 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_state_ = 1;
#line 239 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		noise_pixbuf_utils_get_pixbuf_from_file_async (_data_->_tmp1_, _data_->_tmp2_, noise_pixbuf_cache_load_image_from_file_async_ready, _data_);
#line 239 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		return FALSE;
#line 1623 "PixbufCache.c"
		_state_1:
#line 239 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp3_ = NULL;
#line 239 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp3_ = noise_pixbuf_utils_get_pixbuf_from_file_finish (_data_->_res_, &_data_->_inner_error_);
#line 239 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp0_ = _data_->_tmp3_;
#line 239 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 1633 "PixbufCache.c"
			goto __catch22_g_error;
		}
#line 239 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp4_ = NULL;
#line 239 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp4_ = _data_->_tmp0_;
#line 239 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp0_ = NULL;
#line 239 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_g_object_unref0 (_data_->image);
#line 239 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->image = _data_->_tmp4_;
#line 238 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_g_object_unref0 (_data_->_tmp0_);
#line 1648 "PixbufCache.c"
	}
	goto __finally22;
	__catch22_g_error:
	{
#line 238 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->err = _data_->_inner_error_;
#line 238 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_inner_error_ = NULL;
#line 241 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp5_ = NULL;
#line 241 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp5_ = _data_->image_file;
#line 241 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp6_ = NULL;
#line 241 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp6_ = g_file_get_uri (_data_->_tmp5_);
#line 241 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp7_ = NULL;
#line 241 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp7_ = _data_->_tmp6_;
#line 241 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp8_ = NULL;
#line 241 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp8_ = _data_->err;
#line 241 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp9_ = NULL;
#line 241 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp9_ = _data_->_tmp8_->message;
#line 241 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_debug ("PixbufCache.vala:241: Could not get image from file [%s]: %s", _data_->_tmp7_, _data_->_tmp9_);
#line 241 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_g_free0 (_data_->_tmp7_);
#line 238 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_g_error_free0 (_data_->err);
#line 1683 "PixbufCache.c"
	}
	__finally22:
#line 238 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 238 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_g_object_unref0 (_data_->image);
#line 238 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 238 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_clear_error (&_data_->_inner_error_);
#line 238 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		return FALSE;
#line 1696 "PixbufCache.c"
	}
#line 244 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->result = _data_->image;
#line 244 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	if (_data_->_state_ == 0) {
#line 244 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 1704 "PixbufCache.c"
	} else {
#line 244 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 1708 "PixbufCache.c"
	}
#line 244 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_object_unref (_data_->_async_result);
#line 244 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	return FALSE;
#line 235 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_g_object_unref0 (_data_->image);
#line 235 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	if (_data_->_state_ == 0) {
#line 235 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 1720 "PixbufCache.c"
	} else {
#line 235 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 1724 "PixbufCache.c"
	}
#line 235 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_object_unref (_data_->_async_result);
#line 235 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	return FALSE;
#line 1730 "PixbufCache.c"
}


static void noise_pixbuf_cache_save_image_to_file_data_free (gpointer _data) {
	NoisePixbufCacheSaveImageToFileData* _data_;
	_data_ = _data;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_g_free0 (_data_->key);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_g_object_unref0 (_data_->to_save);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_noise_pixbuf_cache_unref0 (_data_->self);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_slice_free (NoisePixbufCacheSaveImageToFileData, _data_);
#line 1745 "PixbufCache.c"
}


static void noise_pixbuf_cache_save_image_to_file (NoisePixbufCache* self, const gchar* key, GdkPixbuf* to_save, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	NoisePixbufCacheSaveImageToFileData* _data_;
	NoisePixbufCache* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	GdkPixbuf* _tmp3_ = NULL;
	GdkPixbuf* _tmp4_ = NULL;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_ = g_slice_new0 (NoisePixbufCacheSaveImageToFileData);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_async_result = g_simple_async_result_new (NULL, _callback_, _user_data_, noise_pixbuf_cache_save_image_to_file);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, noise_pixbuf_cache_save_image_to_file_data_free);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp0_ = _noise_pixbuf_cache_ref0 (self);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->self = _tmp0_;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp1_ = key;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_g_free0 (_data_->key);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->key = _tmp2_;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp3_ = to_save;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_g_object_unref0 (_data_->to_save);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->to_save = _tmp4_;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	noise_pixbuf_cache_save_image_to_file_co (_data_);
#line 1784 "PixbufCache.c"
}


static void noise_pixbuf_cache_save_image_to_file_finish (NoisePixbufCache* self, GAsyncResult* _res_) {
	NoisePixbufCacheSaveImageToFileData* _data_;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 1792 "PixbufCache.c"
}


/**
     * Stores a pixbuf in the cache directory. Not thread-safe
     */
static void noise_pixbuf_cache_save_image_to_file_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	NoisePixbufCacheSaveImageToFileData* _data_;
#line 256 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_ = _user_data_;
#line 256 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_source_object_ = source_object;
#line 256 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_res_ = _res_;
#line 256 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	noise_pixbuf_cache_save_image_to_file_co (_data_);
#line 1809 "PixbufCache.c"
}


static gboolean noise_pixbuf_cache_save_image_to_file_co (NoisePixbufCacheSaveImageToFileData* _data_) {
#line 250 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	switch (_data_->_state_) {
#line 250 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		case 0:
#line 1818 "PixbufCache.c"
		goto _state_0;
#line 250 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		case 1:
#line 1822 "PixbufCache.c"
		goto _state_1;
		default:
#line 250 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_assert_not_reached ();
#line 1827 "PixbufCache.c"
	}
	_state_0:
#line 251 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_tmp0_ = NULL;
#line 251 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_data_->_tmp0_ = _data_->key;
#line 251 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_debug ("PixbufCache.vala:251: Saving cached image for: %s", _data_->_tmp0_);
#line 1836 "PixbufCache.c"
	{
#line 254 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp1_ = NULL;
#line 254 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp1_ = _data_->key;
#line 254 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp2_ = NULL;
#line 254 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp2_ = noise_pixbuf_cache_get_cached_image_file (_data_->self, _data_->_tmp1_);
#line 254 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->dest_file = _data_->_tmp2_;
#line 255 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp3_ = NULL;
#line 255 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp3_ = _data_->dest_file;
#line 255 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp4_ = FALSE;
#line 255 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp4_ = noise_pixbuf_cache_delete_file (_data_->self, _data_->_tmp3_);
#line 255 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		if (_data_->_tmp4_) {
#line 256 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			_data_->_tmp5_ = NULL;
#line 256 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			_data_->_tmp5_ = _data_->to_save;
#line 256 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			_data_->_tmp6_ = NULL;
#line 256 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			_data_->_tmp6_ = _data_->dest_file;
#line 256 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			_data_->_tmp7_ = NULL;
#line 256 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			_data_->_tmp7_ = _data_->self->priv->_image_format;
#line 256 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			_data_->_tmp8_ = NULL;
#line 256 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			_data_->_tmp8_ = gdk_pixbuf_format_get_name (_data_->_tmp7_);
#line 256 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			_data_->_tmp9_ = NULL;
#line 256 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			_data_->_tmp9_ = _data_->_tmp8_;
#line 256 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			_data_->_state_ = 1;
#line 256 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			noise_pixbuf_utils_save_pixbuf_async (_data_->_tmp5_, _data_->_tmp6_, _data_->_tmp9_, NULL, noise_pixbuf_cache_save_image_to_file_ready, _data_);
#line 256 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			return FALSE;
#line 1884 "PixbufCache.c"
			_state_1:
#line 256 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			noise_pixbuf_utils_save_pixbuf_finish (_data_->_res_, &_data_->_inner_error_);
#line 256 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			_g_free0 (_data_->_tmp9_);
#line 256 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 256 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
				_g_object_unref0 (_data_->dest_file);
#line 1894 "PixbufCache.c"
				goto __catch23_g_error;
			}
		}
#line 253 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_g_object_unref0 (_data_->dest_file);
#line 1900 "PixbufCache.c"
	}
	goto __finally23;
	__catch23_g_error:
	{
#line 253 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->err = _data_->_inner_error_;
#line 253 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_inner_error_ = NULL;
#line 258 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp10_ = NULL;
#line 258 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp10_ = _data_->err;
#line 258 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp11_ = NULL;
#line 258 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_data_->_tmp11_ = _data_->_tmp10_->message;
#line 258 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_warning ("PixbufCache.vala:258: Could not save pixbuf: %s", _data_->_tmp11_);
#line 253 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_g_error_free0 (_data_->err);
#line 1921 "PixbufCache.c"
	}
	__finally23:
#line 253 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 253 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 253 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_clear_error (&_data_->_inner_error_);
#line 253 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		return FALSE;
#line 1932 "PixbufCache.c"
	}
#line 250 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	if (_data_->_state_ == 0) {
#line 250 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 1938 "PixbufCache.c"
	} else {
#line 250 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 1942 "PixbufCache.c"
	}
#line 250 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_object_unref (_data_->_async_result);
#line 250 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	return FALSE;
#line 1948 "PixbufCache.c"
}


/**
     * Deletes a file.
     
     * It silently fails in case the file doesn't exist. Not thread-safe.
     *
     * @return true in case the image was deleted or doesn't exist; false otherwise.
     */
static gboolean noise_pixbuf_cache_delete_file (NoisePixbufCache* self, GFile* file) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 269 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 269 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 1966 "PixbufCache.c"
	{
		GFile* _tmp0_ = NULL;
#line 271 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_tmp0_ = file;
#line 271 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_file_delete (_tmp0_, NULL, &_inner_error_);
#line 271 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1975 "PixbufCache.c"
			goto __catch24_g_error;
		}
	}
	goto __finally24;
	__catch24_g_error:
	{
		GError* err = NULL;
		GError* _tmp1_ = NULL;
#line 270 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		err = _inner_error_;
#line 270 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_inner_error_ = NULL;
#line 273 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_tmp1_ = err;
#line 273 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		if (g_error_matches (_tmp1_, G_IO_ERROR, G_IO_ERROR_NOT_FOUND)) {
#line 1992 "PixbufCache.c"
			GError* _tmp2_ = NULL;
			const gchar* _tmp3_ = NULL;
#line 274 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			_tmp2_ = err;
#line 274 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			_tmp3_ = _tmp2_->message;
#line 274 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			g_debug ("PixbufCache.vala:274: %s", _tmp3_);
#line 2001 "PixbufCache.c"
		} else {
			GError* _tmp4_ = NULL;
			const gchar* _tmp5_ = NULL;
#line 276 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			_tmp4_ = err;
#line 276 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			_tmp5_ = _tmp4_->message;
#line 276 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			g_warning ("PixbufCache.vala:276: Could not delete image: %s", _tmp5_);
#line 277 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			result = FALSE;
#line 277 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			_g_error_free0 (err);
#line 277 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			return result;
#line 2017 "PixbufCache.c"
		}
#line 270 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		_g_error_free0 (err);
#line 2021 "PixbufCache.c"
	}
	__finally24:
#line 270 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 270 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 270 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_clear_error (&_inner_error_);
#line 270 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		return FALSE;
#line 2032 "PixbufCache.c"
	}
#line 281 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	result = TRUE;
#line 281 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	return result;
#line 2038 "PixbufCache.c"
}


GeeMap* noise_pixbuf_cache_get_images (NoisePixbufCache* self) {
	GeeMap* result;
	GeeHashMap* _tmp0_ = NULL;
	GeeMap* _tmp1_ = NULL;
	GeeMap* _tmp2_ = NULL;
#line 64 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 64 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp0_ = self->priv->image_map;
#line 64 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp1_ = gee_abstract_map_get_read_only_view ((GeeAbstractMap*) _tmp0_);
#line 64 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp2_ = _tmp1_;
#line 64 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	result = _tmp2_;
#line 64 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	return result;
#line 2059 "PixbufCache.c"
}


GdkPixbufFormat* noise_pixbuf_cache_get_image_format (NoisePixbufCache* self) {
	GdkPixbufFormat* result;
	GdkPixbufFormat* _tmp0_ = NULL;
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp0_ = self->priv->_image_format;
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	result = _tmp0_;
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	return result;
#line 2074 "PixbufCache.c"
}


static GdkPixbufFormat* _vala_GdkPixbufFormat_copy (GdkPixbufFormat* self) {
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	return g_boxed_copy (gdk_pixbuf_format_get_type (), self);
#line 2081 "PixbufCache.c"
}


static gpointer __vala_GdkPixbufFormat_copy0 (gpointer self) {
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	return self ? _vala_GdkPixbufFormat_copy (self) : NULL;
#line 2088 "PixbufCache.c"
}


static void noise_pixbuf_cache_set_image_format (NoisePixbufCache* self, GdkPixbufFormat* value) {
	GdkPixbufFormat* _tmp0_ = NULL;
	GdkPixbufFormat* _tmp1_ = NULL;
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_return_if_fail (self != NULL);
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp0_ = value;
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_tmp1_ = __vala_GdkPixbufFormat_copy0 (_tmp0_);
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	__vala_GdkPixbufFormat_free0 (self->priv->_image_format);
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	self->priv->_image_format = _tmp1_;
#line 2105 "PixbufCache.c"
}


static void noise_value_pixbuf_cache_init (GValue* value) {
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	value->data[0].v_pointer = NULL;
#line 2112 "PixbufCache.c"
}


static void noise_value_pixbuf_cache_free_value (GValue* value) {
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	if (value->data[0].v_pointer) {
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		noise_pixbuf_cache_unref (value->data[0].v_pointer);
#line 2121 "PixbufCache.c"
	}
}


static void noise_value_pixbuf_cache_copy_value (const GValue* src_value, GValue* dest_value) {
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	if (src_value->data[0].v_pointer) {
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		dest_value->data[0].v_pointer = noise_pixbuf_cache_ref (src_value->data[0].v_pointer);
#line 2131 "PixbufCache.c"
	} else {
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2135 "PixbufCache.c"
	}
}


static gpointer noise_value_pixbuf_cache_peek_pointer (const GValue* value) {
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	return value->data[0].v_pointer;
#line 2143 "PixbufCache.c"
}


static gchar* noise_value_pixbuf_cache_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	if (collect_values[0].v_pointer) {
#line 2150 "PixbufCache.c"
		NoisePixbufCache* object;
		object = collect_values[0].v_pointer;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		if (object->parent_instance.g_class == NULL) {
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2157 "PixbufCache.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2161 "PixbufCache.c"
		}
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		value->data[0].v_pointer = noise_pixbuf_cache_ref (object);
#line 2165 "PixbufCache.c"
	} else {
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		value->data[0].v_pointer = NULL;
#line 2169 "PixbufCache.c"
	}
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	return NULL;
#line 2173 "PixbufCache.c"
}


static gchar* noise_value_pixbuf_cache_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	NoisePixbufCache** object_p;
	object_p = collect_values[0].v_pointer;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	if (!object_p) {
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2184 "PixbufCache.c"
	}
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	if (!value->data[0].v_pointer) {
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		*object_p = NULL;
#line 2190 "PixbufCache.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		*object_p = value->data[0].v_pointer;
#line 2194 "PixbufCache.c"
	} else {
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		*object_p = noise_pixbuf_cache_ref (value->data[0].v_pointer);
#line 2198 "PixbufCache.c"
	}
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	return NULL;
#line 2202 "PixbufCache.c"
}


GParamSpec* noise_param_spec_pixbuf_cache (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	NoiseParamSpecPixbufCache* spec;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_return_val_if_fail (g_type_is_a (object_type, NOISE_TYPE_PIXBUF_CACHE), NULL);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	return G_PARAM_SPEC (spec);
#line 2216 "PixbufCache.c"
}


gpointer noise_value_get_pixbuf_cache (const GValue* value) {
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, NOISE_TYPE_PIXBUF_CACHE), NULL);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	return value->data[0].v_pointer;
#line 2225 "PixbufCache.c"
}


void noise_value_set_pixbuf_cache (GValue* value, gpointer v_object) {
	NoisePixbufCache* old;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, NOISE_TYPE_PIXBUF_CACHE));
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	old = value->data[0].v_pointer;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	if (v_object) {
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, NOISE_TYPE_PIXBUF_CACHE));
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		value->data[0].v_pointer = v_object;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		noise_pixbuf_cache_ref (value->data[0].v_pointer);
#line 2245 "PixbufCache.c"
	} else {
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		value->data[0].v_pointer = NULL;
#line 2249 "PixbufCache.c"
	}
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	if (old) {
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		noise_pixbuf_cache_unref (old);
#line 2255 "PixbufCache.c"
	}
}


void noise_value_take_pixbuf_cache (GValue* value, gpointer v_object) {
	NoisePixbufCache* old;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, NOISE_TYPE_PIXBUF_CACHE));
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	old = value->data[0].v_pointer;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	if (v_object) {
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, NOISE_TYPE_PIXBUF_CACHE));
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		value->data[0].v_pointer = v_object;
#line 2274 "PixbufCache.c"
	} else {
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		value->data[0].v_pointer = NULL;
#line 2278 "PixbufCache.c"
	}
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	if (old) {
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		noise_pixbuf_cache_unref (old);
#line 2284 "PixbufCache.c"
	}
}


static void noise_pixbuf_cache_class_init (NoisePixbufCacheClass * klass) {
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	noise_pixbuf_cache_parent_class = g_type_class_peek_parent (klass);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	((NoisePixbufCacheClass *) klass)->finalize = noise_pixbuf_cache_finalize;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_type_class_add_private (klass, sizeof (NoisePixbufCachePrivate));
#line 2296 "PixbufCache.c"
}


static void noise_pixbuf_cache_instance_init (NoisePixbufCache * self) {
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	self->priv = NOISE_PIXBUF_CACHE_GET_PRIVATE (self);
#line 71 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_rec_mutex_init (&self->priv->__lock_image_map);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	self->ref_count = 1;
#line 2307 "PixbufCache.c"
}


static void noise_pixbuf_cache_finalize (NoisePixbufCache* obj) {
	NoisePixbufCache * self;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_PIXBUF_CACHE, NoisePixbufCache);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_signal_handlers_destroy (self);
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	__vala_GdkPixbufFormat_free0 (self->priv->_image_format);
#line 70 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_g_object_unref0 (self->priv->image_dir);
#line 71 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_rec_mutex_clear (&self->priv->__lock_image_map);
#line 71 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	_g_object_unref0 (self->priv->image_map);
#line 2325 "PixbufCache.c"
}


/**
 * A thread-safe place to store cached pixbufs
 *
 * Pixbuf images are permanently stored at the directory passed to the constructor,
 * and use JPEG buffers by default, since they are much lighter in terms of
 * resource usage and rendering time, while offering acceptable quality. A
 * different image format can be specified at construct-time too.
 *
 * When saving changes to the cache directory, a MD5-based name is used, which
 * is in turn computed from the image's key. This often works better than escaping
 * (and later unescaping) paths, and lets us have tighter control over the image
 * format used, since it's encoded along with the image name.
 *
 * Keep in mind that both cache_image_*() and decache_image() do blocking I/O,
 * and therefore it's recommended to make extensive use of has_image() prior to
 * calling these in order to avoid unnecessary disk access.
 *
 * This class is meant to be kept as generic as possible. It currently does not
 * depend on Noise's internal API (except for PixbufUtils, which is also considered
 * to be generic). It should be easy to re-use it on another application.
 */
GType noise_pixbuf_cache_get_type (void) {
	static volatile gsize noise_pixbuf_cache_type_id__volatile = 0;
	if (g_once_init_enter (&noise_pixbuf_cache_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { noise_value_pixbuf_cache_init, noise_value_pixbuf_cache_free_value, noise_value_pixbuf_cache_copy_value, noise_value_pixbuf_cache_peek_pointer, "p", noise_value_pixbuf_cache_collect_value, "p", noise_value_pixbuf_cache_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (NoisePixbufCacheClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_pixbuf_cache_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoisePixbufCache), 0, (GInstanceInitFunc) noise_pixbuf_cache_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType noise_pixbuf_cache_type_id;
		noise_pixbuf_cache_type_id = g_type_register_fundamental (g_type_fundamental_next (), "NoisePixbufCache", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&noise_pixbuf_cache_type_id__volatile, noise_pixbuf_cache_type_id);
	}
	return noise_pixbuf_cache_type_id__volatile;
}


gpointer noise_pixbuf_cache_ref (gpointer instance) {
	NoisePixbufCache* self;
	self = instance;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	g_atomic_int_inc (&self->ref_count);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	return instance;
#line 2371 "PixbufCache.c"
}


void noise_pixbuf_cache_unref (gpointer instance) {
	NoisePixbufCache* self;
	self = instance;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		NOISE_PIXBUF_CACHE_GET_CLASS (self)->finalize (self);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/PixbufCache.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2384 "PixbufCache.c"
	}
}



