/* String.c generated by valac 0.28.1, the Vala compiler
 * generated from String.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*
 * Copyright (c) 2012-2013 Noise Developers (http://launchpad.net/noise)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Victor Eduardo <victoreduardm@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))



gboolean noise_string_is_empty (const gchar* text, gboolean check_white_space);
gboolean noise_string_is_white_space (const gchar* text);
gint noise_string_compare (const gchar* a, const gchar* b);
gchar* noise_string_escape (const gchar* text);
gchar* noise_string_canonicalize_for_search (const gchar* str);
gunichar noise_string_strip_char (gunichar ch);
gchar* noise_string_to_title_case (const gchar* text);
gchar* noise_string_locale_to_utf8 (const gchar* string_locale);
void noise_string_base_search_method (const gchar* search, gint* parsed_rating, gchar** parsed_search_string);
gint noise_search_get_rating_from_string (const gchar* rating_string);
gchar* noise_search_get_valid_search_string (const gchar* s);


inline gboolean noise_string_is_empty (const gchar* text, gboolean check_white_space) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
#line 34 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_tmp0_ = text;
#line 34 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	if (_tmp0_ != NULL) {
#line 66 "String.c"
		gboolean _tmp1_ = FALSE;
		gboolean _tmp2_ = FALSE;
#line 35 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		_tmp2_ = check_white_space;
#line 35 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		if (_tmp2_) {
#line 73 "String.c"
			const gchar* _tmp3_ = NULL;
			gboolean _tmp4_ = FALSE;
#line 35 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
			_tmp3_ = text;
#line 35 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
			_tmp4_ = noise_string_is_white_space (_tmp3_);
#line 35 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
			_tmp1_ = _tmp4_;
#line 82 "String.c"
		} else {
			const gchar* _tmp5_ = NULL;
#line 35 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
			_tmp5_ = text;
#line 35 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
			_tmp1_ = g_strcmp0 (_tmp5_, "") == 0;
#line 89 "String.c"
		}
#line 35 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		result = _tmp1_;
#line 35 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		return result;
#line 95 "String.c"
	}
#line 36 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	result = TRUE;
#line 36 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	return result;
#line 101 "String.c"
}


/**
     * Compares two strings encoded in UTF-8. Used extensively in the views for sorting.
     *
     * It takes into account the current locale's sorting rules and is faster
     * than normal string comparison.
     *
     * /!\ DON'T USE THIS METHOD WITH STRINGS NOT ENCODED IN UTF-8.
     *
     * @param a first string.
     * @param b second string.
     * @return 0 if a == b, a positive number if a > b, or a negative number if a < b.
     */
inline gint noise_string_compare (const gchar* a, const gchar* b) {
	gint result = 0;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	GCompareFunc _tmp10_ = NULL;
	gint _tmp11_ = 0;
#line 53 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_tmp1_ = a;
#line 53 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	if (_tmp1_ != NULL) {
#line 129 "String.c"
		const gchar* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
#line 53 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		_tmp2_ = a;
#line 53 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		_tmp3_ = g_utf8_collate_key (_tmp2_, (gssize) (-1));
#line 53 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		_g_free0 (_tmp0_);
#line 53 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		_tmp0_ = _tmp3_;
#line 140 "String.c"
	} else {
		gchar* _tmp4_ = NULL;
#line 53 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		_tmp4_ = g_strdup ((const gchar*) NULL);
#line 53 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		_g_free0 (_tmp0_);
#line 53 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		_tmp0_ = _tmp4_;
#line 149 "String.c"
	}
#line 54 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_tmp6_ = b;
#line 54 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	if (_tmp6_ != NULL) {
#line 155 "String.c"
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
#line 54 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		_tmp7_ = b;
#line 54 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		_tmp8_ = g_utf8_collate_key (_tmp7_, (gssize) (-1));
#line 54 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		_g_free0 (_tmp5_);
#line 54 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		_tmp5_ = _tmp8_;
#line 166 "String.c"
	} else {
		gchar* _tmp9_ = NULL;
#line 54 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		_tmp9_ = g_strdup ((const gchar*) NULL);
#line 54 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		_g_free0 (_tmp5_);
#line 54 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		_tmp5_ = _tmp9_;
#line 175 "String.c"
	}
#line 53 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_tmp10_ = g_strcmp0;
#line 53 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_tmp11_ = _tmp10_ (_tmp0_, _tmp5_);
#line 53 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	result = _tmp11_;
#line 53 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_g_free0 (_tmp5_);
#line 53 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_g_free0 (_tmp0_);
#line 53 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	return result;
#line 189 "String.c"
}


/**
     * Escapes the text for use with Markup.
     *
     * @return escaped text
     */
inline gchar* noise_string_escape (const gchar* text) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 62 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 63 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_tmp0_ = text;
#line 63 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_tmp1_ = g_markup_escape_text (_tmp0_, (gssize) (-1));
#line 63 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	result = _tmp1_;
#line 63 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	return result;
#line 212 "String.c"
}


/**
     * Checks whether a string contains only whitespace.
     *
     * @return //true// if text consists enterely of white space.
     */
static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 1115 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1116 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1116 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1117 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1117 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1118 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	result = _result_;
#line 1118 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	return result;
#line 240 "String.c"
}


inline gboolean noise_string_is_white_space (const gchar* text) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gboolean _tmp5_ = FALSE;
#line 71 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	g_return_val_if_fail (text != NULL, FALSE);
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_tmp0_ = text;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_tmp1_ = string_strip (_tmp0_);
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_tmp2_ = _tmp1_;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_tmp3_ = strlen (_tmp2_);
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_tmp4_ = _tmp3_;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_tmp5_ = _tmp4_ == 0;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_g_free0 (_tmp2_);
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	result = _tmp5_;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	return result;
#line 272 "String.c"
}


/**
     * Removes irrelevant and meaningless characters from a string. Useful for search operations.
     * (Taken from gnome-contacts' contacts-utils.vala)
     */
static gboolean string_get_next_char (const gchar* self, gint* index, gunichar* c) {
	gunichar _vala_c = 0U;
	gboolean result = FALSE;
	gint _tmp0_ = 0;
	gunichar _tmp1_ = 0U;
	gunichar _tmp2_ = 0U;
#line 1015 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1016 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	_tmp0_ = *index;
#line 1016 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	_tmp1_ = g_utf8_get_char (((gchar*) self) + _tmp0_);
#line 1016 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	_vala_c = _tmp1_;
#line 1017 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	_tmp2_ = _vala_c;
#line 1017 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	if (_tmp2_ != ((gunichar) 0)) {
#line 298 "String.c"
		gint _tmp3_ = 0;
		gchar* _tmp4_ = NULL;
#line 1018 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		_tmp3_ = *index;
#line 1018 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		_tmp4_ = g_utf8_next_char (((gchar*) self) + _tmp3_);
#line 1018 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		*index = (gint) (_tmp4_ - ((gchar*) self));
#line 1019 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		result = TRUE;
#line 1019 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		if (c) {
#line 1019 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
			*c = _vala_c;
#line 313 "String.c"
		}
#line 1019 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		return result;
#line 317 "String.c"
	} else {
#line 1021 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		result = FALSE;
#line 1021 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		if (c) {
#line 1021 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
			*c = _vala_c;
#line 325 "String.c"
		}
#line 1021 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		return result;
#line 329 "String.c"
	}
#line 1015 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	if (c) {
#line 1015 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		*c = _vala_c;
#line 335 "String.c"
	}
}


inline gchar* noise_string_canonicalize_for_search (const gchar* str) {
	gchar* result = NULL;
	gunichar* buf = NULL;
	gunichar* _tmp0_ = NULL;
	gint buf_length1 = 0;
	gint _buf_size_ = 0;
	GString* res = NULL;
	GString* _tmp1_ = NULL;
	gunichar c = 0U;
	GString* _tmp16_ = NULL;
	const gchar* _tmp17_ = NULL;
	gchar* _tmp18_ = NULL;
#line 79 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 80 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_tmp0_ = g_new0 (gunichar, G_UNICHAR_MAX_DECOMPOSITION_LENGTH);
#line 80 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	buf = _tmp0_;
#line 80 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	buf_length1 = G_UNICHAR_MAX_DECOMPOSITION_LENGTH;
#line 80 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_buf_size_ = buf_length1;
#line 81 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_tmp1_ = g_string_new ("");
#line 81 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	res = _tmp1_;
#line 366 "String.c"
	{
		gint i = 0;
#line 85 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		i = 0;
#line 371 "String.c"
		{
			gboolean _tmp2_ = FALSE;
#line 85 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
			_tmp2_ = TRUE;
#line 85 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
			while (TRUE) {
#line 378 "String.c"
				const gchar* _tmp3_ = NULL;
				gunichar _tmp4_ = 0U;
				gboolean _tmp5_ = FALSE;
				gunichar sc = 0U;
				gunichar _tmp6_ = 0U;
				gunichar _tmp7_ = 0U;
				gunichar _tmp8_ = 0U;
#line 85 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
				if (!_tmp2_) {
#line 388 "String.c"
				}
#line 85 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
				_tmp2_ = FALSE;
#line 85 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
				_tmp3_ = str;
#line 85 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
				_tmp5_ = string_get_next_char (_tmp3_, &i, &_tmp4_);
#line 85 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
				c = _tmp4_;
#line 85 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
				if (!_tmp5_) {
#line 85 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
					break;
#line 402 "String.c"
				}
#line 86 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
				_tmp6_ = c;
#line 86 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
				_tmp7_ = noise_string_strip_char (_tmp6_);
#line 86 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
				sc = _tmp7_;
#line 88 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
				_tmp8_ = sc;
#line 88 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
				if (_tmp8_ != ((gunichar) 0)) {
#line 414 "String.c"
					gsize size = 0UL;
					gunichar _tmp9_ = 0U;
					gunichar* _tmp10_ = NULL;
					gint _tmp10__length1 = 0;
					gsize _tmp11_ = 0UL;
					gsize _tmp12_ = 0UL;
#line 89 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
					_tmp9_ = sc;
#line 89 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
					_tmp10_ = buf;
#line 89 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
					_tmp10__length1 = buf_length1;
#line 89 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
					_tmp11_ = g_unichar_fully_decompose (_tmp9_, FALSE, _tmp10_, _tmp10__length1);
#line 89 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
					size = _tmp11_;
#line 91 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
					_tmp12_ = size;
#line 91 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
					if (_tmp12_ > ((gsize) 0)) {
#line 435 "String.c"
						GString* _tmp13_ = NULL;
						gunichar* _tmp14_ = NULL;
						gint _tmp14__length1 = 0;
						gunichar _tmp15_ = 0U;
#line 92 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
						_tmp13_ = res;
#line 92 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
						_tmp14_ = buf;
#line 92 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
						_tmp14__length1 = buf_length1;
#line 92 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
						_tmp15_ = _tmp14_[0];
#line 92 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
						g_string_append_unichar (_tmp13_, _tmp15_);
#line 450 "String.c"
					}
				}
			}
		}
	}
#line 96 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_tmp16_ = res;
#line 96 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_tmp17_ = _tmp16_->str;
#line 96 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_tmp18_ = g_strdup (_tmp17_);
#line 96 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	result = _tmp18_;
#line 96 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_g_string_free0 (res);
#line 96 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	buf = (g_free (buf), NULL);
#line 96 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	return result;
#line 470 "String.c"
}


inline gunichar noise_string_strip_char (gunichar ch) {
	gunichar result = 0U;
	gunichar _tmp0_ = 0U;
	GUnicodeType _tmp1_ = 0;
#line 100 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_tmp0_ = ch;
#line 100 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_tmp1_ = g_unichar_type (_tmp0_);
#line 100 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	switch (_tmp1_) {
#line 100 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		case G_UNICODE_CONTROL:
#line 100 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		case G_UNICODE_FORMAT:
#line 100 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		case G_UNICODE_UNASSIGNED:
#line 100 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		case G_UNICODE_NON_SPACING_MARK:
#line 100 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		case G_UNICODE_COMBINING_MARK:
#line 100 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		case G_UNICODE_ENCLOSING_MARK:
#line 100 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		case G_UNICODE_LINE_SEPARATOR:
#line 100 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		case G_UNICODE_SPACE_SEPARATOR:
#line 100 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		case G_UNICODE_PARAGRAPH_SEPARATOR:
#line 100 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		case G_UNICODE_DASH_PUNCTUATION:
#line 100 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		case G_UNICODE_OPEN_PUNCTUATION:
#line 100 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		case G_UNICODE_OTHER_PUNCTUATION:
#line 508 "String.c"
		{
#line 113 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
			result = (gunichar) 0;
#line 113 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
			return result;
#line 514 "String.c"
		}
		default:
		{
			gunichar _tmp2_ = 0U;
			gunichar _tmp3_ = 0U;
#line 115 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
			_tmp2_ = ch;
#line 115 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
			_tmp3_ = g_unichar_tolower (_tmp2_);
#line 115 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
			result = _tmp3_;
#line 115 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
			return result;
#line 528 "String.c"
		}
	}
}


/**
     * Capitalizes the initial letters of a UTF-8 string (Title Case).
     *
     * The implementation is guaranteed to be efficient.
     *
     * For example:
     * "This is an input string" => "This Is An Input String"
     * "example string/text"     => "Example String/Text" 
     */
inline gchar* noise_string_to_title_case (const gchar* text) {
	gchar* result = NULL;
	gboolean capitalize_next = FALSE;
	GString* _result_ = NULL;
	GString* _tmp0_ = NULL;
	gunichar c = 0U;
	GString* _tmp17_ = NULL;
	const gchar* _tmp18_ = NULL;
	gchar* _tmp19_ = NULL;
#line 128 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 129 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	capitalize_next = TRUE;
#line 131 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_tmp0_ = g_string_new ("");
#line 131 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_result_ = _tmp0_;
#line 560 "String.c"
	{
		gint i = 0;
#line 134 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		i = 0;
#line 565 "String.c"
		{
			gboolean _tmp1_ = FALSE;
#line 134 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
			_tmp1_ = TRUE;
#line 134 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
			while (TRUE) {
#line 572 "String.c"
				const gchar* _tmp2_ = NULL;
				gunichar _tmp3_ = 0U;
				gboolean _tmp4_ = FALSE;
				gboolean _tmp5_ = FALSE;
#line 134 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
				if (!_tmp1_) {
#line 579 "String.c"
				}
#line 134 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
				_tmp1_ = FALSE;
#line 134 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
				_tmp2_ = text;
#line 134 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
				_tmp4_ = string_get_next_char (_tmp2_, &i, &_tmp3_);
#line 134 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
				c = _tmp3_;
#line 134 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
				if (!_tmp4_) {
#line 134 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
					break;
#line 593 "String.c"
				}
#line 135 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
				_tmp5_ = capitalize_next;
#line 135 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
				if (_tmp5_) {
#line 599 "String.c"
					GString* _tmp6_ = NULL;
					gunichar _tmp7_ = 0U;
					gunichar _tmp8_ = 0U;
#line 136 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
					_tmp6_ = _result_;
#line 136 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
					_tmp7_ = c;
#line 136 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
					_tmp8_ = g_unichar_totitle (_tmp7_);
#line 136 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
					g_string_append_unichar (_tmp6_, _tmp8_);
#line 137 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
					capitalize_next = FALSE;
#line 613 "String.c"
				} else {
					GString* _tmp9_ = NULL;
					gunichar _tmp10_ = 0U;
					gunichar _tmp11_ = 0U;
					gboolean _tmp12_ = FALSE;
					gunichar _tmp13_ = 0U;
					gboolean _tmp14_ = FALSE;
#line 139 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
					_tmp9_ = _result_;
#line 139 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
					_tmp10_ = c;
#line 139 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
					_tmp11_ = g_unichar_tolower (_tmp10_);
#line 139 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
					g_string_append_unichar (_tmp9_, _tmp11_);
#line 142 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
					_tmp13_ = c;
#line 142 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
					_tmp14_ = g_unichar_isspace (_tmp13_);
#line 142 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
					if (_tmp14_) {
#line 142 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
						_tmp12_ = TRUE;
#line 637 "String.c"
					} else {
						gunichar _tmp15_ = 0U;
						gboolean _tmp16_ = FALSE;
#line 142 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
						_tmp15_ = c;
#line 142 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
						_tmp16_ = g_unichar_iscntrl (_tmp15_);
#line 142 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
						_tmp12_ = _tmp16_;
#line 647 "String.c"
					}
#line 142 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
					capitalize_next = _tmp12_;
#line 651 "String.c"
				}
			}
		}
	}
#line 146 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_tmp17_ = _result_;
#line 146 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_tmp18_ = _tmp17_->str;
#line 146 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_tmp19_ = g_strdup (_tmp18_);
#line 146 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	result = _tmp19_;
#line 146 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_g_string_free0 (_result_);
#line 146 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	return result;
#line 668 "String.c"
}


/**
     * Converts a string encoded in the native operating system encoding to UTF-8.
     *
     * @param string_locale String in locale encoding.
     * @return String encoded in UTF-8, or //null// if the string could not be converted.
     */
gchar* noise_string_locale_to_utf8 (const gchar* string_locale) {
	gchar* result = NULL;
	GError* _error_ = NULL;
	gsize bytes_read = 0UL;
	gsize bytes_written = 0UL;
	gchar* string_utf8 = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gsize _tmp4_ = 0UL;
	gsize _tmp5_ = 0UL;
	GError* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	GError* _tmp8_ = NULL;
#line 155 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	g_return_val_if_fail (string_locale != NULL, NULL);
#line 158 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_tmp0_ = string_locale;
#line 158 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_tmp1_ = string_locale;
#line 158 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_tmp2_ = strlen (_tmp1_);
#line 158 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_tmp3_ = _tmp2_;
#line 158 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_tmp7_ = g_locale_to_utf8 (_tmp0_, (gssize) _tmp3_, &_tmp4_, &_tmp5_, &_tmp6_);
#line 158 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	bytes_read = _tmp4_;
#line 158 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	bytes_written = _tmp5_;
#line 158 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_g_error_free0 (_error_);
#line 158 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_error_ = _tmp6_;
#line 158 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	string_utf8 = _tmp7_;
#line 162 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_tmp8_ = _error_;
#line 162 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	if (_tmp8_ != NULL) {
#line 163 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		_g_free0 (string_utf8);
#line 163 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		string_utf8 = NULL;
#line 723 "String.c"
	}
#line 165 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	result = string_utf8;
#line 165 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_g_error_free0 (_error_);
#line 165 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	return result;
#line 731 "String.c"
}


/**
     * Base method used for searches. It does a previous parsing on the search string.
     *
     * If the output value of parsed_rating is greater than 0, then the view should
     * only display the media with that rating in the search results, and ignore
     * the value of parsed_search_string.
     *
     * @param search Non-parsed version of the search string.
     * @param parsed_rating location where the parsed rating it stored, or -1 if the
     * string didn't represent a valid rating.
     * @param parsed_search_string location where the canonicalized version of the
     * search string is stored. Should be passed to the methods in Noise.Search.
     */
void noise_string_base_search_method (const gchar* search, gint* parsed_rating, gchar** parsed_search_string) {
	gint _vala_parsed_rating = 0;
	gchar* _vala_parsed_search_string = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	const gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
#line 181 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	g_return_if_fail (search != NULL);
#line 184 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_tmp0_ = search;
#line 184 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_tmp1_ = string_strip (_tmp0_);
#line 184 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_tmp2_ = _tmp1_;
#line 184 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_tmp3_ = noise_search_get_rating_from_string (_tmp2_);
#line 184 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_vala_parsed_rating = _tmp3_;
#line 184 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_g_free0 (_tmp2_);
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_tmp4_ = _vala_parsed_rating;
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	if (_tmp4_ > 0) {
#line 776 "String.c"
		gint _tmp5_ = 0;
		gint _tmp6_ = 0;
#line 187 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		_tmp5_ = _vala_parsed_rating;
#line 187 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		_tmp6_ = CLAMP (_tmp5_, 1, 5);
#line 187 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		_vala_parsed_rating = _tmp6_;
#line 785 "String.c"
	}
#line 189 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_tmp7_ = search;
#line 189 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_tmp8_ = noise_search_get_valid_search_string (_tmp7_);
#line 189 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_g_free0 (_vala_parsed_search_string);
#line 189 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	_vala_parsed_search_string = _tmp8_;
#line 181 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	if (parsed_rating) {
#line 181 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		*parsed_rating = _vala_parsed_rating;
#line 799 "String.c"
	}
#line 181 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
	if (parsed_search_string) {
#line 181 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		*parsed_search_string = _vala_parsed_search_string;
#line 805 "String.c"
	} else {
#line 181 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/String.vala"
		_g_free0 (_vala_parsed_search_string);
#line 809 "String.c"
	}
}



