/* TimeUtils.c generated by valac 0.28.1, the Vala compiler
 * generated from TimeUtils.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*
 * Copyright (c) 2012-2013 Noise Developers (http://launchpad.net/noise)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Victor Eduardo <victoreduardm@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <time.h>

#define _g_free0(var) (var = (g_free (var), NULL))



#define NOISE_TIME_UTILS_SECONDS_PER_MINUTE ((guint) 60)
#define NOISE_TIME_UTILS_SECONDS_PER_HOUR (60 * NOISE_TIME_UTILS_SECONDS_PER_MINUTE)
#define NOISE_TIME_UTILS_SECONDS_PER_DAY (24 * NOISE_TIME_UTILS_SECONDS_PER_HOUR)
gchar* noise_time_utils_time_string_from_seconds (guint seconds);
guint noise_numeric_lowest_uint_from_double (gdouble number) G_GNUC_DEPRECATED;
guint noise_numeric_uint_from_double (gdouble number) G_GNUC_DEPRECATED;
gchar* noise_time_utils_time_string_from_miliseconds (guint64 miliseconds);
#define NOISE_NUMERIC_MILI_INV ((guint64) 1000)
gchar* noise_time_utils_time_string_from_nanoseconds (guint64 nanoseconds);
#define NOISE_NUMERIC_NANO_INV ((guint64) 1000000000)
gchar* noise_time_utils_pretty_length (guint seconds);
gchar* noise_time_utils_pretty_length_from_ms (guint64 mseconds);
gchar* noise_time_utils_pretty_length_from_ns (guint64 nseconds);
gchar* noise_time_utils_pretty_timestamp_from_time (struct tm* dt);
gchar* noise_time_utils_pretty_timestamp_from_uint (guint time);
guint noise_time_utils_nanoseconds_to_miliseconds (guint64 nanoseconds);
guint64 noise_time_utils_miliseconds_to_nanoseconds (guint miliseconds);


/**
     * Receives the number of seconds and returns a string with format:
     * "%i days, %i hours and %i minutes", "%i seconds", "%i minutes and %i seconds",
     * or similar.
     */
inline gchar* noise_time_utils_time_string_from_seconds (guint seconds) {
	gchar* result = NULL;
	guint _tmp0_ = 0U;
	gchar* days_string = NULL;
	gchar* _tmp5_ = NULL;
	gchar* hours_string = NULL;
	gchar* _tmp6_ = NULL;
	gchar* minutes_string = NULL;
	gchar* _tmp7_ = NULL;
	gchar* seconds_string = NULL;
	gchar* _tmp8_ = NULL;
	guint days = 0U;
	guint hours = 0U;
	guint minutes = 0U;
	guint _tmp9_ = 0U;
	guint _tmp27_ = 0U;
	guint _tmp28_ = 0U;
	guint _tmp29_ = 0U;
	guint _tmp30_ = 0U;
	guint _tmp31_ = 0U;
	guint _tmp32_ = 0U;
	guint _tmp33_ = 0U;
	guint _tmp34_ = 0U;
	guint _tmp35_ = 0U;
	guint _tmp36_ = 0U;
	guint _tmp37_ = 0U;
	guint _tmp42_ = 0U;
	guint _tmp47_ = 0U;
	gchar* rv = NULL;
	gchar* _tmp52_ = NULL;
	guint _tmp53_ = 0U;
#line 43 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp0_ = seconds;
#line 43 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	if (_tmp0_ < NOISE_TIME_UTILS_SECONDS_PER_MINUTE) {
#line 107 "TimeUtils.c"
		guint _tmp1_ = 0U;
		const gchar* _tmp2_ = NULL;
		guint _tmp3_ = 0U;
		gchar* _tmp4_ = NULL;
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_tmp1_ = seconds;
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_tmp2_ = ngettext ("%d second", "%d seconds", (gulong) _tmp1_);
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_tmp3_ = seconds;
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_tmp4_ = g_strdup_printf (_tmp2_, _tmp3_);
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		result = _tmp4_;
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		return result;
#line 124 "TimeUtils.c"
	}
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp5_ = g_strdup ("");
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	days_string = _tmp5_;
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp6_ = g_strdup ("");
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	hours_string = _tmp6_;
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp7_ = g_strdup ("");
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	minutes_string = _tmp7_;
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp8_ = g_strdup ("");
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	seconds_string = _tmp8_;
#line 47 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	days = (guint) 0;
#line 47 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	hours = (guint) 0;
#line 47 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	minutes = (guint) 0;
#line 50 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp9_ = seconds;
#line 50 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	if (_tmp9_ < NOISE_TIME_UTILS_SECONDS_PER_HOUR) {
#line 152 "TimeUtils.c"
		guint _tmp10_ = 0U;
		guint _tmp11_ = 0U;
		guint _tmp12_ = 0U;
		const gchar* _tmp13_ = NULL;
		guint _tmp14_ = 0U;
		gchar* _tmp15_ = NULL;
		guint _tmp16_ = 0U;
		guint _tmp17_ = 0U;
		guint _tmp18_ = 0U;
#line 51 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_tmp10_ = seconds;
#line 51 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_tmp11_ = noise_numeric_lowest_uint_from_double ((gdouble) (_tmp10_ / NOISE_TIME_UTILS_SECONDS_PER_MINUTE));
#line 51 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		minutes = _tmp11_;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_tmp12_ = minutes;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_tmp13_ = ngettext ("%u minute", "%u minutes", (gulong) _tmp12_);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_tmp14_ = minutes;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_tmp15_ = g_strdup_printf (_tmp13_, _tmp14_);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_g_free0 (minutes_string);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		minutes_string = _tmp15_;
#line 53 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_tmp16_ = seconds;
#line 53 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_tmp17_ = minutes;
#line 53 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		seconds = _tmp16_ - (_tmp17_ * NOISE_TIME_UTILS_SECONDS_PER_MINUTE);
#line 55 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_tmp18_ = seconds;
#line 55 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		if (_tmp18_ > ((guint) 0)) {
#line 190 "TimeUtils.c"
			guint _tmp19_ = 0U;
			const gchar* _tmp20_ = NULL;
			guint _tmp21_ = 0U;
			gchar* _tmp22_ = NULL;
			const gchar* _tmp23_ = NULL;
			const gchar* _tmp24_ = NULL;
			const gchar* _tmp25_ = NULL;
			gchar* _tmp26_ = NULL;
#line 56 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
			_tmp19_ = seconds;
#line 56 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
			_tmp20_ = ngettext ("%u second", "%u seconds", (gulong) _tmp19_);
#line 56 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
			_tmp21_ = seconds;
#line 56 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
			_tmp22_ = g_strdup_printf (_tmp20_, _tmp21_);
#line 56 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
			_g_free0 (seconds_string);
#line 56 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
			seconds_string = _tmp22_;
#line 58 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
			_tmp23_ = C_ ("minutes and seconds", "%s and %s");
#line 58 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
			_tmp24_ = minutes_string;
#line 58 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
			_tmp25_ = seconds_string;
#line 58 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
			_tmp26_ = g_strdup_printf (_tmp23_, _tmp24_, _tmp25_);
#line 58 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
			result = _tmp26_;
#line 58 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
			_g_free0 (seconds_string);
#line 58 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
			_g_free0 (minutes_string);
#line 58 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
			_g_free0 (hours_string);
#line 58 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
			_g_free0 (days_string);
#line 58 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
			return result;
#line 231 "TimeUtils.c"
		}
#line 61 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		result = minutes_string;
#line 61 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_g_free0 (seconds_string);
#line 61 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_g_free0 (hours_string);
#line 61 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_g_free0 (days_string);
#line 61 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		return result;
#line 243 "TimeUtils.c"
	}
#line 65 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp27_ = seconds;
#line 65 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp28_ = noise_numeric_lowest_uint_from_double ((gdouble) (_tmp27_ / NOISE_TIME_UTILS_SECONDS_PER_DAY));
#line 65 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	days = _tmp28_;
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp29_ = seconds;
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp30_ = days;
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	seconds = _tmp29_ - (_tmp30_ * NOISE_TIME_UTILS_SECONDS_PER_DAY);
#line 69 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp31_ = seconds;
#line 69 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp32_ = noise_numeric_lowest_uint_from_double ((gdouble) (_tmp31_ / NOISE_TIME_UTILS_SECONDS_PER_HOUR));
#line 69 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	hours = _tmp32_;
#line 70 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp33_ = seconds;
#line 70 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp34_ = hours;
#line 70 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	seconds = _tmp33_ - (_tmp34_ * NOISE_TIME_UTILS_SECONDS_PER_HOUR);
#line 74 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp35_ = seconds;
#line 74 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp36_ = noise_numeric_uint_from_double ((gdouble) (_tmp35_ / NOISE_TIME_UTILS_SECONDS_PER_MINUTE));
#line 74 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	minutes = _tmp36_;
#line 76 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp37_ = days;
#line 76 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	if (_tmp37_ > ((guint) 0)) {
#line 279 "TimeUtils.c"
		guint _tmp38_ = 0U;
		const gchar* _tmp39_ = NULL;
		guint _tmp40_ = 0U;
		gchar* _tmp41_ = NULL;
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_tmp38_ = days;
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_tmp39_ = ngettext ("%u day", "%u days", (gulong) _tmp38_);
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_tmp40_ = days;
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_tmp41_ = g_strdup_printf (_tmp39_, _tmp40_);
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_g_free0 (days_string);
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		days_string = _tmp41_;
#line 296 "TimeUtils.c"
	}
#line 79 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp42_ = hours;
#line 79 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	if (_tmp42_ > ((guint) 0)) {
#line 302 "TimeUtils.c"
		guint _tmp43_ = 0U;
		const gchar* _tmp44_ = NULL;
		guint _tmp45_ = 0U;
		gchar* _tmp46_ = NULL;
#line 80 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_tmp43_ = hours;
#line 80 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_tmp44_ = ngettext ("%u hour", "%u hours", (gulong) _tmp43_);
#line 80 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_tmp45_ = hours;
#line 80 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_tmp46_ = g_strdup_printf (_tmp44_, _tmp45_);
#line 80 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_g_free0 (hours_string);
#line 80 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		hours_string = _tmp46_;
#line 319 "TimeUtils.c"
	}
#line 82 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp47_ = minutes;
#line 82 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	if (_tmp47_ > ((guint) 0)) {
#line 325 "TimeUtils.c"
		guint _tmp48_ = 0U;
		const gchar* _tmp49_ = NULL;
		guint _tmp50_ = 0U;
		gchar* _tmp51_ = NULL;
#line 83 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_tmp48_ = minutes;
#line 83 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_tmp49_ = ngettext ("%u minute", "%u minutes", (gulong) _tmp48_);
#line 83 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_tmp50_ = minutes;
#line 83 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_tmp51_ = g_strdup_printf (_tmp49_, _tmp50_);
#line 83 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_g_free0 (minutes_string);
#line 83 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		minutes_string = _tmp51_;
#line 342 "TimeUtils.c"
	}
#line 85 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp52_ = g_strdup ("");
#line 85 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	rv = _tmp52_;
#line 87 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp53_ = days;
#line 87 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	if (_tmp53_ > ((guint) 0)) {
#line 352 "TimeUtils.c"
		guint _tmp54_ = 0U;
#line 88 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_tmp54_ = hours;
#line 88 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		if (_tmp54_ > ((guint) 0)) {
#line 358 "TimeUtils.c"
			guint _tmp55_ = 0U;
#line 89 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
			_tmp55_ = minutes;
#line 89 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
			if (_tmp55_ > ((guint) 0)) {
#line 364 "TimeUtils.c"
				const gchar* _tmp56_ = NULL;
				const gchar* _tmp57_ = NULL;
				const gchar* _tmp58_ = NULL;
				const gchar* _tmp59_ = NULL;
				gchar* _tmp60_ = NULL;
#line 91 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
				_tmp56_ = C_ ("days, hours and minutes", "%s, %s and %s");
#line 91 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
				_tmp57_ = days_string;
#line 91 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
				_tmp58_ = hours_string;
#line 91 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
				_tmp59_ = minutes_string;
#line 91 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
				_tmp60_ = g_strdup_printf (_tmp56_, _tmp57_, _tmp58_, _tmp59_);
#line 91 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
				_g_free0 (rv);
#line 91 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
				rv = _tmp60_;
#line 384 "TimeUtils.c"
			} else {
				const gchar* _tmp61_ = NULL;
				const gchar* _tmp62_ = NULL;
				const gchar* _tmp63_ = NULL;
				gchar* _tmp64_ = NULL;
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
				_tmp61_ = C_ ("days and hours", "%s and %s");
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
				_tmp62_ = days_string;
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
				_tmp63_ = hours_string;
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
				_tmp64_ = g_strdup_printf (_tmp61_, _tmp62_, _tmp63_);
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
				_g_free0 (rv);
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
				rv = _tmp64_;
#line 402 "TimeUtils.c"
			}
		} else {
			guint _tmp65_ = 0U;
#line 97 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
			_tmp65_ = minutes;
#line 97 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
			if (_tmp65_ > ((guint) 0)) {
#line 410 "TimeUtils.c"
				const gchar* _tmp66_ = NULL;
				const gchar* _tmp67_ = NULL;
				const gchar* _tmp68_ = NULL;
				gchar* _tmp69_ = NULL;
#line 99 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
				_tmp66_ = C_ ("days and minutes", "%s and %s");
#line 99 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
				_tmp67_ = days_string;
#line 99 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
				_tmp68_ = minutes_string;
#line 99 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
				_tmp69_ = g_strdup_printf (_tmp66_, _tmp67_, _tmp68_);
#line 99 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
				_g_free0 (rv);
#line 99 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
				rv = _tmp69_;
#line 427 "TimeUtils.c"
			} else {
				const gchar* _tmp70_ = NULL;
				gchar* _tmp71_ = NULL;
#line 101 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
				_tmp70_ = days_string;
#line 101 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
				_tmp71_ = g_strdup (_tmp70_);
#line 101 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
				_g_free0 (rv);
#line 101 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
				rv = _tmp71_;
#line 439 "TimeUtils.c"
			}
		}
	} else {
		guint _tmp72_ = 0U;
#line 105 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_tmp72_ = hours;
#line 105 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		if (_tmp72_ > ((guint) 0)) {
#line 448 "TimeUtils.c"
			guint _tmp73_ = 0U;
#line 106 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
			_tmp73_ = minutes;
#line 106 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
			if (_tmp73_ > ((guint) 0)) {
#line 454 "TimeUtils.c"
				const gchar* _tmp74_ = NULL;
				const gchar* _tmp75_ = NULL;
				const gchar* _tmp76_ = NULL;
				gchar* _tmp77_ = NULL;
#line 108 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
				_tmp74_ = C_ ("hours and minutes", "%s and %s");
#line 108 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
				_tmp75_ = hours_string;
#line 108 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
				_tmp76_ = minutes_string;
#line 108 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
				_tmp77_ = g_strdup_printf (_tmp74_, _tmp75_, _tmp76_);
#line 108 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
				_g_free0 (rv);
#line 108 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
				rv = _tmp77_;
#line 471 "TimeUtils.c"
			} else {
				const gchar* _tmp78_ = NULL;
				gchar* _tmp79_ = NULL;
#line 110 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
				_tmp78_ = hours_string;
#line 110 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
				_tmp79_ = g_strdup (_tmp78_);
#line 110 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
				_g_free0 (rv);
#line 110 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
				rv = _tmp79_;
#line 483 "TimeUtils.c"
			}
		} else {
			const gchar* _tmp80_ = NULL;
			gchar* _tmp81_ = NULL;
			const gchar* _tmp82_ = NULL;
#line 114 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
			_tmp80_ = minutes_string;
#line 114 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
			_tmp81_ = g_strdup (_tmp80_);
#line 114 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
			_g_free0 (rv);
#line 114 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
			rv = _tmp81_;
#line 115 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
			_tmp82_ = rv;
#line 115 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
			g_warning ("TimeUtils.vala:115: Minutes string '%s'. Should not be reached", _tmp82_);
#line 501 "TimeUtils.c"
		}
	}
#line 119 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	result = rv;
#line 119 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_g_free0 (seconds_string);
#line 119 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_g_free0 (minutes_string);
#line 119 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_g_free0 (hours_string);
#line 119 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_g_free0 (days_string);
#line 119 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	return result;
#line 516 "TimeUtils.c"
}


inline gchar* noise_time_utils_time_string_from_miliseconds (guint64 miliseconds) {
	gchar* result = NULL;
	guint64 _tmp0_ = 0ULL;
	gchar* _tmp1_ = NULL;
#line 123 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp0_ = miliseconds;
#line 123 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp1_ = noise_time_utils_time_string_from_seconds ((guint) (_tmp0_ / NOISE_NUMERIC_MILI_INV));
#line 123 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	result = _tmp1_;
#line 123 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	return result;
#line 532 "TimeUtils.c"
}


inline gchar* noise_time_utils_time_string_from_nanoseconds (guint64 nanoseconds) {
	gchar* result = NULL;
	guint64 _tmp0_ = 0ULL;
	gchar* _tmp1_ = NULL;
#line 127 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp0_ = nanoseconds;
#line 127 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp1_ = noise_time_utils_time_string_from_seconds ((guint) (_tmp0_ / NOISE_NUMERIC_NANO_INV));
#line 127 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	result = _tmp1_;
#line 127 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	return result;
#line 548 "TimeUtils.c"
}


/**
     * Receives the number of seconds and returns a string with format MM:SS
     */
inline gchar* noise_time_utils_pretty_length (guint seconds) {
	gchar* result = NULL;
	guint _tmp0_ = 0U;
	guint hours = 0U;
	guint _tmp8_ = 0U;
	guint _tmp9_ = 0U;
	guint _tmp10_ = 0U;
	guint _tmp11_ = 0U;
	guint minutes = 0U;
	guint _tmp12_ = 0U;
	guint _tmp13_ = 0U;
	guint _tmp14_ = 0U;
	guint _tmp15_ = 0U;
	guint _tmp16_ = 0U;
	guint _tmp17_ = 0U;
	guint _tmp18_ = 0U;
	gchar* _tmp19_ = NULL;
#line 134 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp0_ = seconds;
#line 134 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	if (_tmp0_ < NOISE_TIME_UTILS_SECONDS_PER_HOUR) {
#line 576 "TimeUtils.c"
		guint minutes = 0U;
		guint _tmp1_ = 0U;
		guint _tmp2_ = 0U;
		guint _tmp3_ = 0U;
		guint _tmp4_ = 0U;
		guint _tmp5_ = 0U;
		guint _tmp6_ = 0U;
		gchar* _tmp7_ = NULL;
#line 135 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_tmp1_ = seconds;
#line 135 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_tmp2_ = noise_numeric_lowest_uint_from_double ((gdouble) (_tmp1_ / NOISE_TIME_UTILS_SECONDS_PER_MINUTE));
#line 135 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		minutes = _tmp2_;
#line 136 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_tmp3_ = seconds;
#line 136 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_tmp4_ = minutes;
#line 136 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		seconds = _tmp3_ - (_tmp4_ * NOISE_TIME_UTILS_SECONDS_PER_MINUTE);
#line 137 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_tmp5_ = minutes;
#line 137 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_tmp6_ = seconds;
#line 137 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		_tmp7_ = g_strdup_printf ("%u:%02u", _tmp5_, _tmp6_);
#line 137 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		result = _tmp7_;
#line 137 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
		return result;
#line 607 "TimeUtils.c"
	}
#line 140 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp8_ = seconds;
#line 140 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp9_ = noise_numeric_lowest_uint_from_double ((gdouble) (_tmp8_ / NOISE_TIME_UTILS_SECONDS_PER_HOUR));
#line 140 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	hours = _tmp9_;
#line 141 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp10_ = seconds;
#line 141 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp11_ = hours;
#line 141 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	seconds = _tmp10_ - (_tmp11_ * NOISE_TIME_UTILS_SECONDS_PER_HOUR);
#line 142 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp12_ = seconds;
#line 142 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp13_ = noise_numeric_lowest_uint_from_double ((gdouble) (_tmp12_ / NOISE_TIME_UTILS_SECONDS_PER_MINUTE));
#line 142 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	minutes = _tmp13_;
#line 143 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp14_ = seconds;
#line 143 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp15_ = minutes;
#line 143 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	seconds = _tmp14_ - (_tmp15_ * NOISE_TIME_UTILS_SECONDS_PER_MINUTE);
#line 144 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp16_ = hours;
#line 144 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp17_ = minutes;
#line 144 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp18_ = seconds;
#line 144 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp19_ = g_strdup_printf ("%u:%02u:%02u", _tmp16_, _tmp17_, _tmp18_);
#line 144 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	result = _tmp19_;
#line 144 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	return result;
#line 645 "TimeUtils.c"
}


/**
     * Receives the number of miliseconds and returns a string with format MM:SS
     */
inline gchar* noise_time_utils_pretty_length_from_ms (guint64 mseconds) {
	gchar* result = NULL;
	guint64 _tmp0_ = 0ULL;
	gchar* _tmp1_ = NULL;
#line 151 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp0_ = mseconds;
#line 151 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp1_ = noise_time_utils_pretty_length ((guint) (_tmp0_ / NOISE_NUMERIC_MILI_INV));
#line 151 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	result = _tmp1_;
#line 151 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	return result;
#line 664 "TimeUtils.c"
}


/**
     * Receives the number of nanoseconds and returns a string with format MM:SS
     */
inline gchar* noise_time_utils_pretty_length_from_ns (guint64 nseconds) {
	gchar* result = NULL;
	guint64 _tmp0_ = 0ULL;
	gchar* _tmp1_ = NULL;
#line 158 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp0_ = nseconds;
#line 158 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp1_ = noise_time_utils_pretty_length ((guint) (_tmp0_ / NOISE_NUMERIC_NANO_INV));
#line 158 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	result = _tmp1_;
#line 158 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	return result;
#line 683 "TimeUtils.c"
}


/**
     * Returns a formatted date and time string.
     */
static gchar* g_time_format (struct tm *self, const gchar* format) {
	gchar* result = NULL;
	gchar* buffer = NULL;
	gchar* _tmp0_ = NULL;
	gint buffer_length1 = 0;
	gint _buffer_size_ = 0;
	gchar* _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	gchar* _tmp4_ = NULL;
#line 2523 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	g_return_val_if_fail (format != NULL, NULL);
#line 2524 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, 64);
#line 2524 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	buffer = _tmp0_;
#line 2524 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	buffer_length1 = 64;
#line 2524 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	_buffer_size_ = buffer_length1;
#line 2525 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	_tmp1_ = buffer;
#line 2525 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	_tmp1__length1 = buffer_length1;
#line 2525 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	_tmp2_ = format;
#line 2525 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	strftime (_tmp1_, _tmp1__length1, _tmp2_, &(*self));
#line 2526 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	_tmp3_ = buffer;
#line 2526 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	_tmp3__length1 = buffer_length1;
#line 2526 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	_tmp4_ = g_strdup ((const gchar*) _tmp3_);
#line 2526 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	result = _tmp4_;
#line 2526 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	buffer = (g_free (buffer), NULL);
#line 2526 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	return result;
#line 732 "TimeUtils.c"
}


inline gchar* noise_time_utils_pretty_timestamp_from_time (struct tm* dt) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 164 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	g_return_val_if_fail (dt != NULL, NULL);
#line 167 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp0_ = _ ("%m/%e/%Y %l:%M %p");
#line 167 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp1_ = g_time_format (dt, _tmp0_);
#line 167 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	result = _tmp1_;
#line 167 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	return result;
#line 750 "TimeUtils.c"
}


static void g_time_local (time_t time, struct tm* result) {
	struct tm _result_ = {0};
	struct tm _tmp0_ = {0};
#line 2515 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	localtime_r (&time, &_tmp0_);
#line 2515 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 2516 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	*result = _result_;
#line 2516 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	return;
#line 765 "TimeUtils.c"
}


inline gchar* noise_time_utils_pretty_timestamp_from_uint (guint time) {
	gchar* result = NULL;
	struct tm dt = {0};
	guint _tmp0_ = 0U;
	struct tm _tmp1_ = {0};
	struct tm _tmp2_ = {0};
	gchar* _tmp3_ = NULL;
#line 171 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp0_ = time;
#line 171 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	g_time_local ((time_t) _tmp0_, &_tmp1_);
#line 171 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	dt = _tmp1_;
#line 172 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp2_ = dt;
#line 172 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp3_ = noise_time_utils_pretty_timestamp_from_time (&_tmp2_);
#line 172 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	result = _tmp3_;
#line 172 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	return result;
#line 790 "TimeUtils.c"
}


/**
     * Convert from nanoseconds (10E-9) to miliseconds (10E-3);
     *
     * This is used extensively because {@link Noise.Media} stores
     * miliseconds, while GStreamer uses nanoseconds.
     *
     * The method does its best to avoid losing precision.
     */
inline guint noise_time_utils_nanoseconds_to_miliseconds (guint64 nanoseconds) {
	guint result = 0U;
	guint64 _tmp0_ = 0ULL;
#line 184 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp0_ = nanoseconds;
#line 184 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	result = (guint) ((_tmp0_ * NOISE_NUMERIC_MILI_INV) / NOISE_NUMERIC_NANO_INV);
#line 184 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	return result;
#line 811 "TimeUtils.c"
}


inline guint64 noise_time_utils_miliseconds_to_nanoseconds (guint miliseconds) {
	guint64 result = 0ULL;
	guint _tmp0_ = 0U;
#line 188 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	_tmp0_ = miliseconds;
#line 188 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	result = (((guint64) _tmp0_) * NOISE_NUMERIC_NANO_INV) / NOISE_NUMERIC_MILI_INV;
#line 188 "/usr/src/RPM/BUILD/noise-0.3.1/core/Utils/TimeUtils.vala"
	return result;
#line 824 "TimeUtils.c"
}



