/* Media.c generated by valac 0.28.1, the Vala compiler
 * generated from Media.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2013 Noise Developers (http://launchpad.net/noise)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Victor Eduardo <victoreduardm@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>


#define NOISE_TYPE_MEDIA (noise_media_get_type ())
#define NOISE_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_MEDIA, NoiseMedia))
#define NOISE_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_MEDIA, NoiseMediaClass))
#define NOISE_IS_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_MEDIA))
#define NOISE_IS_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_MEDIA))
#define NOISE_MEDIA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_MEDIA, NoiseMediaClass))

typedef struct _NoiseMedia NoiseMedia;
typedef struct _NoiseMediaClass NoiseMediaClass;
typedef struct _NoiseMediaPrivate NoiseMediaPrivate;

#define NOISE_TYPE_ALBUM (noise_album_get_type ())
#define NOISE_ALBUM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_ALBUM, NoiseAlbum))
#define NOISE_ALBUM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_ALBUM, NoiseAlbumClass))
#define NOISE_IS_ALBUM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_ALBUM))
#define NOISE_IS_ALBUM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_ALBUM))
#define NOISE_ALBUM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_ALBUM, NoiseAlbumClass))

typedef struct _NoiseAlbum NoiseAlbum;
typedef struct _NoiseAlbumClass NoiseAlbumClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _NoiseMedia {
	GObject parent_instance;
	NoiseMediaPrivate * priv;
	guint _rating;
};

struct _NoiseMediaClass {
	GObjectClass parent_class;
	gchar* (*get_uri) (NoiseMedia* self);
	void (*set_uri) (NoiseMedia* self, const gchar* value);
	guint64 (*get_file_size) (NoiseMedia* self);
	void (*set_file_size) (NoiseMedia* self, guint64 value);
	gboolean (*get_file_exists) (NoiseMedia* self);
	GFile* (*get_file) (NoiseMedia* self);
	void (*set_file) (NoiseMedia* self, GFile* value);
	gboolean (*get_isPreview) (NoiseMedia* self);
	void (*set_isPreview) (NoiseMedia* self, gboolean value);
	gboolean (*get_isTemporary) (NoiseMedia* self);
	void (*set_isTemporary) (NoiseMedia* self, gboolean value);
	gboolean (*get_location_unknown) (NoiseMedia* self);
	void (*set_location_unknown) (NoiseMedia* self, gboolean value);
	gboolean (*get_has_embedded) (NoiseMedia* self);
	void (*set_has_embedded) (NoiseMedia* self, gboolean value);
	GIcon* (*get_unique_status_image) (NoiseMedia* self);
	void (*set_unique_status_image) (NoiseMedia* self, GIcon* value);
	gboolean (*get_showIndicator) (NoiseMedia* self);
	void (*set_showIndicator) (NoiseMedia* self, gboolean value);
	const gchar* (*get_title) (NoiseMedia* self);
	void (*set_title) (NoiseMedia* self, const gchar* value);
	guint (*get_track) (NoiseMedia* self);
	void (*set_track) (NoiseMedia* self, guint value);
	guint (*get_track_count) (NoiseMedia* self);
	void (*set_track_count) (NoiseMedia* self, guint value);
	const gchar* (*get_composer) (NoiseMedia* self);
	void (*set_composer) (NoiseMedia* self, const gchar* value);
	const gchar* (*get_artist) (NoiseMedia* self);
	void (*set_artist) (NoiseMedia* self, const gchar* value);
	const gchar* (*get_album_artist) (NoiseMedia* self);
	void (*set_album_artist) (NoiseMedia* self, const gchar* value);
	const gchar* (*get_album) (NoiseMedia* self);
	void (*set_album) (NoiseMedia* self, const gchar* value);
	guint (*get_album_number) (NoiseMedia* self);
	void (*set_album_number) (NoiseMedia* self, guint value);
	guint (*get_album_count) (NoiseMedia* self);
	void (*set_album_count) (NoiseMedia* self, guint value);
	NoiseAlbum* (*get_album_info) (NoiseMedia* self);
	void (*set_album_info) (NoiseMedia* self, NoiseAlbum* value);
	const gchar* (*get_grouping) (NoiseMedia* self);
	void (*set_grouping) (NoiseMedia* self, const gchar* value);
	const gchar* (*get_genre) (NoiseMedia* self);
	void (*set_genre) (NoiseMedia* self, const gchar* value);
	const gchar* (*get_comment) (NoiseMedia* self);
	void (*set_comment) (NoiseMedia* self, const gchar* value);
	const gchar* (*get_lyrics) (NoiseMedia* self);
	void (*set_lyrics) (NoiseMedia* self, const gchar* value);
	guint (*get_year) (NoiseMedia* self);
	void (*set_year) (NoiseMedia* self, guint value);
	guint (*get_bitrate) (NoiseMedia* self);
	void (*set_bitrate) (NoiseMedia* self, guint value);
	guint (*get_bpm) (NoiseMedia* self);
	void (*set_bpm) (NoiseMedia* self, guint value);
	guint (*get_samplerate) (NoiseMedia* self);
	void (*set_samplerate) (NoiseMedia* self, guint value);
	guint (*get_length) (NoiseMedia* self);
	void (*set_length) (NoiseMedia* self, guint value);
	guint (*get_rating) (NoiseMedia* self);
	void (*set_rating) (NoiseMedia* self, guint value);
	guint (*get_play_count) (NoiseMedia* self);
	void (*set_play_count) (NoiseMedia* self, guint value);
	guint (*get_skip_count) (NoiseMedia* self);
	void (*set_skip_count) (NoiseMedia* self, guint value);
	guint (*get_date_added) (NoiseMedia* self);
	void (*set_date_added) (NoiseMedia* self, guint value);
	guint (*get_last_played) (NoiseMedia* self);
	void (*set_last_played) (NoiseMedia* self, guint value);
	guint (*get_last_modified) (NoiseMedia* self);
	void (*set_last_modified) (NoiseMedia* self, guint value);
	gint (*get_resume_pos) (NoiseMedia* self);
	void (*set_resume_pos) (NoiseMedia* self, gint value);
};

struct _NoiseMediaPrivate {
	gint _rowid;
	guint64 _file_size;
	GFile* _file;
	gboolean _isPreview;
	gboolean _isTemporary;
	gboolean _location_unknown;
	gboolean _has_embedded;
	GIcon* _unique_status_image;
	gboolean _showIndicator;
	gchar* _title;
	guint _track;
	guint _track_count;
	gchar* _composer;
	gchar* _artist;
	gchar* _album_artist;
	gchar* _album;
	guint _album_number;
	guint _album_count;
	NoiseAlbum* _album_info;
	gchar* _grouping;
	gchar* _genre;
	gchar* _comment;
	gchar* _lyrics;
	guint _year;
	guint _bitrate;
	guint _bpm;
	guint _samplerate;
	guint _length;
	guint _play_count;
	guint _skip_count;
	guint _date_added;
	guint _last_played;
	guint _last_modified;
	gint _resume_pos;
};


static gpointer noise_media_parent_class = NULL;
extern gchar* noise_media_UNKNOWN;
gchar* noise_media_UNKNOWN = NULL;

GType noise_media_get_type (void) G_GNUC_CONST;
GType noise_album_get_type (void) G_GNUC_CONST;
#define NOISE_MEDIA_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NOISE_TYPE_MEDIA, NoiseMediaPrivate))
enum  {
	NOISE_MEDIA_DUMMY_PROPERTY,
	NOISE_MEDIA_ROWID,
	NOISE_MEDIA_URI,
	NOISE_MEDIA_FILE_SIZE,
	NOISE_MEDIA_FILE_EXISTS,
	NOISE_MEDIA_FILE,
	NOISE_MEDIA_IS_PREVIEW,
	NOISE_MEDIA_IS_TEMPORARY,
	NOISE_MEDIA_LOCATION_UNKNOWN,
	NOISE_MEDIA_HAS_EMBEDDED,
	NOISE_MEDIA_UNIQUE_STATUS_IMAGE,
	NOISE_MEDIA_SHOW_INDICATOR,
	NOISE_MEDIA_TITLE,
	NOISE_MEDIA_TRACK,
	NOISE_MEDIA_TRACK_COUNT,
	NOISE_MEDIA_COMPOSER,
	NOISE_MEDIA_ARTIST,
	NOISE_MEDIA_ALBUM_ARTIST,
	NOISE_MEDIA_ALBUM,
	NOISE_MEDIA_ALBUM_NUMBER,
	NOISE_MEDIA_ALBUM_COUNT,
	NOISE_MEDIA_ALBUM_INFO,
	NOISE_MEDIA_GROUPING,
	NOISE_MEDIA_GENRE,
	NOISE_MEDIA_COMMENT,
	NOISE_MEDIA_LYRICS,
	NOISE_MEDIA_YEAR,
	NOISE_MEDIA_BITRATE,
	NOISE_MEDIA_BPM,
	NOISE_MEDIA_SAMPLERATE,
	NOISE_MEDIA_LENGTH,
	NOISE_MEDIA_RATING,
	NOISE_MEDIA_PLAY_COUNT,
	NOISE_MEDIA_SKIP_COUNT,
	NOISE_MEDIA_DATE_ADDED,
	NOISE_MEDIA_LAST_PLAYED,
	NOISE_MEDIA_LAST_MODIFIED,
	NOISE_MEDIA_RESUME_POS
};
gchar* noise_media_get_display_filename (NoiseMedia* self);
GFile* noise_media_get_file (NoiseMedia* self);
gchar* noise_string_locale_to_utf8 (const gchar* string_locale);
gboolean noise_media_is_valid_string_field (const gchar* text);
gchar* noise_media_get_display_location (NoiseMedia* self);
gboolean noise_media_get_isTemporary (NoiseMedia* self);
gchar* noise_media_get_display_title (NoiseMedia* self);
const gchar* noise_media_get_title (NoiseMedia* self);
gchar* noise_media_get_display_composer (NoiseMedia* self);
gchar* noise_media_get_simple_display_text (const gchar* text);
const gchar* noise_media_get_composer (NoiseMedia* self);
gchar* noise_media_get_display_artist (NoiseMedia* self);
const gchar* noise_media_get_artist (NoiseMedia* self);
gchar* noise_media_get_display_album_artist (NoiseMedia* self, gboolean use_artist_fallback);
const gchar* noise_media_get_album_artist (NoiseMedia* self);
gchar* noise_media_get_display_album (NoiseMedia* self);
const gchar* noise_media_get_album (NoiseMedia* self);
gchar* noise_media_get_display_genre (NoiseMedia* self);
const gchar* noise_media_get_genre (NoiseMedia* self);
gboolean noise_string_is_empty (const gchar* text, gboolean check_white_space);
gchar* noise_media_get_album_hashkey (NoiseMedia* self);
gchar* noise_media_get_title_markup (NoiseMedia* self);
gchar* noise_string_escape (const gchar* text);
NoiseMedia* noise_media_new (const gchar* uri);
NoiseMedia* noise_media_construct (GType object_type, const gchar* uri);
void noise_media_set_uri (NoiseMedia* self, const gchar* value);
NoiseMedia* noise_media_new_from_file (GFile* file);
NoiseMedia* noise_media_construct_from_file (GType object_type, GFile* file);
void noise_media_set_file (NoiseMedia* self, GFile* value);
NoiseMedia* noise_media_copy (NoiseMedia* self);
gchar* noise_media_get_uri (NoiseMedia* self);
guint64 noise_media_get_file_size (NoiseMedia* self);
void noise_media_set_file_size (NoiseMedia* self, guint64 value);
guint noise_media_get_track (NoiseMedia* self);
void noise_media_set_track (NoiseMedia* self, guint value);
guint noise_media_get_track_count (NoiseMedia* self);
void noise_media_set_track_count (NoiseMedia* self, guint value);
guint noise_media_get_album_number (NoiseMedia* self);
void noise_media_set_album_number (NoiseMedia* self, guint value);
guint noise_media_get_album_count (NoiseMedia* self);
void noise_media_set_album_count (NoiseMedia* self, guint value);
void noise_media_set_title (NoiseMedia* self, const gchar* value);
void noise_media_set_artist (NoiseMedia* self, const gchar* value);
void noise_media_set_composer (NoiseMedia* self, const gchar* value);
void noise_media_set_album_artist (NoiseMedia* self, const gchar* value);
void noise_media_set_album (NoiseMedia* self, const gchar* value);
void noise_media_set_genre (NoiseMedia* self, const gchar* value);
const gchar* noise_media_get_grouping (NoiseMedia* self);
void noise_media_set_grouping (NoiseMedia* self, const gchar* value);
const gchar* noise_media_get_comment (NoiseMedia* self);
void noise_media_set_comment (NoiseMedia* self, const gchar* value);
guint noise_media_get_year (NoiseMedia* self);
void noise_media_set_year (NoiseMedia* self, guint value);
guint noise_media_get_bitrate (NoiseMedia* self);
void noise_media_set_bitrate (NoiseMedia* self, guint value);
guint noise_media_get_length (NoiseMedia* self);
void noise_media_set_length (NoiseMedia* self, guint value);
guint noise_media_get_samplerate (NoiseMedia* self);
void noise_media_set_samplerate (NoiseMedia* self, guint value);
guint noise_media_get_bpm (NoiseMedia* self);
void noise_media_set_bpm (NoiseMedia* self, guint value);
guint noise_media_get_rating (NoiseMedia* self);
void noise_media_set_rating (NoiseMedia* self, guint value);
guint noise_media_get_play_count (NoiseMedia* self);
void noise_media_set_play_count (NoiseMedia* self, guint value);
guint noise_media_get_skip_count (NoiseMedia* self);
void noise_media_set_skip_count (NoiseMedia* self, guint value);
guint noise_media_get_date_added (NoiseMedia* self);
void noise_media_set_date_added (NoiseMedia* self, guint value);
guint noise_media_get_last_played (NoiseMedia* self);
void noise_media_set_last_played (NoiseMedia* self, guint value);
const gchar* noise_media_get_lyrics (NoiseMedia* self);
void noise_media_set_lyrics (NoiseMedia* self, const gchar* value);
gboolean noise_media_get_isPreview (NoiseMedia* self);
void noise_media_set_isPreview (NoiseMedia* self, gboolean value);
void noise_media_set_isTemporary (NoiseMedia* self, gboolean value);
guint noise_media_get_last_modified (NoiseMedia* self);
void noise_media_set_last_modified (NoiseMedia* self, guint value);
gboolean noise_media_get_showIndicator (NoiseMedia* self);
void noise_media_set_showIndicator (NoiseMedia* self, gboolean value);
GIcon* noise_media_get_unique_status_image (NoiseMedia* self);
void noise_media_set_unique_status_image (NoiseMedia* self, GIcon* value);
gboolean noise_media_get_location_unknown (NoiseMedia* self);
void noise_media_set_location_unknown (NoiseMedia* self, gboolean value);
gint noise_media_get_rowid (NoiseMedia* self);
void noise_media_set_rowid (NoiseMedia* self, gint value);
gboolean noise_media_get_file_exists (NoiseMedia* self);
gboolean noise_media_get_has_embedded (NoiseMedia* self);
void noise_media_set_has_embedded (NoiseMedia* self, gboolean value);
NoiseAlbum* noise_media_get_album_info (NoiseMedia* self);
void noise_media_set_album_info (NoiseMedia* self, NoiseAlbum* value);
gint noise_media_get_resume_pos (NoiseMedia* self);
void noise_media_set_resume_pos (NoiseMedia* self, gint value);
static void noise_media_finalize (GObject* obj);
static void _vala_noise_media_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_noise_media_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


inline gchar* noise_media_get_display_filename (NoiseMedia* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* filename = NULL;
	gchar* _tmp6_ = NULL;
	const gchar* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	gboolean _tmp9_ = FALSE;
	gchar* _tmp12_ = NULL;
#line 101 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 102 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp1_ = noise_media_get_file (self);
#line 102 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp2_ = _tmp1_;
#line 102 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp3_ = g_file_get_basename (_tmp2_);
#line 102 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = _tmp3_;
#line 102 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	if (_tmp0_ == NULL) {
#line 357 "Media.c"
		const gchar* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
#line 102 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp4_ = noise_media_UNKNOWN;
#line 102 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 102 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_g_free0 (_tmp0_);
#line 102 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp0_ = _tmp5_;
#line 368 "Media.c"
	}
#line 102 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp6_ = noise_string_locale_to_utf8 (_tmp0_);
#line 102 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	filename = _tmp6_;
#line 103 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp8_ = filename;
#line 103 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp9_ = noise_media_is_valid_string_field (_tmp8_);
#line 103 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	if (_tmp9_) {
#line 380 "Media.c"
		const gchar* _tmp10_ = NULL;
#line 103 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp10_ = filename;
#line 103 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp7_ = _tmp10_;
#line 386 "Media.c"
	} else {
		const gchar* _tmp11_ = NULL;
#line 103 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp11_ = noise_media_UNKNOWN;
#line 103 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp7_ = _tmp11_;
#line 393 "Media.c"
	}
#line 103 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp12_ = g_strdup (_tmp7_);
#line 103 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp12_;
#line 103 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_g_free0 (filename);
#line 103 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_g_free0 (_tmp0_);
#line 103 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 405 "Media.c"
}


inline gchar* noise_media_get_display_location (NoiseMedia* self) {
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gchar* filename = NULL;
	GFile* _tmp3_ = NULL;
	GFile* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	const gchar* _tmp9_ = NULL;
	gboolean _tmp10_ = FALSE;
	const gchar* _tmp18_ = NULL;
	gchar* _tmp19_ = NULL;
#line 106 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 107 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = noise_media_get_isTemporary (self);
#line 107 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp1_ = _tmp0_;
#line 107 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	if (_tmp1_) {
#line 432 "Media.c"
		gchar* _tmp2_ = NULL;
#line 108 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp2_ = g_strdup ("");
#line 108 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		result = _tmp2_;
#line 108 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		return result;
#line 440 "Media.c"
	}
#line 110 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp3_ = noise_media_get_file (self);
#line 110 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp4_ = _tmp3_;
#line 110 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp5_ = g_file_get_path (_tmp4_);
#line 110 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp6_ = _tmp5_;
#line 110 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp7_ = noise_string_locale_to_utf8 (_tmp6_);
#line 110 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp8_ = _tmp7_;
#line 110 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_g_free0 (_tmp6_);
#line 110 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	filename = _tmp8_;
#line 112 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp9_ = filename;
#line 112 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp10_ = noise_media_is_valid_string_field (_tmp9_);
#line 112 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	if (_tmp10_) {
#line 464 "Media.c"
		GFile* _tmp11_ = NULL;
		GFile* _tmp12_ = NULL;
		gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		const gchar* _tmp15_ = NULL;
		gchar* _tmp16_ = NULL;
		gchar* _tmp17_ = NULL;
#line 113 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp11_ = noise_media_get_file (self);
#line 113 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp12_ = _tmp11_;
#line 113 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp13_ = g_file_get_uri_scheme (_tmp12_);
#line 113 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp14_ = _tmp13_;
#line 113 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp15_ = filename;
#line 113 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp16_ = g_strdup_printf ("%s:/%s", _tmp14_, _tmp15_);
#line 113 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp17_ = _tmp16_;
#line 113 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_g_free0 (_tmp14_);
#line 113 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		result = _tmp17_;
#line 113 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_g_free0 (filename);
#line 113 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		return result;
#line 494 "Media.c"
	}
#line 115 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp18_ = noise_media_UNKNOWN;
#line 115 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp19_ = g_strdup (_tmp18_);
#line 115 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp19_;
#line 115 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_g_free0 (filename);
#line 115 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 506 "Media.c"
}


inline gchar* noise_media_get_display_title (NoiseMedia* self) {
	gchar* result = NULL;
	gchar* title = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
#line 118 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 119 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = noise_media_get_title (self);
#line 119 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp1_ = _tmp0_;
#line 119 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 119 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	title = _tmp2_;
#line 120 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp4_ = title;
#line 120 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp5_ = noise_media_is_valid_string_field (_tmp4_);
#line 120 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	if (_tmp5_) {
#line 535 "Media.c"
		const gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
#line 120 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp6_ = title;
#line 120 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp7_ = g_strdup (_tmp6_);
#line 120 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_g_free0 (_tmp3_);
#line 120 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp3_ = _tmp7_;
#line 546 "Media.c"
	} else {
		gchar* _tmp8_ = NULL;
#line 120 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp8_ = noise_media_get_display_filename (self);
#line 120 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_g_free0 (_tmp3_);
#line 120 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp3_ = _tmp8_;
#line 555 "Media.c"
	}
#line 120 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp3_;
#line 120 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_g_free0 (title);
#line 120 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 563 "Media.c"
}


inline gchar* noise_media_get_display_composer (NoiseMedia* self) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
#line 123 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 124 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = noise_media_get_composer (self);
#line 124 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp1_ = _tmp0_;
#line 124 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp2_ = noise_media_get_simple_display_text (_tmp1_);
#line 124 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp2_;
#line 124 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 584 "Media.c"
}


inline gchar* noise_media_get_display_artist (NoiseMedia* self) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
#line 127 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 128 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = noise_media_get_artist (self);
#line 128 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp1_ = _tmp0_;
#line 128 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp2_ = noise_media_get_simple_display_text (_tmp1_);
#line 128 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp2_;
#line 128 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 605 "Media.c"
}


inline gchar* noise_media_get_display_album_artist (NoiseMedia* self, gboolean use_artist_fallback) {
	gchar* result = NULL;
	gchar* album_artist = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	const gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
#line 131 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 132 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = noise_media_get_album_artist (self);
#line 132 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp1_ = _tmp0_;
#line 132 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 132 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	album_artist = _tmp2_;
#line 134 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp3_ = album_artist;
#line 134 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp4_ = noise_media_is_valid_string_field (_tmp3_);
#line 134 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	if (_tmp4_) {
#line 135 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		result = album_artist;
#line 135 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		return result;
#line 640 "Media.c"
	}
#line 137 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp5_ = use_artist_fallback;
#line 137 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	if (_tmp5_) {
#line 646 "Media.c"
		gchar* _tmp6_ = NULL;
#line 138 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp6_ = noise_media_get_display_artist (self);
#line 138 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		result = _tmp6_;
#line 138 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_g_free0 (album_artist);
#line 138 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		return result;
#line 656 "Media.c"
	}
#line 140 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp7_ = noise_media_UNKNOWN;
#line 140 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 140 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp8_;
#line 140 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_g_free0 (album_artist);
#line 140 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 668 "Media.c"
}


inline gchar* noise_media_get_display_album (NoiseMedia* self) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
#line 143 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 144 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = noise_media_get_album (self);
#line 144 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp1_ = _tmp0_;
#line 144 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp2_ = noise_media_get_simple_display_text (_tmp1_);
#line 144 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp2_;
#line 144 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 689 "Media.c"
}


inline gchar* noise_media_get_display_genre (NoiseMedia* self) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
#line 147 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 148 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = noise_media_get_genre (self);
#line 148 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp1_ = _tmp0_;
#line 148 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp2_ = noise_media_get_simple_display_text (_tmp1_);
#line 148 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp2_;
#line 148 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 710 "Media.c"
}


inline gboolean noise_media_is_valid_string_field (const gchar* text) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
#line 152 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = text;
#line 152 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp1_ = noise_string_is_empty (_tmp0_, TRUE);
#line 152 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = !_tmp1_;
#line 152 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 726 "Media.c"
}


gchar* noise_media_get_album_hashkey (NoiseMedia* self) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
#line 155 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 156 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = noise_media_get_album_artist (self);
#line 156 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp1_ = _tmp0_;
#line 156 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp2_ = noise_media_is_valid_string_field (_tmp1_);
#line 156 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	if (_tmp2_) {
#line 745 "Media.c"
		const gchar* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
#line 157 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp3_ = noise_media_get_album (self);
#line 157 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp4_ = _tmp3_;
#line 157 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp5_ = noise_media_get_album_artist (self);
#line 157 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp6_ = _tmp5_;
#line 157 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp7_ = g_strdup_printf ("%s|%s", _tmp4_, _tmp6_);
#line 157 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		result = _tmp7_;
#line 157 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		return result;
#line 765 "Media.c"
	} else {
		const gchar* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
		const gchar* _tmp11_ = NULL;
		gchar* _tmp12_ = NULL;
#line 159 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp8_ = noise_media_get_album (self);
#line 159 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp9_ = _tmp8_;
#line 159 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp10_ = noise_media_get_artist (self);
#line 159 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp11_ = _tmp10_;
#line 159 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp12_ = g_strdup_printf ("%s|%s", _tmp9_, _tmp11_);
#line 159 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		result = _tmp12_;
#line 159 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		return result;
#line 786 "Media.c"
	}
}


/**
     * It's called simple because it simply checks if the string is empty,
     * and returns UNKNOWN if it is.
     */
inline gchar* noise_media_get_simple_display_text (const gchar* text) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	gchar* _tmp5_ = NULL;
#line 166 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp1_ = text;
#line 166 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp2_ = noise_media_is_valid_string_field (_tmp1_);
#line 166 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	if (_tmp2_) {
#line 807 "Media.c"
		const gchar* _tmp3_ = NULL;
#line 166 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp3_ = text;
#line 166 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp0_ = _tmp3_;
#line 813 "Media.c"
	} else {
		const gchar* _tmp4_ = NULL;
#line 166 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp4_ = noise_media_UNKNOWN;
#line 166 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp0_ = _tmp4_;
#line 820 "Media.c"
	}
#line 166 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp5_ = g_strdup (_tmp0_);
#line 166 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp5_;
#line 166 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 828 "Media.c"
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 1282 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1282 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1282 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 841 "Media.c"
	{
		GRegex* regex = NULL;
		const gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		GRegex* _tmp3_ = NULL;
		GRegex* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		GRegex* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
#line 1284 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		_tmp0_ = old;
#line 1284 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
#line 1284 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1284 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
#line 1284 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1284 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		_g_free0 (_tmp2_);
#line 1284 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		regex = _tmp4_;
#line 1284 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1284 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 872 "Media.c"
				goto __catch2_g_regex_error;
			}
#line 1284 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1284 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1284 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
			return NULL;
#line 881 "Media.c"
		}
#line 1285 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		_tmp6_ = regex;
#line 1285 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		_tmp7_ = replacement;
#line 1285 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		_tmp8_ = g_regex_replace_literal (_tmp6_, self, (gssize) (-1), 0, _tmp7_, 0, &_inner_error_);
#line 1285 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		_tmp5_ = _tmp8_;
#line 1285 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1285 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1285 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 897 "Media.c"
				goto __catch2_g_regex_error;
			}
#line 1285 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1285 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1285 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1285 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
			return NULL;
#line 908 "Media.c"
		}
#line 1285 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		_tmp9_ = _tmp5_;
#line 1285 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		_tmp5_ = NULL;
#line 1285 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		result = _tmp9_;
#line 1285 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		_g_free0 (_tmp5_);
#line 1285 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1285 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		return result;
#line 922 "Media.c"
	}
	goto __finally2;
	__catch2_g_regex_error:
	{
		GError* e = NULL;
#line 1283 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		e = _inner_error_;
#line 1283 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		_inner_error_ = NULL;
#line 1287 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		g_assert_not_reached ();
#line 1283 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		_g_error_free0 (e);
#line 936 "Media.c"
	}
	__finally2:
#line 1283 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1283 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1283 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		g_clear_error (&_inner_error_);
#line 1283 "/usr/share/vala-0.28/vapi/glib-2.0.vapi"
		return NULL;
#line 947 "Media.c"
	}
}


gchar* noise_media_get_title_markup (NoiseMedia* self) {
	gchar* result = NULL;
	gchar* markup = NULL;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
#line 169 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 175 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp1_ = noise_media_get_artist (self);
#line 175 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp2_ = _tmp1_;
#line 175 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp3_ = noise_media_is_valid_string_field (_tmp2_);
#line 175 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	if (!_tmp3_) {
#line 969 "Media.c"
		const gchar* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		gboolean _tmp6_ = FALSE;
#line 175 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp4_ = noise_media_get_album (self);
#line 175 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp5_ = _tmp4_;
#line 175 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp6_ = noise_media_is_valid_string_field (_tmp5_);
#line 175 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp0_ = _tmp6_;
#line 981 "Media.c"
	} else {
#line 175 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp0_ = FALSE;
#line 985 "Media.c"
	}
#line 175 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	if (_tmp0_) {
#line 989 "Media.c"
		const gchar* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
		gchar* _tmp11_ = NULL;
		gchar* _tmp12_ = NULL;
		gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		gchar* _tmp15_ = NULL;
		gchar* _tmp16_ = NULL;
		gchar* _tmp17_ = NULL;
		gchar* _tmp18_ = NULL;
		gchar* _tmp19_ = NULL;
		gchar* _tmp20_ = NULL;
		gchar* _tmp21_ = NULL;
		gchar* _tmp22_ = NULL;
		gchar* _tmp23_ = NULL;
		gchar* _tmp24_ = NULL;
		gchar* _tmp25_ = NULL;
		gchar* _tmp26_ = NULL;
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp7_ = _ ("$NAME on $ALBUM");
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp8_ = noise_media_get_album (self);
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp9_ = _tmp8_;
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp10_ = noise_string_escape (_tmp9_);
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp11_ = _tmp10_;
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp12_ = g_strconcat ("<b>", _tmp11_, NULL);
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp13_ = _tmp12_;
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp14_ = g_strconcat (_tmp13_, "</b>", NULL);
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp15_ = _tmp14_;
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp16_ = string_replace (_tmp7_, "$ALBUM", _tmp15_);
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp17_ = _tmp16_;
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp18_ = noise_media_get_display_title (self);
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp19_ = _tmp18_;
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp20_ = noise_string_escape (_tmp19_);
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp21_ = _tmp20_;
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp22_ = g_strconcat ("<b>", _tmp21_, NULL);
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp23_ = _tmp22_;
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp24_ = g_strconcat (_tmp23_, "</b>", NULL);
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp25_ = _tmp24_;
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp26_ = string_replace (_tmp17_, "$NAME", _tmp25_);
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_g_free0 (markup);
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		markup = _tmp26_;
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_g_free0 (_tmp25_);
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_g_free0 (_tmp23_);
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_g_free0 (_tmp21_);
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_g_free0 (_tmp19_);
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_g_free0 (_tmp17_);
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_g_free0 (_tmp15_);
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_g_free0 (_tmp13_);
#line 177 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_g_free0 (_tmp11_);
#line 1070 "Media.c"
	} else {
		gboolean _tmp27_ = FALSE;
		const gchar* _tmp28_ = NULL;
		const gchar* _tmp29_ = NULL;
		gboolean _tmp30_ = FALSE;
#line 178 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp28_ = noise_media_get_artist (self);
#line 178 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp29_ = _tmp28_;
#line 178 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		_tmp30_ = noise_media_is_valid_string_field (_tmp29_);
#line 178 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		if (_tmp30_) {
#line 1084 "Media.c"
			const gchar* _tmp31_ = NULL;
			const gchar* _tmp32_ = NULL;
			gboolean _tmp33_ = FALSE;
#line 178 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			_tmp31_ = noise_media_get_album (self);
#line 178 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			_tmp32_ = _tmp31_;
#line 178 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			_tmp33_ = noise_media_is_valid_string_field (_tmp32_);
#line 178 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			_tmp27_ = !_tmp33_;
#line 1096 "Media.c"
		} else {
#line 178 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			_tmp27_ = FALSE;
#line 1100 "Media.c"
		}
#line 178 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		if (_tmp27_) {
#line 1104 "Media.c"
			const gchar* _tmp34_ = NULL;
			const gchar* _tmp35_ = NULL;
			const gchar* _tmp36_ = NULL;
			gchar* _tmp37_ = NULL;
			gchar* _tmp38_ = NULL;
			gchar* _tmp39_ = NULL;
			gchar* _tmp40_ = NULL;
			gchar* _tmp41_ = NULL;
			gchar* _tmp42_ = NULL;
			gchar* _tmp43_ = NULL;
			gchar* _tmp44_ = NULL;
			gchar* _tmp45_ = NULL;
			gchar* _tmp46_ = NULL;
			gchar* _tmp47_ = NULL;
			gchar* _tmp48_ = NULL;
			gchar* _tmp49_ = NULL;
			gchar* _tmp50_ = NULL;
			gchar* _tmp51_ = NULL;
			gchar* _tmp52_ = NULL;
			gchar* _tmp53_ = NULL;
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			_tmp34_ = _ ("$NAME by $ARTIST");
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			_tmp35_ = noise_media_get_artist (self);
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			_tmp36_ = _tmp35_;
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			_tmp37_ = noise_string_escape (_tmp36_);
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			_tmp38_ = _tmp37_;
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			_tmp39_ = g_strconcat ("<b>", _tmp38_, NULL);
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			_tmp40_ = _tmp39_;
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			_tmp41_ = g_strconcat (_tmp40_, "</b>", NULL);
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			_tmp42_ = _tmp41_;
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			_tmp43_ = string_replace (_tmp34_, "$ARTIST", _tmp42_);
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			_tmp44_ = _tmp43_;
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			_tmp45_ = noise_media_get_display_title (self);
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			_tmp46_ = _tmp45_;
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			_tmp47_ = noise_string_escape (_tmp46_);
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			_tmp48_ = _tmp47_;
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			_tmp49_ = g_strconcat ("<b>", _tmp48_, NULL);
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			_tmp50_ = _tmp49_;
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			_tmp51_ = g_strconcat (_tmp50_, "</b>", NULL);
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			_tmp52_ = _tmp51_;
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			_tmp53_ = string_replace (_tmp44_, "$NAME", _tmp52_);
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			_g_free0 (markup);
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			markup = _tmp53_;
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			_g_free0 (_tmp52_);
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			_g_free0 (_tmp50_);
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			_g_free0 (_tmp48_);
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			_g_free0 (_tmp46_);
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			_g_free0 (_tmp44_);
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			_g_free0 (_tmp42_);
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			_g_free0 (_tmp40_);
#line 180 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			_g_free0 (_tmp38_);
#line 1185 "Media.c"
		} else {
			gboolean _tmp54_ = FALSE;
			const gchar* _tmp55_ = NULL;
			const gchar* _tmp56_ = NULL;
			gboolean _tmp57_ = FALSE;
#line 181 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			_tmp55_ = noise_media_get_artist (self);
#line 181 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			_tmp56_ = _tmp55_;
#line 181 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			_tmp57_ = noise_media_is_valid_string_field (_tmp56_);
#line 181 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			if (!_tmp57_) {
#line 1199 "Media.c"
				const gchar* _tmp58_ = NULL;
				const gchar* _tmp59_ = NULL;
				gboolean _tmp60_ = FALSE;
#line 181 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp58_ = noise_media_get_album (self);
#line 181 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp59_ = _tmp58_;
#line 181 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp60_ = noise_media_is_valid_string_field (_tmp59_);
#line 181 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp54_ = !_tmp60_;
#line 1211 "Media.c"
			} else {
#line 181 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp54_ = FALSE;
#line 1215 "Media.c"
			}
#line 181 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
			if (_tmp54_) {
#line 1219 "Media.c"
				gchar* _tmp61_ = NULL;
				gchar* _tmp62_ = NULL;
				gchar* _tmp63_ = NULL;
				gchar* _tmp64_ = NULL;
				gchar* _tmp65_ = NULL;
				gchar* _tmp66_ = NULL;
				gchar* _tmp67_ = NULL;
#line 183 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp61_ = noise_media_get_display_title (self);
#line 183 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp62_ = _tmp61_;
#line 183 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp63_ = noise_string_escape (_tmp62_);
#line 183 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp64_ = _tmp63_;
#line 183 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp65_ = g_strconcat ("<b>", _tmp64_, NULL);
#line 183 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp66_ = _tmp65_;
#line 183 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp67_ = g_strconcat (_tmp66_, "</b>", NULL);
#line 183 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_g_free0 (markup);
#line 183 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				markup = _tmp67_;
#line 183 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_g_free0 (_tmp66_);
#line 183 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_g_free0 (_tmp64_);
#line 183 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_g_free0 (_tmp62_);
#line 1251 "Media.c"
			} else {
				const gchar* _tmp68_ = NULL;
				const gchar* _tmp69_ = NULL;
				const gchar* _tmp70_ = NULL;
				gchar* _tmp71_ = NULL;
				gchar* _tmp72_ = NULL;
				gchar* _tmp73_ = NULL;
				gchar* _tmp74_ = NULL;
				gchar* _tmp75_ = NULL;
				gchar* _tmp76_ = NULL;
				gchar* _tmp77_ = NULL;
				gchar* _tmp78_ = NULL;
				gchar* _tmp79_ = NULL;
				gchar* _tmp80_ = NULL;
				gchar* _tmp81_ = NULL;
				gchar* _tmp82_ = NULL;
				gchar* _tmp83_ = NULL;
				gchar* _tmp84_ = NULL;
				gchar* _tmp85_ = NULL;
				gchar* _tmp86_ = NULL;
				gchar* _tmp87_ = NULL;
				gchar* _tmp88_ = NULL;
				const gchar* _tmp89_ = NULL;
				const gchar* _tmp90_ = NULL;
				gchar* _tmp91_ = NULL;
				gchar* _tmp92_ = NULL;
				gchar* _tmp93_ = NULL;
				gchar* _tmp94_ = NULL;
				gchar* _tmp95_ = NULL;
				gchar* _tmp96_ = NULL;
				gchar* _tmp97_ = NULL;
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp68_ = _ ("$NAME by $ARTIST on $ALBUM");
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp69_ = noise_media_get_artist (self);
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp70_ = _tmp69_;
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp71_ = noise_string_escape (_tmp70_);
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp72_ = _tmp71_;
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp73_ = g_strconcat ("<b>", _tmp72_, NULL);
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp74_ = _tmp73_;
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp75_ = g_strconcat (_tmp74_, "</b>", NULL);
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp76_ = _tmp75_;
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp77_ = string_replace (_tmp68_, "$ARTIST", _tmp76_);
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp78_ = _tmp77_;
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp79_ = noise_media_get_display_title (self);
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp80_ = _tmp79_;
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp81_ = noise_string_escape (_tmp80_);
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp82_ = _tmp81_;
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp83_ = g_strconcat ("<b>", _tmp82_, NULL);
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp84_ = _tmp83_;
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp85_ = g_strconcat (_tmp84_, "</b>", NULL);
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp86_ = _tmp85_;
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp87_ = string_replace (_tmp78_, "$NAME", _tmp86_);
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp88_ = _tmp87_;
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp89_ = noise_media_get_album (self);
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp90_ = _tmp89_;
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp91_ = noise_string_escape (_tmp90_);
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp92_ = _tmp91_;
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp93_ = g_strconcat ("<b>", _tmp92_, NULL);
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp94_ = _tmp93_;
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp95_ = g_strconcat (_tmp94_, "</b>", NULL);
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp96_ = _tmp95_;
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_tmp97_ = string_replace (_tmp88_, "$ALBUM", _tmp96_);
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_g_free0 (markup);
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				markup = _tmp97_;
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_g_free0 (_tmp96_);
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_g_free0 (_tmp94_);
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_g_free0 (_tmp92_);
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_g_free0 (_tmp88_);
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_g_free0 (_tmp86_);
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_g_free0 (_tmp84_);
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_g_free0 (_tmp82_);
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_g_free0 (_tmp80_);
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_g_free0 (_tmp78_);
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_g_free0 (_tmp76_);
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_g_free0 (_tmp74_);
#line 186 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
				_g_free0 (_tmp72_);
#line 1371 "Media.c"
			}
		}
	}
#line 188 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = markup;
#line 188 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 1379 "Media.c"
}


NoiseMedia* noise_media_construct (GType object_type, const gchar* uri) {
	NoiseMedia * self = NULL;
	const gchar* _tmp0_ = NULL;
#line 191 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 191 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = (NoiseMedia*) g_object_new (object_type, NULL);
#line 192 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = uri;
#line 192 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	noise_media_set_uri (self, _tmp0_);
#line 191 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return self;
#line 1396 "Media.c"
}


NoiseMedia* noise_media_new (const gchar* uri) {
#line 191 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return noise_media_construct (NOISE_TYPE_MEDIA, uri);
#line 1403 "Media.c"
}


NoiseMedia* noise_media_construct_from_file (GType object_type, GFile* file) {
	NoiseMedia * self = NULL;
	GFile* _tmp0_ = NULL;
#line 195 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 195 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = (NoiseMedia*) g_object_new (object_type, NULL);
#line 196 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = file;
#line 196 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	noise_media_set_file (self, _tmp0_);
#line 195 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return self;
#line 1420 "Media.c"
}


NoiseMedia* noise_media_new_from_file (GFile* file) {
#line 195 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return noise_media_construct_from_file (NOISE_TYPE_MEDIA, file);
#line 1427 "Media.c"
}


NoiseMedia* noise_media_copy (NoiseMedia* self) {
	NoiseMedia* result = NULL;
	NoiseMedia* rv = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	NoiseMedia* _tmp3_ = NULL;
	NoiseMedia* _tmp4_ = NULL;
	guint64 _tmp5_ = 0ULL;
	guint64 _tmp6_ = 0ULL;
	guint _tmp7_ = 0U;
	guint _tmp8_ = 0U;
	guint _tmp9_ = 0U;
	guint _tmp10_ = 0U;
	guint _tmp11_ = 0U;
	guint _tmp12_ = 0U;
	guint _tmp13_ = 0U;
	guint _tmp14_ = 0U;
	const gchar* _tmp15_ = NULL;
	const gchar* _tmp16_ = NULL;
	const gchar* _tmp17_ = NULL;
	const gchar* _tmp18_ = NULL;
	const gchar* _tmp19_ = NULL;
	const gchar* _tmp20_ = NULL;
	const gchar* _tmp21_ = NULL;
	const gchar* _tmp22_ = NULL;
	const gchar* _tmp23_ = NULL;
	const gchar* _tmp24_ = NULL;
	const gchar* _tmp25_ = NULL;
	const gchar* _tmp26_ = NULL;
	const gchar* _tmp27_ = NULL;
	const gchar* _tmp28_ = NULL;
	const gchar* _tmp29_ = NULL;
	const gchar* _tmp30_ = NULL;
	guint _tmp31_ = 0U;
	guint _tmp32_ = 0U;
	guint _tmp33_ = 0U;
	guint _tmp34_ = 0U;
	guint _tmp35_ = 0U;
	guint _tmp36_ = 0U;
	guint _tmp37_ = 0U;
	guint _tmp38_ = 0U;
	guint _tmp39_ = 0U;
	guint _tmp40_ = 0U;
	guint _tmp41_ = 0U;
	guint _tmp42_ = 0U;
	guint _tmp43_ = 0U;
	guint _tmp44_ = 0U;
	guint _tmp45_ = 0U;
	guint _tmp46_ = 0U;
	guint _tmp47_ = 0U;
	guint _tmp48_ = 0U;
	guint _tmp49_ = 0U;
	guint _tmp50_ = 0U;
	const gchar* _tmp51_ = NULL;
	const gchar* _tmp52_ = NULL;
	gboolean _tmp53_ = FALSE;
	gboolean _tmp54_ = FALSE;
	gboolean _tmp55_ = FALSE;
	gboolean _tmp56_ = FALSE;
	guint _tmp57_ = 0U;
	guint _tmp58_ = 0U;
	gboolean _tmp59_ = FALSE;
	gboolean _tmp60_ = FALSE;
	GIcon* _tmp61_ = NULL;
	GIcon* _tmp62_ = NULL;
	gboolean _tmp63_ = FALSE;
	gboolean _tmp64_ = FALSE;
#line 199 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 200 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = noise_media_get_uri (self);
#line 200 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp1_ = _tmp0_;
#line 200 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp2_ = _tmp1_;
#line 200 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp3_ = noise_media_new (_tmp2_);
#line 200 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp4_ = _tmp3_;
#line 200 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_g_free0 (_tmp2_);
#line 200 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	rv = _tmp4_;
#line 202 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp5_ = noise_media_get_file_size (self);
#line 202 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp6_ = _tmp5_;
#line 202 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	noise_media_set_file_size (rv, _tmp6_);
#line 203 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp7_ = noise_media_get_track (self);
#line 203 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp8_ = _tmp7_;
#line 203 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	noise_media_set_track (rv, _tmp8_);
#line 204 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp9_ = noise_media_get_track_count (self);
#line 204 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp10_ = _tmp9_;
#line 204 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	noise_media_set_track_count (rv, _tmp10_);
#line 205 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp11_ = noise_media_get_album_number (self);
#line 205 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp12_ = _tmp11_;
#line 205 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	noise_media_set_album_number (rv, _tmp12_);
#line 206 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp13_ = noise_media_get_album_count (self);
#line 206 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp14_ = _tmp13_;
#line 206 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	noise_media_set_album_count (rv, _tmp14_);
#line 207 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp15_ = noise_media_get_title (self);
#line 207 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp16_ = _tmp15_;
#line 207 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	noise_media_set_title (rv, _tmp16_);
#line 208 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp17_ = noise_media_get_artist (self);
#line 208 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp18_ = _tmp17_;
#line 208 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	noise_media_set_artist (rv, _tmp18_);
#line 209 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp19_ = noise_media_get_composer (self);
#line 209 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp20_ = _tmp19_;
#line 209 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	noise_media_set_composer (rv, _tmp20_);
#line 210 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp21_ = noise_media_get_album_artist (self);
#line 210 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp22_ = _tmp21_;
#line 210 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	noise_media_set_album_artist (rv, _tmp22_);
#line 211 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp23_ = noise_media_get_album (self);
#line 211 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp24_ = _tmp23_;
#line 211 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	noise_media_set_album (rv, _tmp24_);
#line 212 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp25_ = noise_media_get_genre (self);
#line 212 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp26_ = _tmp25_;
#line 212 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	noise_media_set_genre (rv, _tmp26_);
#line 213 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp27_ = noise_media_get_grouping (self);
#line 213 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp28_ = _tmp27_;
#line 213 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	noise_media_set_grouping (rv, _tmp28_);
#line 214 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp29_ = noise_media_get_comment (self);
#line 214 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp30_ = _tmp29_;
#line 214 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	noise_media_set_comment (rv, _tmp30_);
#line 215 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp31_ = noise_media_get_year (self);
#line 215 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp32_ = _tmp31_;
#line 215 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	noise_media_set_year (rv, _tmp32_);
#line 216 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp33_ = noise_media_get_bitrate (self);
#line 216 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp34_ = _tmp33_;
#line 216 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	noise_media_set_bitrate (rv, _tmp34_);
#line 217 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp35_ = noise_media_get_length (self);
#line 217 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp36_ = _tmp35_;
#line 217 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	noise_media_set_length (rv, _tmp36_);
#line 218 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp37_ = noise_media_get_samplerate (self);
#line 218 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp38_ = _tmp37_;
#line 218 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	noise_media_set_samplerate (rv, _tmp38_);
#line 219 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp39_ = noise_media_get_bpm (self);
#line 219 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp40_ = _tmp39_;
#line 219 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	noise_media_set_bpm (rv, _tmp40_);
#line 220 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp41_ = noise_media_get_rating (self);
#line 220 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp42_ = _tmp41_;
#line 220 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	noise_media_set_rating (rv, _tmp42_);
#line 221 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp43_ = noise_media_get_play_count (self);
#line 221 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp44_ = _tmp43_;
#line 221 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	noise_media_set_play_count (rv, _tmp44_);
#line 222 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp45_ = noise_media_get_skip_count (self);
#line 222 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp46_ = _tmp45_;
#line 222 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	noise_media_set_skip_count (rv, _tmp46_);
#line 223 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp47_ = noise_media_get_date_added (self);
#line 223 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp48_ = _tmp47_;
#line 223 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	noise_media_set_date_added (rv, _tmp48_);
#line 224 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp49_ = noise_media_get_last_played (self);
#line 224 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp50_ = _tmp49_;
#line 224 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	noise_media_set_last_played (rv, _tmp50_);
#line 225 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp51_ = noise_media_get_lyrics (self);
#line 225 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp52_ = _tmp51_;
#line 225 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	noise_media_set_lyrics (rv, _tmp52_);
#line 226 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp53_ = noise_media_get_isPreview (self);
#line 226 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp54_ = _tmp53_;
#line 226 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	noise_media_set_isPreview (rv, _tmp54_);
#line 227 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp55_ = noise_media_get_isTemporary (self);
#line 227 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp56_ = _tmp55_;
#line 227 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	noise_media_set_isTemporary (rv, _tmp56_);
#line 228 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp57_ = noise_media_get_last_modified (self);
#line 228 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp58_ = _tmp57_;
#line 228 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	noise_media_set_last_modified (rv, _tmp58_);
#line 229 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp59_ = noise_media_get_showIndicator (self);
#line 229 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp60_ = _tmp59_;
#line 229 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	noise_media_set_showIndicator (rv, _tmp60_);
#line 230 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp61_ = noise_media_get_unique_status_image (self);
#line 230 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp62_ = _tmp61_;
#line 230 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	noise_media_set_unique_status_image (rv, _tmp62_);
#line 231 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp63_ = noise_media_get_location_unknown (self);
#line 231 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp64_ = _tmp63_;
#line 231 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	noise_media_set_location_unknown (rv, _tmp64_);
#line 233 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = rv;
#line 233 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 1699 "Media.c"
}


gint noise_media_get_rowid (NoiseMedia* self) {
	gint result;
	gint _tmp0_ = 0;
#line 36 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 36 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = self->priv->_rowid;
#line 36 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp0_;
#line 36 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 1714 "Media.c"
}


void noise_media_set_rowid (NoiseMedia* self, gint value) {
	gint _tmp0_ = 0;
#line 36 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_if_fail (self != NULL);
#line 36 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = value;
#line 36 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_rowid = _tmp0_;
#line 36 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_notify ((GObject *) self, "rowid");
#line 1728 "Media.c"
}


gchar* noise_media_get_uri (NoiseMedia* self) {
#line 39 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_uri (self);
#line 1737 "Media.c"
}


static gchar* noise_media_real_get_uri (NoiseMedia* base) {
	gchar* result;
	NoiseMedia* self;
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
#line 39 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 39 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = noise_media_get_file (self);
#line 39 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp1_ = _tmp0_;
#line 39 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp2_ = g_file_get_uri (_tmp1_);
#line 39 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp2_;
#line 39 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 1759 "Media.c"
}


void noise_media_set_uri (NoiseMedia* self, const gchar* value) {
#line 40 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_if_fail (self != NULL);
#line 40 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_uri (self, value);
#line 1768 "Media.c"
}


static void noise_media_real_set_uri (NoiseMedia* base, const gchar* value) {
	NoiseMedia* self;
	const gchar* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
#line 40 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 40 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = value;
#line 40 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp1_ = g_file_new_for_uri (_tmp0_);
#line 40 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp2_ = _tmp1_;
#line 40 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	noise_media_set_file (self, _tmp2_);
#line 40 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_g_object_unref0 (_tmp2_);
#line 40 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_notify ((GObject *) self, "uri");
#line 1791 "Media.c"
}


guint64 noise_media_get_file_size (NoiseMedia* self) {
#line 43 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 43 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_file_size (self);
#line 1800 "Media.c"
}


static guint64 noise_media_real_get_file_size (NoiseMedia* base) {
	guint64 result;
	NoiseMedia* self;
	guint64 _tmp0_ = 0ULL;
#line 43 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 43 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = self->priv->_file_size;
#line 43 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp0_;
#line 43 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 1816 "Media.c"
}


void noise_media_set_file_size (NoiseMedia* self, guint64 value) {
#line 43 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_if_fail (self != NULL);
#line 43 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_file_size (self, value);
#line 1825 "Media.c"
}


static void noise_media_real_set_file_size (NoiseMedia* base, guint64 value) {
	NoiseMedia* self;
	guint64 _tmp0_ = 0ULL;
#line 43 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 43 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = value;
#line 43 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_file_size = _tmp0_;
#line 43 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_notify ((GObject *) self, "file-size");
#line 1840 "Media.c"
}


gboolean noise_media_get_file_exists (NoiseMedia* self) {
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_file_exists (self);
#line 1849 "Media.c"
}


static gboolean noise_media_real_get_file_exists (NoiseMedia* base) {
	gboolean result;
	NoiseMedia* self;
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = noise_media_get_file (self);
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp1_ = _tmp0_;
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp2_ = g_file_query_exists (_tmp1_, NULL);
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp2_;
#line 44 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 1871 "Media.c"
}


GFile* noise_media_get_file (NoiseMedia* self) {
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_file (self);
#line 1880 "Media.c"
}


static GFile* noise_media_real_get_file (NoiseMedia* base) {
	GFile* result;
	NoiseMedia* self;
	GFile* _tmp0_ = NULL;
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = self->priv->_file;
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp0_;
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 1896 "Media.c"
}


void noise_media_set_file (NoiseMedia* self, GFile* value) {
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_if_fail (self != NULL);
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_file (self, value);
#line 1905 "Media.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return self ? g_object_ref (self) : NULL;
#line 1912 "Media.c"
}


static void noise_media_real_set_file (NoiseMedia* base, GFile* value) {
	NoiseMedia* self;
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = value;
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_g_object_unref0 (self->priv->_file);
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_file = _tmp1_;
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_notify ((GObject *) self, "file");
#line 1932 "Media.c"
}


gboolean noise_media_get_isPreview (NoiseMedia* self) {
#line 48 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 48 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_isPreview (self);
#line 1941 "Media.c"
}


static gboolean noise_media_real_get_isPreview (NoiseMedia* base) {
	gboolean result;
	NoiseMedia* self;
	gboolean _tmp0_ = FALSE;
#line 48 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 48 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = self->priv->_isPreview;
#line 48 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp0_;
#line 48 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 1957 "Media.c"
}


void noise_media_set_isPreview (NoiseMedia* self, gboolean value) {
#line 48 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_if_fail (self != NULL);
#line 48 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_isPreview (self, value);
#line 1966 "Media.c"
}


static void noise_media_real_set_isPreview (NoiseMedia* base, gboolean value) {
	NoiseMedia* self;
	gboolean _tmp0_ = FALSE;
#line 48 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 48 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = value;
#line 48 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_isPreview = _tmp0_;
#line 48 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_notify ((GObject *) self, "isPreview");
#line 1981 "Media.c"
}


gboolean noise_media_get_isTemporary (NoiseMedia* self) {
#line 49 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 49 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_isTemporary (self);
#line 1990 "Media.c"
}


static gboolean noise_media_real_get_isTemporary (NoiseMedia* base) {
	gboolean result;
	NoiseMedia* self;
	gboolean _tmp0_ = FALSE;
#line 49 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 49 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = self->priv->_isTemporary;
#line 49 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp0_;
#line 49 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 2006 "Media.c"
}


void noise_media_set_isTemporary (NoiseMedia* self, gboolean value) {
#line 49 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_if_fail (self != NULL);
#line 49 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_isTemporary (self, value);
#line 2015 "Media.c"
}


static void noise_media_real_set_isTemporary (NoiseMedia* base, gboolean value) {
	NoiseMedia* self;
	gboolean _tmp0_ = FALSE;
#line 49 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 49 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = value;
#line 49 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_isTemporary = _tmp0_;
#line 49 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_notify ((GObject *) self, "isTemporary");
#line 2030 "Media.c"
}


gboolean noise_media_get_location_unknown (NoiseMedia* self) {
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_location_unknown (self);
#line 2039 "Media.c"
}


static gboolean noise_media_real_get_location_unknown (NoiseMedia* base) {
	gboolean result;
	NoiseMedia* self;
	gboolean _tmp0_ = FALSE;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = self->priv->_location_unknown;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp0_;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 2055 "Media.c"
}


void noise_media_set_location_unknown (NoiseMedia* self, gboolean value) {
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_if_fail (self != NULL);
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_location_unknown (self, value);
#line 2064 "Media.c"
}


static void noise_media_real_set_location_unknown (NoiseMedia* base, gboolean value) {
	NoiseMedia* self;
	gboolean _tmp0_ = FALSE;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = value;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_location_unknown = _tmp0_;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_notify ((GObject *) self, "location-unknown");
#line 2079 "Media.c"
}


gboolean noise_media_get_has_embedded (NoiseMedia* self) {
#line 53 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 53 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_has_embedded (self);
#line 2088 "Media.c"
}


static gboolean noise_media_real_get_has_embedded (NoiseMedia* base) {
	gboolean result;
	NoiseMedia* self;
	gboolean _tmp0_ = FALSE;
#line 53 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 53 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = self->priv->_has_embedded;
#line 53 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp0_;
#line 53 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 2104 "Media.c"
}


void noise_media_set_has_embedded (NoiseMedia* self, gboolean value) {
#line 53 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_if_fail (self != NULL);
#line 53 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_has_embedded (self, value);
#line 2113 "Media.c"
}


static void noise_media_real_set_has_embedded (NoiseMedia* base, gboolean value) {
	NoiseMedia* self;
	gboolean _tmp0_ = FALSE;
#line 53 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 53 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = value;
#line 53 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_has_embedded = _tmp0_;
#line 53 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_notify ((GObject *) self, "has-embedded");
#line 2128 "Media.c"
}


GIcon* noise_media_get_unique_status_image (NoiseMedia* self) {
#line 57 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 57 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_unique_status_image (self);
#line 2137 "Media.c"
}


static GIcon* noise_media_real_get_unique_status_image (NoiseMedia* base) {
	GIcon* result;
	NoiseMedia* self;
	GIcon* _tmp0_ = NULL;
#line 57 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 57 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = self->priv->_unique_status_image;
#line 57 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp0_;
#line 57 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 2153 "Media.c"
}


void noise_media_set_unique_status_image (NoiseMedia* self, GIcon* value) {
#line 57 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_if_fail (self != NULL);
#line 57 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_unique_status_image (self, value);
#line 2162 "Media.c"
}


static void noise_media_real_set_unique_status_image (NoiseMedia* base, GIcon* value) {
	NoiseMedia* self;
	GIcon* _tmp0_ = NULL;
	GIcon* _tmp1_ = NULL;
#line 57 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 57 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = value;
#line 57 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 57 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_g_object_unref0 (self->priv->_unique_status_image);
#line 57 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_unique_status_image = _tmp1_;
#line 57 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_notify ((GObject *) self, "unique-status-image");
#line 2182 "Media.c"
}


gboolean noise_media_get_showIndicator (NoiseMedia* self) {
#line 58 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 58 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_showIndicator (self);
#line 2191 "Media.c"
}


static gboolean noise_media_real_get_showIndicator (NoiseMedia* base) {
	gboolean result;
	NoiseMedia* self;
	gboolean _tmp0_ = FALSE;
#line 58 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 58 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = self->priv->_showIndicator;
#line 58 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp0_;
#line 58 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 2207 "Media.c"
}


void noise_media_set_showIndicator (NoiseMedia* self, gboolean value) {
#line 58 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_if_fail (self != NULL);
#line 58 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_showIndicator (self, value);
#line 2216 "Media.c"
}


static void noise_media_real_set_showIndicator (NoiseMedia* base, gboolean value) {
	NoiseMedia* self;
	gboolean _tmp0_ = FALSE;
#line 58 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 58 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = value;
#line 58 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_showIndicator = _tmp0_;
#line 58 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_notify ((GObject *) self, "showIndicator");
#line 2231 "Media.c"
}


const gchar* noise_media_get_title (NoiseMedia* self) {
#line 63 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 63 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_title (self);
#line 2240 "Media.c"
}


static const gchar* noise_media_real_get_title (NoiseMedia* base) {
	const gchar* result;
	NoiseMedia* self;
	const gchar* _tmp0_ = NULL;
#line 63 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 63 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = self->priv->_title;
#line 63 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp0_;
#line 63 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 2256 "Media.c"
}


void noise_media_set_title (NoiseMedia* self, const gchar* value) {
#line 63 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_if_fail (self != NULL);
#line 63 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_title (self, value);
#line 2265 "Media.c"
}


static void noise_media_real_set_title (NoiseMedia* base, const gchar* value) {
	NoiseMedia* self;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 63 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 63 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = value;
#line 63 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 63 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_g_free0 (self->priv->_title);
#line 63 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_title = _tmp1_;
#line 63 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_notify ((GObject *) self, "title");
#line 2285 "Media.c"
}


guint noise_media_get_track (NoiseMedia* self) {
#line 64 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 64 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_track (self);
#line 2294 "Media.c"
}


static guint noise_media_real_get_track (NoiseMedia* base) {
	guint result;
	NoiseMedia* self;
	guint _tmp0_ = 0U;
#line 64 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 64 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = self->priv->_track;
#line 64 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp0_;
#line 64 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 2310 "Media.c"
}


void noise_media_set_track (NoiseMedia* self, guint value) {
#line 64 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_if_fail (self != NULL);
#line 64 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_track (self, value);
#line 2319 "Media.c"
}


static void noise_media_real_set_track (NoiseMedia* base, guint value) {
	NoiseMedia* self;
	guint _tmp0_ = 0U;
#line 64 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 64 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = value;
#line 64 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_track = _tmp0_;
#line 64 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_notify ((GObject *) self, "track");
#line 2334 "Media.c"
}


guint noise_media_get_track_count (NoiseMedia* self) {
#line 65 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 65 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_track_count (self);
#line 2343 "Media.c"
}


static guint noise_media_real_get_track_count (NoiseMedia* base) {
	guint result;
	NoiseMedia* self;
	guint _tmp0_ = 0U;
#line 65 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 65 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = self->priv->_track_count;
#line 65 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp0_;
#line 65 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 2359 "Media.c"
}


void noise_media_set_track_count (NoiseMedia* self, guint value) {
#line 65 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_if_fail (self != NULL);
#line 65 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_track_count (self, value);
#line 2368 "Media.c"
}


static void noise_media_real_set_track_count (NoiseMedia* base, guint value) {
	NoiseMedia* self;
	guint _tmp0_ = 0U;
#line 65 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 65 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = value;
#line 65 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_track_count = _tmp0_;
#line 65 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_notify ((GObject *) self, "track-count");
#line 2383 "Media.c"
}


const gchar* noise_media_get_composer (NoiseMedia* self) {
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_composer (self);
#line 2392 "Media.c"
}


static const gchar* noise_media_real_get_composer (NoiseMedia* base) {
	const gchar* result;
	NoiseMedia* self;
	const gchar* _tmp0_ = NULL;
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = self->priv->_composer;
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp0_;
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 2408 "Media.c"
}


void noise_media_set_composer (NoiseMedia* self, const gchar* value) {
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_if_fail (self != NULL);
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_composer (self, value);
#line 2417 "Media.c"
}


static void noise_media_real_set_composer (NoiseMedia* base, const gchar* value) {
	NoiseMedia* self;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = value;
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_g_free0 (self->priv->_composer);
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_composer = _tmp1_;
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_notify ((GObject *) self, "composer");
#line 2437 "Media.c"
}


const gchar* noise_media_get_artist (NoiseMedia* self) {
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_artist (self);
#line 2446 "Media.c"
}


static const gchar* noise_media_real_get_artist (NoiseMedia* base) {
	const gchar* result;
	NoiseMedia* self;
	const gchar* _tmp0_ = NULL;
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = self->priv->_artist;
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp0_;
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 2462 "Media.c"
}


void noise_media_set_artist (NoiseMedia* self, const gchar* value) {
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_if_fail (self != NULL);
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_artist (self, value);
#line 2471 "Media.c"
}


static void noise_media_real_set_artist (NoiseMedia* base, const gchar* value) {
	NoiseMedia* self;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = value;
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_g_free0 (self->priv->_artist);
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_artist = _tmp1_;
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_notify ((GObject *) self, "artist");
#line 2491 "Media.c"
}


const gchar* noise_media_get_album_artist (NoiseMedia* self) {
#line 68 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 68 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_album_artist (self);
#line 2500 "Media.c"
}


static const gchar* noise_media_real_get_album_artist (NoiseMedia* base) {
	const gchar* result;
	NoiseMedia* self;
	const gchar* _tmp0_ = NULL;
#line 68 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 68 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = self->priv->_album_artist;
#line 68 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp0_;
#line 68 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 2516 "Media.c"
}


void noise_media_set_album_artist (NoiseMedia* self, const gchar* value) {
#line 68 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_if_fail (self != NULL);
#line 68 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_album_artist (self, value);
#line 2525 "Media.c"
}


static void noise_media_real_set_album_artist (NoiseMedia* base, const gchar* value) {
	NoiseMedia* self;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 68 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 68 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = value;
#line 68 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 68 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_g_free0 (self->priv->_album_artist);
#line 68 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_album_artist = _tmp1_;
#line 68 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_notify ((GObject *) self, "album-artist");
#line 2545 "Media.c"
}


const gchar* noise_media_get_album (NoiseMedia* self) {
#line 69 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 69 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_album (self);
#line 2554 "Media.c"
}


static const gchar* noise_media_real_get_album (NoiseMedia* base) {
	const gchar* result;
	NoiseMedia* self;
	const gchar* _tmp0_ = NULL;
#line 69 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 69 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = self->priv->_album;
#line 69 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp0_;
#line 69 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 2570 "Media.c"
}


void noise_media_set_album (NoiseMedia* self, const gchar* value) {
#line 69 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_if_fail (self != NULL);
#line 69 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_album (self, value);
#line 2579 "Media.c"
}


static void noise_media_real_set_album (NoiseMedia* base, const gchar* value) {
	NoiseMedia* self;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 69 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 69 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = value;
#line 69 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 69 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_g_free0 (self->priv->_album);
#line 69 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_album = _tmp1_;
#line 69 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_notify ((GObject *) self, "album");
#line 2599 "Media.c"
}


guint noise_media_get_album_number (NoiseMedia* self) {
#line 70 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 70 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_album_number (self);
#line 2608 "Media.c"
}


static guint noise_media_real_get_album_number (NoiseMedia* base) {
	guint result;
	NoiseMedia* self;
	guint _tmp0_ = 0U;
#line 70 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 70 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = self->priv->_album_number;
#line 70 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp0_;
#line 70 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 2624 "Media.c"
}


void noise_media_set_album_number (NoiseMedia* self, guint value) {
#line 70 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_if_fail (self != NULL);
#line 70 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_album_number (self, value);
#line 2633 "Media.c"
}


static void noise_media_real_set_album_number (NoiseMedia* base, guint value) {
	NoiseMedia* self;
	guint _tmp0_ = 0U;
#line 70 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 70 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = value;
#line 70 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_album_number = _tmp0_;
#line 70 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_notify ((GObject *) self, "album-number");
#line 2648 "Media.c"
}


guint noise_media_get_album_count (NoiseMedia* self) {
#line 71 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 71 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_album_count (self);
#line 2657 "Media.c"
}


static guint noise_media_real_get_album_count (NoiseMedia* base) {
	guint result;
	NoiseMedia* self;
	guint _tmp0_ = 0U;
#line 71 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 71 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = self->priv->_album_count;
#line 71 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp0_;
#line 71 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 2673 "Media.c"
}


void noise_media_set_album_count (NoiseMedia* self, guint value) {
#line 71 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_if_fail (self != NULL);
#line 71 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_album_count (self, value);
#line 2682 "Media.c"
}


static void noise_media_real_set_album_count (NoiseMedia* base, guint value) {
	NoiseMedia* self;
	guint _tmp0_ = 0U;
#line 71 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 71 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = value;
#line 71 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_album_count = _tmp0_;
#line 71 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_notify ((GObject *) self, "album-count");
#line 2697 "Media.c"
}


NoiseAlbum* noise_media_get_album_info (NoiseMedia* self) {
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_album_info (self);
#line 2706 "Media.c"
}


static NoiseAlbum* noise_media_real_get_album_info (NoiseMedia* base) {
	NoiseAlbum* result;
	NoiseMedia* self;
	NoiseAlbum* _tmp0_ = NULL;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = self->priv->_album_info;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp0_;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 2722 "Media.c"
}


void noise_media_set_album_info (NoiseMedia* self, NoiseAlbum* value) {
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_if_fail (self != NULL);
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_album_info (self, value);
#line 2731 "Media.c"
}


static void noise_media_real_set_album_info (NoiseMedia* base, NoiseAlbum* value) {
	NoiseMedia* self;
	NoiseAlbum* _tmp0_ = NULL;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = value;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_album_info = _tmp0_;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_notify ((GObject *) self, "album-info");
#line 2746 "Media.c"
}


const gchar* noise_media_get_grouping (NoiseMedia* self) {
#line 73 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 73 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_grouping (self);
#line 2755 "Media.c"
}


static const gchar* noise_media_real_get_grouping (NoiseMedia* base) {
	const gchar* result;
	NoiseMedia* self;
	const gchar* _tmp0_ = NULL;
#line 73 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 73 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = self->priv->_grouping;
#line 73 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp0_;
#line 73 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 2771 "Media.c"
}


void noise_media_set_grouping (NoiseMedia* self, const gchar* value) {
#line 73 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_if_fail (self != NULL);
#line 73 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_grouping (self, value);
#line 2780 "Media.c"
}


static void noise_media_real_set_grouping (NoiseMedia* base, const gchar* value) {
	NoiseMedia* self;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 73 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 73 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = value;
#line 73 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 73 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_g_free0 (self->priv->_grouping);
#line 73 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_grouping = _tmp1_;
#line 73 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_notify ((GObject *) self, "grouping");
#line 2800 "Media.c"
}


const gchar* noise_media_get_genre (NoiseMedia* self) {
#line 74 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 74 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_genre (self);
#line 2809 "Media.c"
}


static const gchar* noise_media_real_get_genre (NoiseMedia* base) {
	const gchar* result;
	NoiseMedia* self;
	const gchar* _tmp0_ = NULL;
#line 74 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 74 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = self->priv->_genre;
#line 74 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp0_;
#line 74 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 2825 "Media.c"
}


void noise_media_set_genre (NoiseMedia* self, const gchar* value) {
#line 74 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_if_fail (self != NULL);
#line 74 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_genre (self, value);
#line 2834 "Media.c"
}


static void noise_media_real_set_genre (NoiseMedia* base, const gchar* value) {
	NoiseMedia* self;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 74 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 74 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = value;
#line 74 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 74 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_g_free0 (self->priv->_genre);
#line 74 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_genre = _tmp1_;
#line 74 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_notify ((GObject *) self, "genre");
#line 2854 "Media.c"
}


const gchar* noise_media_get_comment (NoiseMedia* self) {
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_comment (self);
#line 2863 "Media.c"
}


static const gchar* noise_media_real_get_comment (NoiseMedia* base) {
	const gchar* result;
	NoiseMedia* self;
	const gchar* _tmp0_ = NULL;
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = self->priv->_comment;
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp0_;
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 2879 "Media.c"
}


void noise_media_set_comment (NoiseMedia* self, const gchar* value) {
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_if_fail (self != NULL);
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_comment (self, value);
#line 2888 "Media.c"
}


static void noise_media_real_set_comment (NoiseMedia* base, const gchar* value) {
	NoiseMedia* self;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = value;
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_g_free0 (self->priv->_comment);
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_comment = _tmp1_;
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_notify ((GObject *) self, "comment");
#line 2908 "Media.c"
}


const gchar* noise_media_get_lyrics (NoiseMedia* self) {
#line 76 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 76 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_lyrics (self);
#line 2917 "Media.c"
}


static const gchar* noise_media_real_get_lyrics (NoiseMedia* base) {
	const gchar* result;
	NoiseMedia* self;
	const gchar* _tmp0_ = NULL;
#line 76 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 76 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = self->priv->_lyrics;
#line 76 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp0_;
#line 76 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 2933 "Media.c"
}


void noise_media_set_lyrics (NoiseMedia* self, const gchar* value) {
#line 76 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_if_fail (self != NULL);
#line 76 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_lyrics (self, value);
#line 2942 "Media.c"
}


static void noise_media_real_set_lyrics (NoiseMedia* base, const gchar* value) {
	NoiseMedia* self;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 76 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 76 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = value;
#line 76 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 76 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_g_free0 (self->priv->_lyrics);
#line 76 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_lyrics = _tmp1_;
#line 76 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_notify ((GObject *) self, "lyrics");
#line 2962 "Media.c"
}


guint noise_media_get_year (NoiseMedia* self) {
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_year (self);
#line 2971 "Media.c"
}


static guint noise_media_real_get_year (NoiseMedia* base) {
	guint result;
	NoiseMedia* self;
	guint _tmp0_ = 0U;
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = self->priv->_year;
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp0_;
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 2987 "Media.c"
}


void noise_media_set_year (NoiseMedia* self, guint value) {
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_if_fail (self != NULL);
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_year (self, value);
#line 2996 "Media.c"
}


static void noise_media_real_set_year (NoiseMedia* base, guint value) {
	NoiseMedia* self;
	guint _tmp0_ = 0U;
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = value;
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_year = _tmp0_;
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_notify ((GObject *) self, "year");
#line 3011 "Media.c"
}


guint noise_media_get_bitrate (NoiseMedia* self) {
#line 78 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 78 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_bitrate (self);
#line 3020 "Media.c"
}


static guint noise_media_real_get_bitrate (NoiseMedia* base) {
	guint result;
	NoiseMedia* self;
	guint _tmp0_ = 0U;
#line 78 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 78 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = self->priv->_bitrate;
#line 78 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp0_;
#line 78 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 3036 "Media.c"
}


void noise_media_set_bitrate (NoiseMedia* self, guint value) {
#line 78 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_if_fail (self != NULL);
#line 78 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_bitrate (self, value);
#line 3045 "Media.c"
}


static void noise_media_real_set_bitrate (NoiseMedia* base, guint value) {
	NoiseMedia* self;
	guint _tmp0_ = 0U;
#line 78 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 78 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = value;
#line 78 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_bitrate = _tmp0_;
#line 78 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_notify ((GObject *) self, "bitrate");
#line 3060 "Media.c"
}


guint noise_media_get_bpm (NoiseMedia* self) {
#line 79 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 79 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_bpm (self);
#line 3069 "Media.c"
}


static guint noise_media_real_get_bpm (NoiseMedia* base) {
	guint result;
	NoiseMedia* self;
	guint _tmp0_ = 0U;
#line 79 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 79 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = self->priv->_bpm;
#line 79 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp0_;
#line 79 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 3085 "Media.c"
}


void noise_media_set_bpm (NoiseMedia* self, guint value) {
#line 79 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_if_fail (self != NULL);
#line 79 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_bpm (self, value);
#line 3094 "Media.c"
}


static void noise_media_real_set_bpm (NoiseMedia* base, guint value) {
	NoiseMedia* self;
	guint _tmp0_ = 0U;
#line 79 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 79 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = value;
#line 79 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_bpm = _tmp0_;
#line 79 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_notify ((GObject *) self, "bpm");
#line 3109 "Media.c"
}


guint noise_media_get_samplerate (NoiseMedia* self) {
#line 80 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 80 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_samplerate (self);
#line 3118 "Media.c"
}


static guint noise_media_real_get_samplerate (NoiseMedia* base) {
	guint result;
	NoiseMedia* self;
	guint _tmp0_ = 0U;
#line 80 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 80 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = self->priv->_samplerate;
#line 80 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp0_;
#line 80 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 3134 "Media.c"
}


void noise_media_set_samplerate (NoiseMedia* self, guint value) {
#line 80 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_if_fail (self != NULL);
#line 80 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_samplerate (self, value);
#line 3143 "Media.c"
}


static void noise_media_real_set_samplerate (NoiseMedia* base, guint value) {
	NoiseMedia* self;
	guint _tmp0_ = 0U;
#line 80 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 80 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = value;
#line 80 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_samplerate = _tmp0_;
#line 80 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_notify ((GObject *) self, "samplerate");
#line 3158 "Media.c"
}


guint noise_media_get_length (NoiseMedia* self) {
#line 82 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 82 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_length (self);
#line 3167 "Media.c"
}


static guint noise_media_real_get_length (NoiseMedia* base) {
	guint result;
	NoiseMedia* self;
	guint _tmp0_ = 0U;
#line 82 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 82 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = self->priv->_length;
#line 82 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp0_;
#line 82 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 3183 "Media.c"
}


void noise_media_set_length (NoiseMedia* self, guint value) {
#line 82 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_if_fail (self != NULL);
#line 82 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_length (self, value);
#line 3192 "Media.c"
}


static void noise_media_real_set_length (NoiseMedia* base, guint value) {
	NoiseMedia* self;
	guint _tmp0_ = 0U;
#line 82 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 82 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = value;
#line 82 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_length = _tmp0_;
#line 82 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_notify ((GObject *) self, "length");
#line 3207 "Media.c"
}


guint noise_media_get_rating (NoiseMedia* self) {
#line 86 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 86 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_rating (self);
#line 3216 "Media.c"
}


static guint noise_media_real_get_rating (NoiseMedia* base) {
	guint result;
	NoiseMedia* self;
	guint _tmp0_ = 0U;
#line 86 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 86 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = self->_rating;
#line 86 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp0_;
#line 86 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 3232 "Media.c"
}


void noise_media_set_rating (NoiseMedia* self, guint value) {
#line 87 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_if_fail (self != NULL);
#line 87 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_rating (self, value);
#line 3241 "Media.c"
}


static void noise_media_real_set_rating (NoiseMedia* base, guint value) {
	NoiseMedia* self;
	guint _tmp0_ = 0U;
	guint _tmp1_ = 0U;
#line 87 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 87 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = value;
#line 87 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp1_ = CLAMP (_tmp0_, (guint) 0, (guint) 5);
#line 87 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->_rating = _tmp1_;
#line 87 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_notify ((GObject *) self, "rating");
#line 3259 "Media.c"
}


guint noise_media_get_play_count (NoiseMedia* self) {
#line 93 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 93 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_play_count (self);
#line 3268 "Media.c"
}


static guint noise_media_real_get_play_count (NoiseMedia* base) {
	guint result;
	NoiseMedia* self;
	guint _tmp0_ = 0U;
#line 93 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 93 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = self->priv->_play_count;
#line 93 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp0_;
#line 93 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 3284 "Media.c"
}


void noise_media_set_play_count (NoiseMedia* self, guint value) {
#line 93 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_if_fail (self != NULL);
#line 93 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_play_count (self, value);
#line 3293 "Media.c"
}


static void noise_media_real_set_play_count (NoiseMedia* base, guint value) {
	NoiseMedia* self;
	guint _tmp0_ = 0U;
#line 93 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 93 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = value;
#line 93 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_play_count = _tmp0_;
#line 93 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_notify ((GObject *) self, "play-count");
#line 3308 "Media.c"
}


guint noise_media_get_skip_count (NoiseMedia* self) {
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_skip_count (self);
#line 3317 "Media.c"
}


static guint noise_media_real_get_skip_count (NoiseMedia* base) {
	guint result;
	NoiseMedia* self;
	guint _tmp0_ = 0U;
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = self->priv->_skip_count;
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp0_;
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 3333 "Media.c"
}


void noise_media_set_skip_count (NoiseMedia* self, guint value) {
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_if_fail (self != NULL);
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_skip_count (self, value);
#line 3342 "Media.c"
}


static void noise_media_real_set_skip_count (NoiseMedia* base, guint value) {
	NoiseMedia* self;
	guint _tmp0_ = 0U;
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = value;
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_skip_count = _tmp0_;
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_notify ((GObject *) self, "skip-count");
#line 3357 "Media.c"
}


guint noise_media_get_date_added (NoiseMedia* self) {
#line 95 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 95 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_date_added (self);
#line 3366 "Media.c"
}


static guint noise_media_real_get_date_added (NoiseMedia* base) {
	guint result;
	NoiseMedia* self;
	guint _tmp0_ = 0U;
#line 95 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 95 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = self->priv->_date_added;
#line 95 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp0_;
#line 95 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 3382 "Media.c"
}


void noise_media_set_date_added (NoiseMedia* self, guint value) {
#line 95 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_if_fail (self != NULL);
#line 95 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_date_added (self, value);
#line 3391 "Media.c"
}


static void noise_media_real_set_date_added (NoiseMedia* base, guint value) {
	NoiseMedia* self;
	guint _tmp0_ = 0U;
#line 95 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 95 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = value;
#line 95 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_date_added = _tmp0_;
#line 95 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_notify ((GObject *) self, "date-added");
#line 3406 "Media.c"
}


guint noise_media_get_last_played (NoiseMedia* self) {
#line 96 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 96 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_last_played (self);
#line 3415 "Media.c"
}


static guint noise_media_real_get_last_played (NoiseMedia* base) {
	guint result;
	NoiseMedia* self;
	guint _tmp0_ = 0U;
#line 96 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 96 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = self->priv->_last_played;
#line 96 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp0_;
#line 96 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 3431 "Media.c"
}


void noise_media_set_last_played (NoiseMedia* self, guint value) {
#line 96 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_if_fail (self != NULL);
#line 96 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_last_played (self, value);
#line 3440 "Media.c"
}


static void noise_media_real_set_last_played (NoiseMedia* base, guint value) {
	NoiseMedia* self;
	guint _tmp0_ = 0U;
#line 96 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 96 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = value;
#line 96 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_last_played = _tmp0_;
#line 96 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_notify ((GObject *) self, "last-played");
#line 3455 "Media.c"
}


guint noise_media_get_last_modified (NoiseMedia* self) {
#line 97 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 97 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_last_modified (self);
#line 3464 "Media.c"
}


static guint noise_media_real_get_last_modified (NoiseMedia* base) {
	guint result;
	NoiseMedia* self;
	guint _tmp0_ = 0U;
#line 97 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 97 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = self->priv->_last_modified;
#line 97 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp0_;
#line 97 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 3480 "Media.c"
}


void noise_media_set_last_modified (NoiseMedia* self, guint value) {
#line 97 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_if_fail (self != NULL);
#line 97 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_last_modified (self, value);
#line 3489 "Media.c"
}


static void noise_media_real_set_last_modified (NoiseMedia* base, guint value) {
	NoiseMedia* self;
	guint _tmp0_ = 0U;
#line 97 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 97 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = value;
#line 97 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_last_modified = _tmp0_;
#line 97 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_notify ((GObject *) self, "last-modified");
#line 3504 "Media.c"
}


gint noise_media_get_resume_pos (NoiseMedia* self) {
#line 99 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 99 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_resume_pos (self);
#line 3513 "Media.c"
}


static gint noise_media_real_get_resume_pos (NoiseMedia* base) {
	gint result;
	NoiseMedia* self;
	gint _tmp0_ = 0;
#line 99 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 99 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = self->priv->_resume_pos;
#line 99 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	result = _tmp0_;
#line 99 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	return result;
#line 3529 "Media.c"
}


void noise_media_set_resume_pos (NoiseMedia* self, gint value) {
#line 99 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_return_if_fail (self != NULL);
#line 99 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_resume_pos (self, value);
#line 3538 "Media.c"
}


static void noise_media_real_set_resume_pos (NoiseMedia* base, gint value) {
	NoiseMedia* self;
	gint _tmp0_ = 0;
#line 99 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = base;
#line 99 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = value;
#line 99 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_resume_pos = _tmp0_;
#line 99 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_notify ((GObject *) self, "resume-pos");
#line 3553 "Media.c"
}


static void noise_media_class_init (NoiseMediaClass * klass) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	noise_media_parent_class = g_type_class_peek_parent (klass);
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_type_class_add_private (klass, sizeof (NoiseMediaPrivate));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_uri = noise_media_real_get_uri;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_uri = noise_media_real_set_uri;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_file_size = noise_media_real_get_file_size;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_file_size = noise_media_real_set_file_size;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_file_exists = noise_media_real_get_file_exists;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_file = noise_media_real_get_file;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_file = noise_media_real_set_file;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_isPreview = noise_media_real_get_isPreview;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_isPreview = noise_media_real_set_isPreview;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_isTemporary = noise_media_real_get_isTemporary;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_isTemporary = noise_media_real_set_isTemporary;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_location_unknown = noise_media_real_get_location_unknown;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_location_unknown = noise_media_real_set_location_unknown;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_has_embedded = noise_media_real_get_has_embedded;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_has_embedded = noise_media_real_set_has_embedded;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_unique_status_image = noise_media_real_get_unique_status_image;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_unique_status_image = noise_media_real_set_unique_status_image;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_showIndicator = noise_media_real_get_showIndicator;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_showIndicator = noise_media_real_set_showIndicator;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_title = noise_media_real_get_title;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_title = noise_media_real_set_title;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_track = noise_media_real_get_track;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_track = noise_media_real_set_track;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_track_count = noise_media_real_get_track_count;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_track_count = noise_media_real_set_track_count;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_composer = noise_media_real_get_composer;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_composer = noise_media_real_set_composer;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_artist = noise_media_real_get_artist;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_artist = noise_media_real_set_artist;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_album_artist = noise_media_real_get_album_artist;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_album_artist = noise_media_real_set_album_artist;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_album = noise_media_real_get_album;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_album = noise_media_real_set_album;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_album_number = noise_media_real_get_album_number;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_album_number = noise_media_real_set_album_number;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_album_count = noise_media_real_get_album_count;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_album_count = noise_media_real_set_album_count;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_album_info = noise_media_real_get_album_info;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_album_info = noise_media_real_set_album_info;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_grouping = noise_media_real_get_grouping;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_grouping = noise_media_real_set_grouping;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_genre = noise_media_real_get_genre;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_genre = noise_media_real_set_genre;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_comment = noise_media_real_get_comment;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_comment = noise_media_real_set_comment;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_lyrics = noise_media_real_get_lyrics;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_lyrics = noise_media_real_set_lyrics;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_year = noise_media_real_get_year;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_year = noise_media_real_set_year;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_bitrate = noise_media_real_get_bitrate;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_bitrate = noise_media_real_set_bitrate;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_bpm = noise_media_real_get_bpm;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_bpm = noise_media_real_set_bpm;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_samplerate = noise_media_real_get_samplerate;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_samplerate = noise_media_real_set_samplerate;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_length = noise_media_real_get_length;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_length = noise_media_real_set_length;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_rating = noise_media_real_get_rating;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_rating = noise_media_real_set_rating;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_play_count = noise_media_real_get_play_count;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_play_count = noise_media_real_set_play_count;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_skip_count = noise_media_real_get_skip_count;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_skip_count = noise_media_real_set_skip_count;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_date_added = noise_media_real_get_date_added;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_date_added = noise_media_real_set_date_added;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_last_played = noise_media_real_get_last_played;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_last_played = noise_media_real_set_last_played;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_last_modified = noise_media_real_get_last_modified;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_last_modified = noise_media_real_set_last_modified;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_resume_pos = noise_media_real_get_resume_pos;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_resume_pos = noise_media_real_set_resume_pos;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_media_get_property;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_media_set_property;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_media_finalize;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_ROWID, g_param_spec_int ("rowid", "rowid", "rowid", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_URI, g_param_spec_string ("uri", "uri", "uri", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_FILE_SIZE, g_param_spec_uint64 ("file-size", "file-size", "file-size", 0, G_MAXUINT64, (guint64) 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_FILE_EXISTS, g_param_spec_boolean ("file-exists", "file-exists", "file-exists", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_FILE, g_param_spec_object ("file", "file", "file", G_TYPE_FILE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_IS_PREVIEW, g_param_spec_boolean ("isPreview", "isPreview", "isPreview", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_IS_TEMPORARY, g_param_spec_boolean ("isTemporary", "isTemporary", "isTemporary", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_LOCATION_UNKNOWN, g_param_spec_boolean ("location-unknown", "location-unknown", "location-unknown", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_HAS_EMBEDDED, g_param_spec_boolean ("has-embedded", "has-embedded", "has-embedded", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_UNIQUE_STATUS_IMAGE, g_param_spec_object ("unique-status-image", "unique-status-image", "unique-status-image", G_TYPE_ICON, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_SHOW_INDICATOR, g_param_spec_boolean ("showIndicator", "showIndicator", "showIndicator", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3734 "Media.c"
	/**
	     * Metadata Fields
	     */
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_TITLE, g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_TRACK, g_param_spec_uint ("track", "track", "track", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_TRACK_COUNT, g_param_spec_uint ("track-count", "track-count", "track-count", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_COMPOSER, g_param_spec_string ("composer", "composer", "composer", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_ARTIST, g_param_spec_string ("artist", "artist", "artist", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_ALBUM_ARTIST, g_param_spec_string ("album-artist", "album-artist", "album-artist", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_ALBUM, g_param_spec_string ("album", "album", "album", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_ALBUM_NUMBER, g_param_spec_uint ("album-number", "album-number", "album-number", 0, G_MAXUINT, (guint) 1, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_ALBUM_COUNT, g_param_spec_uint ("album-count", "album-count", "album-count", 0, G_MAXUINT, (guint) 1, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_ALBUM_INFO, g_param_spec_object ("album-info", "album-info", "album-info", NOISE_TYPE_ALBUM, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_GROUPING, g_param_spec_string ("grouping", "grouping", "grouping", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_GENRE, g_param_spec_string ("genre", "genre", "genre", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_COMMENT, g_param_spec_string ("comment", "comment", "comment", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_LYRICS, g_param_spec_string ("lyrics", "lyrics", "lyrics", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_YEAR, g_param_spec_uint ("year", "year", "year", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_BITRATE, g_param_spec_uint ("bitrate", "bitrate", "bitrate", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_BPM, g_param_spec_uint ("bpm", "bpm", "bpm", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_SAMPLERATE, g_param_spec_uint ("samplerate", "samplerate", "samplerate", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_LENGTH, g_param_spec_uint ("length", "length", "length", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_RATING, g_param_spec_uint ("rating", "rating", "rating", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3778 "Media.c"
	/**
	     * Internal stats
	     */
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_PLAY_COUNT, g_param_spec_uint ("play-count", "play-count", "play-count", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_SKIP_COUNT, g_param_spec_uint ("skip-count", "skip-count", "skip-count", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_DATE_ADDED, g_param_spec_uint ("date-added", "date-added", "date-added", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_LAST_PLAYED, g_param_spec_uint ("last-played", "last-played", "last-played", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_LAST_MODIFIED, g_param_spec_uint ("last-modified", "last-modified", "last-modified", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_RESUME_POS, g_param_spec_int ("resume-pos", "resume-pos", "resume-pos", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 34 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = _ ("Unknown");
#line 34 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 34 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	noise_media_UNKNOWN = _tmp1_;
#line 3800 "Media.c"
}


static void noise_media_instance_init (NoiseMedia * self) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv = NOISE_MEDIA_GET_PRIVATE (self);
#line 43 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_file_size = (guint64) 0;
#line 48 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_isPreview = FALSE;
#line 49 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_isTemporary = FALSE;
#line 52 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_location_unknown = FALSE;
#line 53 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_has_embedded = FALSE;
#line 58 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_showIndicator = FALSE;
#line 63 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp0_ = g_strdup ("");
#line 63 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_title = _tmp0_;
#line 64 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_track = (guint) 0;
#line 65 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_track_count = (guint) 0;
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp1_ = g_strdup ("");
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_composer = _tmp1_;
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp2_ = g_strdup ("");
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_artist = _tmp2_;
#line 68 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp3_ = g_strdup ("");
#line 68 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_album_artist = _tmp3_;
#line 69 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp4_ = g_strdup ("");
#line 69 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_album = _tmp4_;
#line 70 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_album_number = (guint) 1;
#line 71 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_album_count = (guint) 1;
#line 72 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_album_info = NULL;
#line 73 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp5_ = g_strdup ("");
#line 73 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_grouping = _tmp5_;
#line 74 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp6_ = g_strdup ("");
#line 74 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_genre = _tmp6_;
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp7_ = g_strdup ("");
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_comment = _tmp7_;
#line 76 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_tmp8_ = g_strdup ("");
#line 76 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_lyrics = _tmp8_;
#line 77 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_year = (guint) 0;
#line 78 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_bitrate = (guint) 0;
#line 79 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_bpm = (guint) 0;
#line 80 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_samplerate = (guint) 0;
#line 82 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_length = (guint) 0;
#line 93 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_play_count = (guint) 0;
#line 94 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_skip_count = (guint) 0;
#line 95 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_date_added = (guint) 0;
#line 96 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_last_played = (guint) 0;
#line 97 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_last_modified = (guint) 0;
#line 99 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self->priv->_resume_pos = 0;
#line 3896 "Media.c"
}


static void noise_media_finalize (GObject* obj) {
	NoiseMedia * self;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_MEDIA, NoiseMedia);
#line 46 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_g_object_unref0 (self->priv->_file);
#line 57 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_g_object_unref0 (self->priv->_unique_status_image);
#line 63 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_g_free0 (self->priv->_title);
#line 66 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_g_free0 (self->priv->_composer);
#line 67 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_g_free0 (self->priv->_artist);
#line 68 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_g_free0 (self->priv->_album_artist);
#line 69 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_g_free0 (self->priv->_album);
#line 73 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_g_free0 (self->priv->_grouping);
#line 74 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_g_free0 (self->priv->_genre);
#line 75 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_g_free0 (self->priv->_comment);
#line 76 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	_g_free0 (self->priv->_lyrics);
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	G_OBJECT_CLASS (noise_media_parent_class)->finalize (obj);
#line 3928 "Media.c"
}


GType noise_media_get_type (void) {
	static volatile gsize noise_media_type_id__volatile = 0;
	if (g_once_init_enter (&noise_media_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseMediaClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_media_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseMedia), 0, (GInstanceInitFunc) noise_media_instance_init, NULL };
		GType noise_media_type_id;
		noise_media_type_id = g_type_register_static (G_TYPE_OBJECT, "NoiseMedia", &g_define_type_info, 0);
		g_once_init_leave (&noise_media_type_id__volatile, noise_media_type_id);
	}
	return noise_media_type_id__volatile;
}


static void _vala_noise_media_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NoiseMedia * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_MEDIA, NoiseMedia);
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	switch (property_id) {
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_ROWID:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		g_value_set_int (value, noise_media_get_rowid (self));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_URI:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		g_value_take_string (value, noise_media_get_uri (self));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_FILE_SIZE:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		g_value_set_uint64 (value, noise_media_get_file_size (self));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_FILE_EXISTS:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		g_value_set_boolean (value, noise_media_get_file_exists (self));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_FILE:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		g_value_set_object (value, noise_media_get_file (self));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_IS_PREVIEW:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		g_value_set_boolean (value, noise_media_get_isPreview (self));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_IS_TEMPORARY:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		g_value_set_boolean (value, noise_media_get_isTemporary (self));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_LOCATION_UNKNOWN:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		g_value_set_boolean (value, noise_media_get_location_unknown (self));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_HAS_EMBEDDED:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		g_value_set_boolean (value, noise_media_get_has_embedded (self));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_UNIQUE_STATUS_IMAGE:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		g_value_set_object (value, noise_media_get_unique_status_image (self));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_SHOW_INDICATOR:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		g_value_set_boolean (value, noise_media_get_showIndicator (self));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_TITLE:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		g_value_set_string (value, noise_media_get_title (self));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_TRACK:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		g_value_set_uint (value, noise_media_get_track (self));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_TRACK_COUNT:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		g_value_set_uint (value, noise_media_get_track_count (self));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_COMPOSER:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		g_value_set_string (value, noise_media_get_composer (self));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_ARTIST:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		g_value_set_string (value, noise_media_get_artist (self));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_ALBUM_ARTIST:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		g_value_set_string (value, noise_media_get_album_artist (self));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_ALBUM:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		g_value_set_string (value, noise_media_get_album (self));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_ALBUM_NUMBER:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		g_value_set_uint (value, noise_media_get_album_number (self));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_ALBUM_COUNT:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		g_value_set_uint (value, noise_media_get_album_count (self));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_ALBUM_INFO:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		g_value_set_object (value, noise_media_get_album_info (self));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_GROUPING:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		g_value_set_string (value, noise_media_get_grouping (self));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_GENRE:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		g_value_set_string (value, noise_media_get_genre (self));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_COMMENT:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		g_value_set_string (value, noise_media_get_comment (self));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_LYRICS:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		g_value_set_string (value, noise_media_get_lyrics (self));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_YEAR:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		g_value_set_uint (value, noise_media_get_year (self));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_BITRATE:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		g_value_set_uint (value, noise_media_get_bitrate (self));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_BPM:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		g_value_set_uint (value, noise_media_get_bpm (self));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_SAMPLERATE:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		g_value_set_uint (value, noise_media_get_samplerate (self));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_LENGTH:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		g_value_set_uint (value, noise_media_get_length (self));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_RATING:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		g_value_set_uint (value, noise_media_get_rating (self));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_PLAY_COUNT:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		g_value_set_uint (value, noise_media_get_play_count (self));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_SKIP_COUNT:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		g_value_set_uint (value, noise_media_get_skip_count (self));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_DATE_ADDED:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		g_value_set_uint (value, noise_media_get_date_added (self));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_LAST_PLAYED:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		g_value_set_uint (value, noise_media_get_last_played (self));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_LAST_MODIFIED:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		g_value_set_uint (value, noise_media_get_last_modified (self));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_RESUME_POS:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		g_value_set_int (value, noise_media_get_resume_pos (self));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 4171 "Media.c"
		default:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 4177 "Media.c"
	}
}


static void _vala_noise_media_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	NoiseMedia * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_MEDIA, NoiseMedia);
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
	switch (property_id) {
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_ROWID:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		noise_media_set_rowid (self, g_value_get_int (value));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_URI:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		noise_media_set_uri (self, g_value_get_string (value));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_FILE_SIZE:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		noise_media_set_file_size (self, g_value_get_uint64 (value));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_FILE:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		noise_media_set_file (self, g_value_get_object (value));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_IS_PREVIEW:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		noise_media_set_isPreview (self, g_value_get_boolean (value));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_IS_TEMPORARY:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		noise_media_set_isTemporary (self, g_value_get_boolean (value));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_LOCATION_UNKNOWN:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		noise_media_set_location_unknown (self, g_value_get_boolean (value));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_HAS_EMBEDDED:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		noise_media_set_has_embedded (self, g_value_get_boolean (value));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_UNIQUE_STATUS_IMAGE:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		noise_media_set_unique_status_image (self, g_value_get_object (value));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_SHOW_INDICATOR:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		noise_media_set_showIndicator (self, g_value_get_boolean (value));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_TITLE:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		noise_media_set_title (self, g_value_get_string (value));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_TRACK:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		noise_media_set_track (self, g_value_get_uint (value));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_TRACK_COUNT:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		noise_media_set_track_count (self, g_value_get_uint (value));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_COMPOSER:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		noise_media_set_composer (self, g_value_get_string (value));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_ARTIST:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		noise_media_set_artist (self, g_value_get_string (value));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_ALBUM_ARTIST:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		noise_media_set_album_artist (self, g_value_get_string (value));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_ALBUM:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		noise_media_set_album (self, g_value_get_string (value));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_ALBUM_NUMBER:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		noise_media_set_album_number (self, g_value_get_uint (value));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_ALBUM_COUNT:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		noise_media_set_album_count (self, g_value_get_uint (value));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_ALBUM_INFO:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		noise_media_set_album_info (self, g_value_get_object (value));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_GROUPING:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		noise_media_set_grouping (self, g_value_get_string (value));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_GENRE:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		noise_media_set_genre (self, g_value_get_string (value));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_COMMENT:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		noise_media_set_comment (self, g_value_get_string (value));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_LYRICS:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		noise_media_set_lyrics (self, g_value_get_string (value));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_YEAR:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		noise_media_set_year (self, g_value_get_uint (value));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_BITRATE:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		noise_media_set_bitrate (self, g_value_get_uint (value));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_BPM:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		noise_media_set_bpm (self, g_value_get_uint (value));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_SAMPLERATE:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		noise_media_set_samplerate (self, g_value_get_uint (value));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_LENGTH:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		noise_media_set_length (self, g_value_get_uint (value));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_RATING:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		noise_media_set_rating (self, g_value_get_uint (value));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_PLAY_COUNT:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		noise_media_set_play_count (self, g_value_get_uint (value));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_SKIP_COUNT:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		noise_media_set_skip_count (self, g_value_get_uint (value));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_DATE_ADDED:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		noise_media_set_date_added (self, g_value_get_uint (value));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_LAST_PLAYED:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		noise_media_set_last_played (self, g_value_get_uint (value));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_LAST_MODIFIED:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		noise_media_set_last_modified (self, g_value_get_uint (value));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		case NOISE_MEDIA_RESUME_POS:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		noise_media_set_resume_pos (self, g_value_get_int (value));
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 4403 "Media.c"
		default:
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "/usr/src/RPM/BUILD/noise-0.3.1/core/Media.vala"
		break;
#line 4409 "Media.c"
	}
}



